/* ipcchannel.c generated by valac 0.29.1, the Vala compiler
 * generated from ipcchannel.vala, do not modify */

/*
 * Copyright 2014 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <unistd.h>
#include <gio/gio.h>
#include <gio/gunixsocketaddress.h>
#include <errno.h>
#include <gobject/gvaluecollector.h>


#define DIORITE_IPC_TYPE_CHANNEL (diorite_ipc_channel_get_type ())
#define DIORITE_IPC_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITE_IPC_TYPE_CHANNEL, DioriteIpcChannel))
#define DIORITE_IPC_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITE_IPC_TYPE_CHANNEL, DioriteIpcChannelClass))
#define DIORITE_IPC_IS_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITE_IPC_TYPE_CHANNEL))
#define DIORITE_IPC_IS_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITE_IPC_TYPE_CHANNEL))
#define DIORITE_IPC_CHANNEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITE_IPC_TYPE_CHANNEL, DioriteIpcChannelClass))

typedef struct _DioriteIpcChannel DioriteIpcChannel;
typedef struct _DioriteIpcChannelClass DioriteIpcChannelClass;
typedef struct _DioriteIpcChannelPrivate DioriteIpcChannelPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_byte_array_unref0(var) ((var == NULL) ? NULL : (var = (g_byte_array_unref (var), NULL)))
#define _diorite_ipc_channel_unref0(var) ((var == NULL) ? NULL : (var = (diorite_ipc_channel_unref (var), NULL)))
typedef struct _DioriteIpcChannelWriteBytesAsyncData DioriteIpcChannelWriteBytesAsyncData;
typedef struct _Block1Data Block1Data;
typedef struct _DioriteIpcChannelReadBytesAsyncData DioriteIpcChannelReadBytesAsyncData;
typedef struct _DioriteIpcParamSpecChannel DioriteIpcParamSpecChannel;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _DioriteIpcChannel {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DioriteIpcChannelPrivate * priv;
};

struct _DioriteIpcChannelClass {
	GTypeClass parent_class;
	void (*finalize) (DioriteIpcChannel *self);
};

struct _DioriteIpcChannelPrivate {
	gchar* name;
	gchar* path;
	gboolean _listening;
	gint local_socket;
	gint remote_socket;
};

typedef enum  {
	DIORITE_IO_ERROR_CONN_FAILED,
	DIORITE_IO_ERROR_TIMEOUT,
	DIORITE_IO_ERROR_RW_FAILED,
	DIORITE_IO_ERROR_READ,
	DIORITE_IO_ERROR_WRITE,
	DIORITE_IO_ERROR_TOO_MANY_DATA,
	DIORITE_IO_ERROR_NOT_CONNECTED,
	DIORITE_IO_ERROR_OP_FAILED
} DioriteIOError;
#define DIORITE_IO_ERROR diorite_io_error_quark ()
struct _DioriteIpcChannelWriteBytesAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	DioriteIpcChannel* self;
	GOutputStream* out_stream;
	GByteArray* bytes;
	GByteArray* _tmp0_;
	guint _tmp1_;
	gsize _tmp2_;
	gsize _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GError* _tmp6_;
	GError* _tmp7_;
	guint32 size;
	GByteArray* _tmp8_;
	guint _tmp9_;
	guint8* size_buffer;
	guint8* _tmp10_;
	gint size_buffer_length1;
	gint _size_buffer_size_;
	guint32 _tmp11_;
	GByteArray* _tmp12_;
	guint8* _tmp13_;
	gint _tmp13__length1;
	guint8* data;
	GByteArray* _tmp14_;
	guint8* _tmp15_;
	gint _tmp15__length1;
	guint total_size;
	GByteArray* _tmp16_;
	guint _tmp17_;
	gulong bytes_written_total;
	gulong bytes_written;
	gboolean _tmp18_;
	gulong _tmp19_;
	guint _tmp20_;
	guint8* buffer;
	guint8* _tmp21_;
	gulong _tmp22_;
	gint buffer_length1;
	gint _buffer_size_;
	guint _tmp23_;
	gulong _tmp24_;
	gint _tmp25_;
	gint _tmp26_;
	gssize _result_;
	GOutputStream* _tmp27_;
	guint8* _tmp28_;
	gint _tmp28__length1;
	gssize _tmp29_;
	gssize _tmp30_;
	GError* e;
	const gchar* _tmp31_;
	GError* _tmp32_;
	const gchar* _tmp33_;
	GError* _tmp34_;
	gulong _tmp35_;
	gulong _tmp36_;
	GError * _inner_error_;
};

struct _Block1Data {
	int _ref_count_;
	DioriteIpcChannel* self;
	guint cancel_id;
	GCancellable* cancellable;
	gpointer _async_data_;
};

struct _DioriteIpcChannelReadBytesAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	DioriteIpcChannel* self;
	GInputStream* in_stream;
	GByteArray* bytes;
	guint timeout;
	GCancellable* cancellable;
	Block1Data* _data1_;
	GCancellable* _tmp0_;
	GByteArray* _tmp1_;
	guint _tmp2_;
	GCancellable* _tmp3_;
	GCancellable* _tmp4_;
	guint _tmp5_;
	guint _tmp6_;
	guint8* real_buffer;
	guint8* _tmp7_;
	gint real_buffer_length1;
	gint _real_buffer_size_;
	guint8* buffer;
	guint8* _tmp8_;
	gint _tmp8__length1;
	gint buffer_length1;
	gint _buffer_size_;
	gint bytes_to_read;
	guint64 message_size;
	gint _tmp9_;
	gint _tmp10_;
	gssize _result_;
	GInputStream* _tmp11_;
	guint8* _tmp12_;
	gint _tmp12__length1;
	GCancellable* _tmp13_;
	gssize _tmp14_;
	guint _tmp15_;
	guint _tmp16_;
	gssize _tmp17_;
	gint _tmp18_;
	GError* _tmp19_;
	guint8* _tmp20_;
	gint _tmp20__length1;
	guint32 _tmp21_;
	GError* e;
	GError* _tmp22_;
	const gchar* _tmp23_;
	GError* _tmp24_;
	guint64 _tmp25_;
	GError* _tmp26_;
	gsize bytes_read_total;
	gsize bytes_read;
	gsize _tmp27_;
	guint64 _tmp28_;
	guint64 _tmp29_;
	gsize _tmp30_;
	gint _tmp31_;
	gint _tmp32_;
	gssize _tmp33_;
	GInputStream* _tmp34_;
	guint8* _tmp35_;
	gint _tmp35__length1;
	GCancellable* _tmp36_;
	gssize _tmp37_;
	guint _tmp38_;
	guint _tmp39_;
	GError* _vala1_e;
	GError* _tmp40_;
	const gchar* _tmp41_;
	GError* _tmp42_;
	gsize _tmp43_;
	gint _tmp44_;
	GByteArray* _tmp45_;
	guint8* _tmp46_;
	gint _tmp46__length1;
	gsize _tmp47_;
	gsize _tmp48_;
	guint _tmp49_;
	guint _tmp50_;
	GError * _inner_error_;
};

struct _DioriteIpcParamSpecChannel {
	GParamSpec parent_instance;
};


static gpointer diorite_ipc_channel_parent_class = NULL;

void diorite_ipc_uint32_to_bytes (guint8** buffer, int* buffer_length1, guint32 data, guint offset);
void diorite_ipc_uint32_from_bytes (guint8* buffer, int buffer_length1, guint32* data, guint offset);
gint diorite_ipc_socket_connect (gint fd, const gchar* path);
gint diorite_ipc_socket_bind (gint fd, const gchar* path);
gint diorite_ipc_socket_accept (gint fd);
gpointer diorite_ipc_channel_ref (gpointer instance);
void diorite_ipc_channel_unref (gpointer instance);
GParamSpec* diorite_ipc_param_spec_channel (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void diorite_ipc_value_set_channel (GValue* value, gpointer v_object);
void diorite_ipc_value_take_channel (GValue* value, gpointer v_object);
gpointer diorite_ipc_value_get_channel (const GValue* value);
GType diorite_ipc_channel_get_type (void) G_GNUC_CONST;
#define DIORITE_IPC_CHANNEL_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DIORITE_IPC_TYPE_CHANNEL, DioriteIpcChannelPrivate))
enum  {
	DIORITE_IPC_CHANNEL_DUMMY_PROPERTY
};
DioriteIpcChannel* diorite_ipc_channel_new (const gchar* name);
DioriteIpcChannel* diorite_ipc_channel_construct (GType object_type, const gchar* name);
gchar* diorite_ipc_create_path (const gchar* name);
GQuark diorite_io_error_quark (void);
void diorite_ipc_channel_create (DioriteIpcChannel* self, GError** error);
gchar* get_last_error_msg (void);
void diorite_ipc_channel_close (DioriteIpcChannel* self);
GSocketService* diorite_ipc_channel_create_service (DioriteIpcChannel* self, GError** error);
GSocketConnection* diorite_ipc_channel_create_connection (DioriteIpcChannel* self, GCancellable* cancellable, GError** error);
void diorite_ipc_channel_listen (DioriteIpcChannel* self, GError** error);
void diorite_ipc_channel_check_connected (DioriteIpcChannel* self, GError** error);
void diorite_ipc_channel_disconnect (DioriteIpcChannel* self, GError** error);
void diorite_ipc_channel_connect (DioriteIpcChannel* self, guint timeout, GError** error);
void diorite_ipc_channel_write_data (DioriteIpcChannel* self, guint8* data, int data_length1, GError** error);
void diorite_ipc_channel_write_bytes (DioriteIpcChannel* self, GByteArray* bytes, GError** error);
void diorite_ipc_channel_stop (DioriteIpcChannel* self, GError** error);
void diorite_ipc_channel_flush (DioriteIpcChannel* self, GError** error);
void diorite_ipc_channel_write (DioriteIpcChannel* self, guint8* buffer, gint len, gulong* bytes_written, GError** error);
gsize diorite_ipc_channel_get_max_message_size (void);
#define DIORITE_IPC_MESSAGE_BUFSIZE 512
static void diorite_ipc_channel_write_bytes_async_data_free (gpointer _data);
void diorite_ipc_channel_write_bytes_async (DioriteIpcChannel* self, GOutputStream* out_stream, GByteArray* bytes, GAsyncReadyCallback _callback_, gpointer _user_data_);
void diorite_ipc_channel_write_bytes_finish (DioriteIpcChannel* self, GAsyncResult* _res_, GError** error);
static gboolean diorite_ipc_channel_write_bytes_async_co (DioriteIpcChannelWriteBytesAsyncData* _data_);
static void diorite_ipc_channel_write_bytes_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
void diorite_ipc_channel_read_data (DioriteIpcChannel* self, guint8** data, int* data_length1, GError** error);
void diorite_ipc_channel_read_bytes (DioriteIpcChannel* self, GByteArray** bytes, GError** error);
void diorite_ipc_channel_read (DioriteIpcChannel* self, guint8* buffer, int buffer_length1, gulong* bytes_read, GError** error);
static void diorite_ipc_channel_read_bytes_async_data_free (gpointer _data);
void diorite_ipc_channel_read_bytes_async (DioriteIpcChannel* self, GInputStream* in_stream, guint timeout, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
void diorite_ipc_channel_read_bytes_finish (DioriteIpcChannel* self, GAsyncResult* _res_, GByteArray** bytes, GError** error);
static gboolean diorite_ipc_channel_read_bytes_async_co (DioriteIpcChannelReadBytesAsyncData* _data_);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean ___lambda4_ (Block1Data* _data1_);
static gboolean ____lambda4__gsource_func (gpointer self);
static void diorite_ipc_channel_read_bytes_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static gboolean diorite_ipc_channel_get_connected (DioriteIpcChannel* self);
gboolean diorite_ipc_channel_get_listening (DioriteIpcChannel* self);
static void diorite_ipc_channel_finalize (DioriteIpcChannel* obj);


void diorite_ipc_uint32_to_bytes (guint8** buffer, int* buffer_length1, guint32 data, guint offset) {
	gulong size = 0UL;
	guint8* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	guint _tmp1_ = 0U;
	gulong _tmp2_ = 0UL;
	size = sizeof (guint32);
	_tmp0_ = *buffer;
	_tmp0__length1 = *buffer_length1;
	_tmp1_ = offset;
	_tmp2_ = size;
	_vala_assert (((gulong) _tmp0__length1) >= (_tmp1_ + _tmp2_), "buffer.length >= offset + size");
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gint _tmp5_ = 0;
				gulong _tmp6_ = 0UL;
				guint8* _tmp7_ = NULL;
				gint _tmp7__length1 = 0;
				guint _tmp8_ = 0U;
				gint _tmp9_ = 0;
				guint32 _tmp10_ = 0U;
				gint _tmp11_ = 0;
				guint8 _tmp12_ = 0U;
				if (!_tmp3_) {
					gint _tmp4_ = 0;
					_tmp4_ = i;
					i = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp5_ = i;
				_tmp6_ = size;
				if (!(((gulong) _tmp5_) < _tmp6_)) {
					break;
				}
				_tmp7_ = *buffer;
				_tmp7__length1 = *buffer_length1;
				_tmp8_ = offset;
				_tmp9_ = i;
				_tmp10_ = data;
				_tmp11_ = i;
				_tmp7_[_tmp8_ + _tmp9_] = (guint8) ((_tmp10_ >> ((3 - _tmp11_) * 8)) & 0xFF);
				_tmp12_ = _tmp7_[_tmp8_ + _tmp9_];
			}
		}
	}
}


void diorite_ipc_uint32_from_bytes (guint8* buffer, int buffer_length1, guint32* data, guint offset) {
	guint32 _vala_data = 0U;
	gulong size = 0UL;
	guint8* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	guint _tmp1_ = 0U;
	gulong _tmp2_ = 0UL;
	size = sizeof (guint32);
	_tmp0_ = buffer;
	_tmp0__length1 = buffer_length1;
	_tmp1_ = offset;
	_tmp2_ = size;
	_vala_assert (((gulong) _tmp0__length1) >= (_tmp1_ + _tmp2_), "buffer.length >= offset + size");
	_vala_data = (guint32) 0;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gint _tmp5_ = 0;
				gulong _tmp6_ = 0UL;
				guint32 _tmp7_ = 0U;
				guint8* _tmp8_ = NULL;
				gint _tmp8__length1 = 0;
				guint _tmp9_ = 0U;
				gint _tmp10_ = 0;
				guint8 _tmp11_ = 0U;
				gint _tmp12_ = 0;
				if (!_tmp3_) {
					gint _tmp4_ = 0;
					_tmp4_ = i;
					i = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp5_ = i;
				_tmp6_ = size;
				if (!(((gulong) _tmp5_) < _tmp6_)) {
					break;
				}
				_tmp7_ = _vala_data;
				_tmp8_ = buffer;
				_tmp8__length1 = buffer_length1;
				_tmp9_ = offset;
				_tmp10_ = i;
				_tmp11_ = _tmp8_[_tmp9_ + _tmp10_];
				_tmp12_ = i;
				_vala_data = _tmp7_ + (_tmp11_ * (1 << ((3 - _tmp12_) * 8)));
			}
		}
	}
	if (data) {
		*data = _vala_data;
	}
}


DioriteIpcChannel* diorite_ipc_channel_construct (GType object_type, const gchar* name) {
	DioriteIpcChannel* self = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	self = (DioriteIpcChannel*) g_type_create_instance (object_type);
	_tmp0_ = name;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->name);
	self->priv->name = _tmp1_;
	_tmp2_ = name;
	_tmp3_ = diorite_ipc_create_path (_tmp2_);
	_g_free0 (self->priv->path);
	self->priv->path = _tmp3_;
	return self;
}


DioriteIpcChannel* diorite_ipc_channel_new (const gchar* name) {
	return diorite_ipc_channel_construct (DIORITE_IPC_TYPE_CHANNEL, name);
}


void diorite_ipc_channel_create (DioriteIpcChannel* self, GError** error) {
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	const gchar* _tmp7_ = NULL;
	gint _result_ = 0;
	gint _tmp8_ = 0;
	const gchar* _tmp9_ = NULL;
	gint _tmp10_ = 0;
	gint _tmp11_ = 0;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = socket (AF_UNIX, SOCK_STREAM, 0);
	self->priv->local_socket = _tmp0_;
	_tmp1_ = self->priv->local_socket;
	if (_tmp1_ < 0) {
		const gchar* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		GError* _tmp5_ = NULL;
		GError* _tmp6_ = NULL;
		_tmp2_ = self->priv->path;
		_tmp3_ = get_last_error_msg ();
		_tmp4_ = _tmp3_;
		_tmp5_ = g_error_new (DIORITE_IO_ERROR, DIORITE_IO_ERROR_CONN_FAILED, "Failed to create socket '%s'. %s", _tmp2_, _tmp4_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		_inner_error_ = _tmp6_;
		if (_inner_error_->domain == DIORITE_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp7_ = self->priv->path;
	unlink (_tmp7_);
	_tmp8_ = self->priv->local_socket;
	_tmp9_ = self->priv->path;
	_tmp10_ = diorite_ipc_socket_bind (_tmp8_, _tmp9_);
	_result_ = _tmp10_;
	_tmp11_ = _result_;
	if (_tmp11_ < 0) {
		const gchar* _tmp12_ = NULL;
		gchar* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		GError* _tmp15_ = NULL;
		GError* _tmp16_ = NULL;
		diorite_ipc_channel_close (self);
		_tmp12_ = self->priv->path;
		_tmp13_ = get_last_error_msg ();
		_tmp14_ = _tmp13_;
		_tmp15_ = g_error_new (DIORITE_IO_ERROR, DIORITE_IO_ERROR_CONN_FAILED, "Failed to bind socket '%s'. %s", _tmp12_, _tmp14_);
		_tmp16_ = _tmp15_;
		_g_free0 (_tmp14_);
		_inner_error_ = _tmp16_;
		if (_inner_error_->domain == DIORITE_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


GSocketService* diorite_ipc_channel_create_service (DioriteIpcChannel* self, GError** error) {
	GSocketService* result = NULL;
	const gchar* _tmp0_ = NULL;
	GUnixSocketAddress* address = NULL;
	const gchar* _tmp1_ = NULL;
	GUnixSocketAddress* _tmp2_ = NULL;
	GSocketService* service = NULL;
	GSocketService* _tmp3_ = NULL;
	GSocketAddress* effective_address = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->path;
	unlink (_tmp0_);
	_tmp1_ = self->priv->path;
	_tmp2_ = (GUnixSocketAddress*) g_unix_socket_address_new (_tmp1_);
	address = _tmp2_;
	_tmp3_ = g_socket_service_new ();
	service = _tmp3_;
	{
		GSocketService* _tmp4_ = NULL;
		GUnixSocketAddress* _tmp5_ = NULL;
		GSocketAddress* _tmp6_ = NULL;
		_tmp4_ = service;
		_tmp5_ = address;
		g_socket_listener_add_address ((GSocketListener*) _tmp4_, (GSocketAddress*) _tmp5_, G_SOCKET_TYPE_STREAM, G_SOCKET_PROTOCOL_DEFAULT, NULL, &_tmp6_, &_inner_error_);
		_g_object_unref0 (effective_address);
		effective_address = _tmp6_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch8_g_error;
		}
	}
	goto __finally8;
	__catch8_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp7_ = NULL;
		GError* _tmp8_ = NULL;
		const gchar* _tmp9_ = NULL;
		GError* _tmp10_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp7_ = self->priv->path;
		_tmp8_ = e;
		_tmp9_ = _tmp8_->message;
		_tmp10_ = g_error_new (DIORITE_IO_ERROR, DIORITE_IO_ERROR_CONN_FAILED, "Failed to add socket '%s'. %s", _tmp7_, _tmp9_);
		_inner_error_ = _tmp10_;
		_g_error_free0 (e);
		goto __finally8;
	}
	__finally8:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DIORITE_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (effective_address);
			_g_object_unref0 (service);
			_g_object_unref0 (address);
			return NULL;
		} else {
			_g_object_unref0 (effective_address);
			_g_object_unref0 (service);
			_g_object_unref0 (address);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	result = service;
	_g_object_unref0 (effective_address);
	_g_object_unref0 (address);
	return result;
}


GSocketConnection* diorite_ipc_channel_create_connection (DioriteIpcChannel* self, GCancellable* cancellable, GError** error) {
	GSocketConnection* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	{
		GUnixSocketAddress* address = NULL;
		const gchar* _tmp0_ = NULL;
		GUnixSocketAddress* _tmp1_ = NULL;
		GSocket* socket = NULL;
		GSocket* _tmp2_ = NULL;
		GSocketConnection* connection = NULL;
		GSocket* _tmp3_ = NULL;
		GSocketConnection* _tmp4_ = NULL;
		GSocketConnection* _tmp5_ = NULL;
		GUnixSocketAddress* _tmp6_ = NULL;
		GCancellable* _tmp7_ = NULL;
		_tmp0_ = self->priv->path;
		_tmp1_ = (GUnixSocketAddress*) g_unix_socket_address_new (_tmp0_);
		address = _tmp1_;
		_tmp2_ = g_socket_new (G_SOCKET_FAMILY_UNIX, G_SOCKET_TYPE_STREAM, G_SOCKET_PROTOCOL_DEFAULT, &_inner_error_);
		socket = _tmp2_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (address);
			goto __catch9_g_error;
		}
		_tmp3_ = socket;
		_tmp4_ = g_socket_connection_factory_create_connection (_tmp3_);
		connection = _tmp4_;
		_tmp5_ = connection;
		_tmp6_ = address;
		_tmp7_ = cancellable;
		g_socket_connection_connect (_tmp5_, (GSocketAddress*) _tmp6_, _tmp7_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (connection);
			_g_object_unref0 (socket);
			_g_object_unref0 (address);
			goto __catch9_g_error;
		}
		result = connection;
		_g_object_unref0 (socket);
		_g_object_unref0 (address);
		return result;
	}
	goto __finally9;
	__catch9_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp8_ = NULL;
		GError* _tmp9_ = NULL;
		const gchar* _tmp10_ = NULL;
		GError* _tmp11_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp8_ = self->priv->path;
		_tmp9_ = e;
		_tmp10_ = _tmp9_->message;
		_tmp11_ = g_error_new (DIORITE_IO_ERROR, DIORITE_IO_ERROR_CONN_FAILED, "Failed to connect to socket '%s'. %s", _tmp8_, _tmp10_);
		_inner_error_ = _tmp11_;
		_g_error_free0 (e);
		goto __finally9;
	}
	__finally9:
	if (_inner_error_->domain == DIORITE_IO_ERROR) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	} else {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


void diorite_ipc_channel_listen (DioriteIpcChannel* self, GError** error) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	diorite_ipc_channel_check_connected (self, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DIORITE_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	{
		gint _result_ = 0;
		gint _tmp0_ = 0;
		gint _tmp1_ = 0;
		gint _tmp2_ = 0;
		gint _tmp8_ = 0;
		gint _tmp9_ = 0;
		gint _tmp10_ = 0;
		_tmp0_ = self->priv->local_socket;
		_tmp1_ = listen (_tmp0_, 5);
		_result_ = _tmp1_;
		_tmp2_ = _result_;
		if (_tmp2_ < 0) {
			const gchar* _tmp3_ = NULL;
			gchar* _tmp4_ = NULL;
			gchar* _tmp5_ = NULL;
			GError* _tmp6_ = NULL;
			GError* _tmp7_ = NULL;
			diorite_ipc_channel_close (self);
			_tmp3_ = self->priv->path;
			_tmp4_ = get_last_error_msg ();
			_tmp5_ = _tmp4_;
			_tmp6_ = g_error_new (DIORITE_IO_ERROR, DIORITE_IO_ERROR_CONN_FAILED, "Failed to listen on socket '%s'. %s", _tmp3_, _tmp5_);
			_tmp7_ = _tmp6_;
			_g_free0 (_tmp5_);
			_inner_error_ = _tmp7_;
			goto __finally10;
		}
		self->priv->_listening = TRUE;
		_tmp8_ = self->priv->local_socket;
		_tmp9_ = diorite_ipc_socket_accept (_tmp8_);
		self->priv->remote_socket = _tmp9_;
		_tmp10_ = self->priv->remote_socket;
		if (_tmp10_ < 0) {
			const gchar* _tmp11_ = NULL;
			gchar* _tmp12_ = NULL;
			gchar* _tmp13_ = NULL;
			GError* _tmp14_ = NULL;
			GError* _tmp15_ = NULL;
			diorite_ipc_channel_close (self);
			_tmp11_ = self->priv->path;
			_tmp12_ = get_last_error_msg ();
			_tmp13_ = _tmp12_;
			_tmp14_ = g_error_new (DIORITE_IO_ERROR, DIORITE_IO_ERROR_CONN_FAILED, "Failed to accept on socket '%s'. %s", _tmp11_, _tmp13_);
			_tmp15_ = _tmp14_;
			_g_free0 (_tmp13_);
			_inner_error_ = _tmp15_;
			goto __finally10;
		}
	}
	__finally10:
	{
		self->priv->_listening = FALSE;
	}
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DIORITE_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


void diorite_ipc_channel_disconnect (DioriteIpcChannel* self, GError** error) {
	gint _tmp0_ = 0;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	diorite_ipc_channel_check_connected (self, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DIORITE_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp0_ = self->priv->remote_socket;
	close (_tmp0_);
	self->priv->remote_socket = -1;
}


void diorite_ipc_channel_connect (DioriteIpcChannel* self, guint timeout, GError** error) {
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _result_ = 0;
	gint _tmp7_ = 0;
	const gchar* _tmp8_ = NULL;
	gint _tmp9_ = 0;
	gint _tmp10_ = 0;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = socket (AF_UNIX, SOCK_STREAM, 0);
	self->priv->local_socket = _tmp0_;
	_tmp1_ = self->priv->local_socket;
	if (_tmp1_ < 0) {
		const gchar* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		GError* _tmp5_ = NULL;
		GError* _tmp6_ = NULL;
		_tmp2_ = self->priv->path;
		_tmp3_ = get_last_error_msg ();
		_tmp4_ = _tmp3_;
		_tmp5_ = g_error_new (DIORITE_IO_ERROR, DIORITE_IO_ERROR_CONN_FAILED, "Failed to create socket '%s'. %s", _tmp2_, _tmp4_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		_inner_error_ = _tmp6_;
		if (_inner_error_->domain == DIORITE_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp7_ = self->priv->local_socket;
	_tmp8_ = self->priv->path;
	_tmp9_ = diorite_ipc_socket_connect (_tmp7_, _tmp8_);
	_result_ = _tmp9_;
	_tmp10_ = _result_;
	if (_tmp10_ < 0) {
		const gchar* _tmp11_ = NULL;
		gchar* _tmp12_ = NULL;
		gchar* _tmp13_ = NULL;
		GError* _tmp14_ = NULL;
		GError* _tmp15_ = NULL;
		diorite_ipc_channel_close (self);
		_tmp11_ = self->priv->path;
		_tmp12_ = get_last_error_msg ();
		_tmp13_ = _tmp12_;
		_tmp14_ = g_error_new (DIORITE_IO_ERROR, DIORITE_IO_ERROR_CONN_FAILED, "Failed to connect to '%s'. %s", _tmp11_, _tmp13_);
		_tmp15_ = _tmp14_;
		_g_free0 (_tmp13_);
		_inner_error_ = _tmp15_;
		if (_inner_error_->domain == DIORITE_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


void diorite_ipc_channel_write_data (DioriteIpcChannel* self, guint8* data, int data_length1, GError** error) {
	GByteArray* bytes = NULL;
	guint8* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	GByteArray* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = data;
	_tmp0__length1 = data_length1;
	data = NULL;
	data_length1 = 0;
	_tmp1_ = g_byte_array_new_take (_tmp0_, _tmp0__length1);
	bytes = _tmp1_;
	diorite_ipc_channel_write_bytes (self, bytes, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DIORITE_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_byte_array_unref0 (bytes);
			data = (g_free (data), NULL);
			return;
		} else {
			_g_byte_array_unref0 (bytes);
			data = (g_free (data), NULL);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_g_byte_array_unref0 (bytes);
	data = (g_free (data), NULL);
}


void diorite_ipc_channel_stop (DioriteIpcChannel* self, GError** error) {
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	self->priv->_listening = FALSE;
	_tmp0_ = self->priv->local_socket;
	_tmp1_ = shutdown (_tmp0_, 2);
	if (_tmp1_ < 0) {
		const gchar* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		GError* _tmp5_ = NULL;
		GError* _tmp6_ = NULL;
		_tmp2_ = self->priv->path;
		_tmp3_ = get_last_error_msg ();
		_tmp4_ = _tmp3_;
		_tmp5_ = g_error_new (DIORITE_IO_ERROR, DIORITE_IO_ERROR_CONN_FAILED, "Failed to cancel io on socket '%s'. %s", _tmp2_, _tmp4_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		_inner_error_ = _tmp6_;
		if (_inner_error_->domain == DIORITE_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


void diorite_ipc_channel_close (DioriteIpcChannel* self) {
	gint _tmp0_ = 0;
	gint _tmp2_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->local_socket;
	if (_tmp0_ >= 0) {
		gint _tmp1_ = 0;
		_tmp1_ = self->priv->local_socket;
		close (_tmp1_);
		self->priv->local_socket = -1;
	}
	_tmp2_ = self->priv->remote_socket;
	if (_tmp2_ >= 0) {
		gint _tmp3_ = 0;
		_tmp3_ = self->priv->remote_socket;
		close (_tmp3_);
		self->priv->remote_socket = -1;
	}
}


void diorite_ipc_channel_flush (DioriteIpcChannel* self, GError** error) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	diorite_ipc_channel_check_connected (self, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DIORITE_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


void diorite_ipc_channel_write (DioriteIpcChannel* self, guint8* buffer, gint len, gulong* bytes_written, GError** error) {
	gulong _vala_bytes_written = 0UL;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint fd = 0;
	gssize _result_ = 0L;
	gint _tmp4_ = 0;
	guint8* _tmp5_ = NULL;
	gint _tmp6_ = 0;
	gssize _tmp7_ = 0L;
	gssize _tmp8_ = 0L;
	gssize _tmp14_ = 0L;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_vala_bytes_written = (gulong) 0;
	_tmp1_ = self->priv->remote_socket;
	if (_tmp1_ >= 0) {
		gint _tmp2_ = 0;
		_tmp2_ = self->priv->remote_socket;
		_tmp0_ = _tmp2_;
	} else {
		gint _tmp3_ = 0;
		_tmp3_ = self->priv->local_socket;
		_tmp0_ = _tmp3_;
	}
	fd = _tmp0_;
	_tmp4_ = fd;
	_tmp5_ = buffer;
	_tmp6_ = len;
	_tmp7_ = write (_tmp4_, (void*) _tmp5_, (gsize) _tmp6_);
	_result_ = _tmp7_;
	_tmp8_ = _result_;
	if (_tmp8_ < ((gssize) 0)) {
		const gchar* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
		gchar* _tmp11_ = NULL;
		GError* _tmp12_ = NULL;
		GError* _tmp13_ = NULL;
		diorite_ipc_channel_close (self);
		_tmp9_ = self->priv->path;
		_tmp10_ = get_last_error_msg ();
		_tmp11_ = _tmp10_;
		_tmp12_ = g_error_new (DIORITE_IO_ERROR, DIORITE_IO_ERROR_WRITE, "Failed write to socket '%s': %s", _tmp9_, _tmp11_);
		_tmp13_ = _tmp12_;
		_g_free0 (_tmp11_);
		_inner_error_ = _tmp13_;
		if (_inner_error_->domain == DIORITE_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp14_ = _result_;
	_vala_bytes_written = (gulong) _tmp14_;
	diorite_ipc_channel_flush (self, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DIORITE_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	if (bytes_written) {
		*bytes_written = _vala_bytes_written;
	}
}


void diorite_ipc_channel_write_bytes (DioriteIpcChannel* self, GByteArray* bytes, GError** error) {
	GByteArray* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	gsize _tmp2_ = 0UL;
	guint32 size = 0U;
	GByteArray* _tmp8_ = NULL;
	guint _tmp9_ = 0U;
	guint8* size_buffer = NULL;
	guint8* _tmp10_ = NULL;
	gint size_buffer_length1 = 0;
	gint _size_buffer_size_ = 0;
	guint32 _tmp11_ = 0U;
	GByteArray* _tmp12_ = NULL;
	guint8* _tmp13_ = NULL;
	gint _tmp13__length1 = 0;
	guint8* data = NULL;
	GByteArray* _tmp14_ = NULL;
	guint8* _tmp15_ = NULL;
	gint _tmp15__length1 = 0;
	guint total_size = 0U;
	GByteArray* _tmp16_ = NULL;
	guint _tmp17_ = 0U;
	gulong bytes_written_total = 0UL;
	gulong bytes_written = 0UL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (bytes != NULL);
	diorite_ipc_channel_check_connected (self, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DIORITE_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp0_ = bytes;
	_tmp1_ = _tmp0_->len;
	_tmp2_ = diorite_ipc_channel_get_max_message_size ();
	if (((gsize) _tmp1_) > _tmp2_) {
		gsize _tmp3_ = 0UL;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		GError* _tmp6_ = NULL;
		GError* _tmp7_ = NULL;
		_tmp3_ = diorite_ipc_channel_get_max_message_size ();
		_tmp4_ = g_strdup_printf ("%" G_GSIZE_FORMAT, _tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = g_error_new (DIORITE_IO_ERROR, DIORITE_IO_ERROR_TOO_MANY_DATA, "Only %s bytes can be sent.", _tmp5_);
		_tmp7_ = _tmp6_;
		_g_free0 (_tmp5_);
		_inner_error_ = _tmp7_;
		if (_inner_error_->domain == DIORITE_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp8_ = bytes;
	_tmp9_ = _tmp8_->len;
	size = (guint32) _tmp9_;
	_tmp10_ = g_new0 (guint8, sizeof (guint32));
	size_buffer = _tmp10_;
	size_buffer_length1 = sizeof (guint32);
	_size_buffer_size_ = size_buffer_length1;
	_tmp11_ = size;
	diorite_ipc_uint32_to_bytes (&size_buffer, &size_buffer_length1, _tmp11_, (guint) 0);
	_tmp12_ = bytes;
	_tmp13_ = size_buffer;
	_tmp13__length1 = size_buffer_length1;
	g_byte_array_prepend (_tmp12_, _tmp13_, _tmp13__length1);
	_tmp14_ = bytes;
	_tmp15_ = _tmp14_->data;
	_tmp15__length1 = (gint) _tmp14_->len;
	data = _tmp15_;
	_tmp16_ = bytes;
	_tmp17_ = _tmp16_->len;
	total_size = _tmp17_;
	bytes_written_total = (gulong) 0;
	{
		gboolean _tmp18_ = FALSE;
		_tmp18_ = TRUE;
		while (TRUE) {
			guint8* _tmp21_ = NULL;
			gulong _tmp22_ = 0UL;
			guint _tmp23_ = 0U;
			gulong _tmp24_ = 0UL;
			gint _tmp25_ = 0;
			gulong _tmp26_ = 0UL;
			gulong _tmp27_ = 0UL;
			gulong _tmp28_ = 0UL;
			if (!_tmp18_) {
				gulong _tmp19_ = 0UL;
				guint _tmp20_ = 0U;
				_tmp19_ = bytes_written_total;
				_tmp20_ = total_size;
				if (!(_tmp19_ < ((gulong) _tmp20_))) {
					break;
				}
			}
			_tmp18_ = FALSE;
			_tmp21_ = data;
			_tmp22_ = bytes_written_total;
			_tmp23_ = total_size;
			_tmp24_ = bytes_written_total;
			_tmp25_ = MIN (DIORITE_IPC_MESSAGE_BUFSIZE, (gint) (_tmp23_ - _tmp24_));
			diorite_ipc_channel_write (self, _tmp21_ + _tmp22_, _tmp25_, &_tmp26_, &_inner_error_);
			bytes_written = _tmp26_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				if (_inner_error_->domain == DIORITE_IO_ERROR) {
					g_propagate_error (error, _inner_error_);
					size_buffer = (g_free (size_buffer), NULL);
					return;
				} else {
					size_buffer = (g_free (size_buffer), NULL);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return;
				}
			}
			_tmp27_ = bytes_written_total;
			_tmp28_ = bytes_written;
			bytes_written_total = _tmp27_ + _tmp28_;
		}
	}
	size_buffer = (g_free (size_buffer), NULL);
}


static void diorite_ipc_channel_write_bytes_async_data_free (gpointer _data) {
	DioriteIpcChannelWriteBytesAsyncData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->out_stream);
	_g_byte_array_unref0 (_data_->bytes);
	_diorite_ipc_channel_unref0 (_data_->self);
	g_slice_free (DioriteIpcChannelWriteBytesAsyncData, _data_);
}


static gpointer _diorite_ipc_channel_ref0 (gpointer self) {
	return self ? diorite_ipc_channel_ref (self) : NULL;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static gpointer _g_byte_array_ref0 (gpointer self) {
	return self ? g_byte_array_ref (self) : NULL;
}


void diorite_ipc_channel_write_bytes_async (DioriteIpcChannel* self, GOutputStream* out_stream, GByteArray* bytes, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	DioriteIpcChannelWriteBytesAsyncData* _data_;
	DioriteIpcChannel* _tmp0_ = NULL;
	GOutputStream* _tmp1_ = NULL;
	GOutputStream* _tmp2_ = NULL;
	GByteArray* _tmp3_ = NULL;
	GByteArray* _tmp4_ = NULL;
	_data_ = g_slice_new0 (DioriteIpcChannelWriteBytesAsyncData);
	_data_->_async_result = g_simple_async_result_new (NULL, _callback_, _user_data_, diorite_ipc_channel_write_bytes_async);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, diorite_ipc_channel_write_bytes_async_data_free);
	_tmp0_ = _diorite_ipc_channel_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = out_stream;
	_tmp2_ = _g_object_ref0 (_tmp1_);
	_g_object_unref0 (_data_->out_stream);
	_data_->out_stream = _tmp2_;
	_tmp3_ = bytes;
	_tmp4_ = _g_byte_array_ref0 (_tmp3_);
	_g_byte_array_unref0 (_data_->bytes);
	_data_->bytes = _tmp4_;
	diorite_ipc_channel_write_bytes_async_co (_data_);
}


void diorite_ipc_channel_write_bytes_finish (DioriteIpcChannel* self, GAsyncResult* _res_, GError** error) {
	DioriteIpcChannelWriteBytesAsyncData* _data_;
	if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (_res_), error)) {
		return;
	}
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


static void diorite_ipc_channel_write_bytes_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	DioriteIpcChannelWriteBytesAsyncData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	diorite_ipc_channel_write_bytes_async_co (_data_);
}


static gboolean diorite_ipc_channel_write_bytes_async_co (DioriteIpcChannelWriteBytesAsyncData* _data_) {
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = NULL;
	_data_->_tmp0_ = _data_->bytes;
	_data_->_tmp1_ = 0U;
	_data_->_tmp1_ = _data_->_tmp0_->len;
	_data_->_tmp2_ = 0UL;
	_data_->_tmp2_ = diorite_ipc_channel_get_max_message_size ();
	if (((gsize) _data_->_tmp1_) > _data_->_tmp2_) {
		_data_->_tmp3_ = 0UL;
		_data_->_tmp3_ = diorite_ipc_channel_get_max_message_size ();
		_data_->_tmp4_ = NULL;
		_data_->_tmp4_ = g_strdup_printf ("%" G_GSIZE_FORMAT, _data_->_tmp3_);
		_data_->_tmp5_ = NULL;
		_data_->_tmp5_ = _data_->_tmp4_;
		_data_->_tmp6_ = NULL;
		_data_->_tmp6_ = g_error_new (DIORITE_IO_ERROR, DIORITE_IO_ERROR_TOO_MANY_DATA, "Only %s bytes can be sent.", _data_->_tmp5_);
		_data_->_tmp7_ = NULL;
		_data_->_tmp7_ = _data_->_tmp6_;
		_g_free0 (_data_->_tmp5_);
		_data_->_inner_error_ = _data_->_tmp7_;
		if (_data_->_inner_error_->domain == DIORITE_IO_ERROR) {
			g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
			g_error_free (_data_->_inner_error_);
			if (_data_->_state_ == 0) {
				g_simple_async_result_complete_in_idle (_data_->_async_result);
			} else {
				g_simple_async_result_complete (_data_->_async_result);
			}
			g_object_unref (_data_->_async_result);
			return FALSE;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
			g_clear_error (&_data_->_inner_error_);
			return FALSE;
		}
	}
	_data_->_tmp8_ = NULL;
	_data_->_tmp8_ = _data_->bytes;
	_data_->_tmp9_ = 0U;
	_data_->_tmp9_ = _data_->_tmp8_->len;
	_data_->size = (guint32) _data_->_tmp9_;
	_data_->_tmp10_ = NULL;
	_data_->_tmp10_ = g_new0 (guint8, sizeof (guint32));
	_data_->size_buffer_length1 = 0;
	_data_->_size_buffer_size_ = 0;
	_data_->size_buffer = _data_->_tmp10_;
	_data_->size_buffer_length1 = sizeof (guint32);
	_data_->_size_buffer_size_ = _data_->size_buffer_length1;
	_data_->_tmp11_ = 0U;
	_data_->_tmp11_ = _data_->size;
	diorite_ipc_uint32_to_bytes (&_data_->size_buffer, &_data_->size_buffer_length1, _data_->_tmp11_, (guint) 0);
	_data_->_tmp12_ = NULL;
	_data_->_tmp12_ = _data_->bytes;
	_data_->_tmp13_ = NULL;
	_data_->_tmp13__length1 = 0;
	_data_->_tmp13_ = _data_->size_buffer;
	_data_->_tmp13__length1 = _data_->size_buffer_length1;
	g_byte_array_prepend (_data_->_tmp12_, _data_->_tmp13_, _data_->_tmp13__length1);
	_data_->_tmp14_ = NULL;
	_data_->_tmp14_ = _data_->bytes;
	_data_->_tmp15_ = NULL;
	_data_->_tmp15__length1 = 0;
	_data_->_tmp15_ = _data_->_tmp14_->data;
	_data_->_tmp15__length1 = (gint) _data_->_tmp14_->len;
	_data_->data = _data_->_tmp15_;
	_data_->_tmp16_ = NULL;
	_data_->_tmp16_ = _data_->bytes;
	_data_->_tmp17_ = 0U;
	_data_->_tmp17_ = _data_->_tmp16_->len;
	_data_->total_size = _data_->_tmp17_;
	_data_->bytes_written_total = (gulong) 0;
	{
		_data_->_tmp18_ = TRUE;
		while (TRUE) {
			if (!_data_->_tmp18_) {
				_data_->_tmp19_ = 0UL;
				_data_->_tmp19_ = _data_->bytes_written_total;
				_data_->_tmp20_ = 0U;
				_data_->_tmp20_ = _data_->total_size;
				if (!(_data_->_tmp19_ < ((gulong) _data_->_tmp20_))) {
					break;
				}
			}
			_data_->_tmp18_ = FALSE;
			{
				_data_->_tmp21_ = NULL;
				_data_->_tmp21_ = _data_->data;
				_data_->_tmp22_ = 0UL;
				_data_->_tmp22_ = _data_->bytes_written_total;
				_data_->buffer_length1 = 0;
				_data_->_buffer_size_ = 0;
				_data_->buffer = (guint8*) (_data_->_tmp21_ + _data_->_tmp22_);
				_data_->buffer_length1 = -1;
				_data_->_buffer_size_ = _data_->buffer_length1;
				_data_->_tmp23_ = 0U;
				_data_->_tmp23_ = _data_->total_size;
				_data_->_tmp24_ = 0UL;
				_data_->_tmp24_ = _data_->bytes_written_total;
				_data_->_tmp25_ = 0;
				_data_->_tmp25_ = MIN (DIORITE_IPC_MESSAGE_BUFSIZE, (gint) (_data_->_tmp23_ - _data_->_tmp24_));
				_data_->buffer_length1 = _data_->_tmp25_;
				_data_->_tmp26_ = 0;
				_data_->_tmp26_ = _data_->buffer_length1;
				_data_->_tmp27_ = NULL;
				_data_->_tmp27_ = _data_->out_stream;
				_data_->_tmp28_ = NULL;
				_data_->_tmp28__length1 = 0;
				_data_->_tmp28_ = _data_->buffer;
				_data_->_tmp28__length1 = _data_->buffer_length1;
				_data_->_state_ = 1;
				g_output_stream_write_async (_data_->_tmp27_, _data_->_tmp28_, (gsize) _data_->_tmp28__length1, G_PRIORITY_DEFAULT, NULL, diorite_ipc_channel_write_bytes_async_ready, _data_);
				return FALSE;
				_state_1:
				_data_->_tmp29_ = 0L;
				_data_->_tmp29_ = g_output_stream_write_finish (_data_->_tmp27_, _data_->_res_, &_data_->_inner_error_);
				_data_->_result_ = _data_->_tmp29_;
				if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
					if (_data_->_inner_error_->domain == G_IO_ERROR) {
						goto __catch11_g_io_error;
					}
					_data_->size_buffer = (g_free (_data_->size_buffer), NULL);
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
					g_clear_error (&_data_->_inner_error_);
					return FALSE;
				}
				_data_->_tmp30_ = 0L;
				_data_->_tmp30_ = _data_->_result_;
				_data_->bytes_written = (gulong) _data_->_tmp30_;
			}
			goto __finally11;
			__catch11_g_io_error:
			{
				_data_->e = _data_->_inner_error_;
				_data_->_inner_error_ = NULL;
				diorite_ipc_channel_close (_data_->self);
				_data_->_tmp31_ = NULL;
				_data_->_tmp31_ = _data_->self->priv->path;
				_data_->_tmp32_ = NULL;
				_data_->_tmp32_ = _data_->e;
				_data_->_tmp33_ = NULL;
				_data_->_tmp33_ = _data_->_tmp32_->message;
				_data_->_tmp34_ = NULL;
				_data_->_tmp34_ = g_error_new (DIORITE_IO_ERROR, DIORITE_IO_ERROR_WRITE, "Failed write to socket '%s': %s", _data_->_tmp31_, _data_->_tmp33_);
				_data_->_inner_error_ = _data_->_tmp34_;
				_g_error_free0 (_data_->e);
				goto __finally11;
			}
			__finally11:
			if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
				if (_data_->_inner_error_->domain == DIORITE_IO_ERROR) {
					g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
					g_error_free (_data_->_inner_error_);
					_data_->size_buffer = (g_free (_data_->size_buffer), NULL);
					if (_data_->_state_ == 0) {
						g_simple_async_result_complete_in_idle (_data_->_async_result);
					} else {
						g_simple_async_result_complete (_data_->_async_result);
					}
					g_object_unref (_data_->_async_result);
					return FALSE;
				} else {
					_data_->size_buffer = (g_free (_data_->size_buffer), NULL);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
					g_clear_error (&_data_->_inner_error_);
					return FALSE;
				}
			}
			_data_->_tmp35_ = 0UL;
			_data_->_tmp35_ = _data_->bytes_written_total;
			_data_->_tmp36_ = 0UL;
			_data_->_tmp36_ = _data_->bytes_written;
			_data_->bytes_written_total = _data_->_tmp35_ + _data_->_tmp36_;
		}
	}
	_data_->size_buffer = (g_free (_data_->size_buffer), NULL);
	if (_data_->_state_ == 0) {
		g_simple_async_result_complete_in_idle (_data_->_async_result);
	} else {
		g_simple_async_result_complete (_data_->_async_result);
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


void diorite_ipc_channel_read_data (DioriteIpcChannel* self, guint8** data, int* data_length1, GError** error) {
	guint8* _vala_data = NULL;
	int _vala_data_length1 = 0;
	GByteArray* bytes = NULL;
	GByteArray* _tmp0_ = NULL;
	guint8* _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	diorite_ipc_channel_read_bytes (self, &_tmp0_, &_inner_error_);
	_g_byte_array_unref0 (bytes);
	bytes = _tmp0_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DIORITE_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_byte_array_unref0 (bytes);
			return;
		} else {
			_g_byte_array_unref0 (bytes);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp1_ = bytes->data;
	_tmp1__length1 = bytes->len;
	bytes->data = NULL;
	bytes->len = 0;
	_vala_data = (g_free (_vala_data), NULL);
	_vala_data = _tmp1_;
	_vala_data_length1 = _tmp1__length1;
	_g_byte_array_unref0 (bytes);
	if (data) {
		*data = _vala_data;
	} else {
		_vala_data = (g_free (_vala_data), NULL);
	}
	if (data_length1) {
		*data_length1 = _vala_data_length1;
	}
}


void diorite_ipc_channel_read_bytes (DioriteIpcChannel* self, GByteArray** bytes, GError** error) {
	GByteArray* _vala_bytes = NULL;
	GByteArray* _tmp0_ = NULL;
	guint8* buffer = NULL;
	guint8* _tmp1_ = NULL;
	gint buffer_length1 = 0;
	gint _buffer_size_ = 0;
	gulong bytes_read = 0UL;
	guint64 bytes_read_total = 0ULL;
	guint64 message_size = 0ULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	diorite_ipc_channel_check_connected (self, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DIORITE_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp0_ = g_byte_array_new ();
	_g_byte_array_unref0 (_vala_bytes);
	_vala_bytes = _tmp0_;
	_tmp1_ = g_new0 (guint8, DIORITE_IPC_MESSAGE_BUFSIZE);
	buffer = _tmp1_;
	buffer_length1 = DIORITE_IPC_MESSAGE_BUFSIZE;
	_buffer_size_ = buffer_length1;
	bytes_read_total = (guint64) 0;
	message_size = (guint64) 0;
	{
		gboolean _tmp2_ = FALSE;
		_tmp2_ = TRUE;
		while (TRUE) {
			guint8* _tmp5_ = NULL;
			gint _tmp5__length1 = 0;
			gulong _tmp6_ = 0UL;
			guint64 _tmp7_ = 0ULL;
			guint extra = 0U;
			gulong _tmp21_ = 0UL;
			guint _tmp22_ = 0U;
			if (!_tmp2_) {
				guint64 _tmp3_ = 0ULL;
				guint64 _tmp4_ = 0ULL;
				_tmp3_ = bytes_read_total;
				_tmp4_ = message_size;
				if (!(_tmp3_ < _tmp4_)) {
					break;
				}
			}
			_tmp2_ = FALSE;
			_tmp5_ = buffer;
			_tmp5__length1 = buffer_length1;
			diorite_ipc_channel_read (self, _tmp5_, _tmp5__length1, &_tmp6_, &_inner_error_);
			bytes_read = _tmp6_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				if (_inner_error_->domain == DIORITE_IO_ERROR) {
					g_propagate_error (error, _inner_error_);
					buffer = (g_free (buffer), NULL);
					return;
				} else {
					buffer = (g_free (buffer), NULL);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return;
				}
			}
			_tmp7_ = bytes_read_total;
			if (_tmp7_ == ((guint64) 0)) {
				guint8* _tmp8_ = NULL;
				gint _tmp8__length1 = 0;
				guint32 _tmp9_ = 0U;
				guint64 _tmp10_ = 0ULL;
				gulong _tmp11_ = 0UL;
				guint8* shorter_buffer = NULL;
				guint8* _tmp12_ = NULL;
				gint _tmp12__length1 = 0;
				gint shorter_buffer_length1 = 0;
				gint _shorter_buffer_size_ = 0;
				guint8* _tmp13_ = NULL;
				gint _tmp13__length1 = 0;
				gint _tmp14_ = 0;
				GByteArray* _tmp15_ = NULL;
				guint8* _tmp16_ = NULL;
				gint _tmp16__length1 = 0;
				_tmp8_ = buffer;
				_tmp8__length1 = buffer_length1;
				diorite_ipc_uint32_from_bytes (_tmp8_, _tmp8__length1, &_tmp9_, (guint) 0);
				message_size = (guint64) _tmp9_;
				_tmp10_ = bytes_read_total;
				_tmp11_ = bytes_read;
				bytes_read_total = _tmp10_ + (_tmp11_ - sizeof (guint32));
				_tmp12_ = buffer;
				_tmp12__length1 = buffer_length1;
				shorter_buffer = (guint8*) (((guint8*) _tmp12_) + sizeof (guint32));
				shorter_buffer_length1 = -1;
				_shorter_buffer_size_ = shorter_buffer_length1;
				_tmp13_ = buffer;
				_tmp13__length1 = buffer_length1;
				shorter_buffer_length1 = (gint) (_tmp13__length1 - sizeof (guint32));
				_tmp14_ = shorter_buffer_length1;
				_tmp15_ = _vala_bytes;
				_tmp16_ = shorter_buffer;
				_tmp16__length1 = shorter_buffer_length1;
				g_byte_array_append (_tmp15_, _tmp16_, _tmp16__length1);
			} else {
				GByteArray* _tmp17_ = NULL;
				guint8* _tmp18_ = NULL;
				gint _tmp18__length1 = 0;
				guint64 _tmp19_ = 0ULL;
				gulong _tmp20_ = 0UL;
				_tmp17_ = _vala_bytes;
				_tmp18_ = buffer;
				_tmp18__length1 = buffer_length1;
				g_byte_array_append (_tmp17_, _tmp18_, _tmp18__length1);
				_tmp19_ = bytes_read_total;
				_tmp20_ = bytes_read;
				bytes_read_total = _tmp19_ + _tmp20_;
			}
			_tmp21_ = bytes_read;
			extra = (guint) (DIORITE_IPC_MESSAGE_BUFSIZE - _tmp21_);
			_tmp22_ = extra;
			if (_tmp22_ > ((guint) 0)) {
				GByteArray* _tmp23_ = NULL;
				GByteArray* _tmp24_ = NULL;
				guint _tmp25_ = 0U;
				guint _tmp26_ = 0U;
				guint _tmp27_ = 0U;
				_tmp23_ = _vala_bytes;
				_tmp24_ = _vala_bytes;
				_tmp25_ = _tmp24_->len;
				_tmp26_ = extra;
				_tmp27_ = extra;
				g_byte_array_remove_range (_tmp23_, _tmp25_ - _tmp26_, _tmp27_);
			}
		}
	}
	buffer = (g_free (buffer), NULL);
	if (bytes) {
		*bytes = _vala_bytes;
	} else {
		_g_byte_array_unref0 (_vala_bytes);
	}
}


void diorite_ipc_channel_read (DioriteIpcChannel* self, guint8* buffer, int buffer_length1, gulong* bytes_read, GError** error) {
	gulong _vala_bytes_read = 0UL;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint fd = 0;
	gssize _result_ = 0L;
	gint _tmp4_ = 0;
	guint8* _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
	guint8* _tmp6_ = NULL;
	gint _tmp6__length1 = 0;
	gssize _tmp7_ = 0L;
	gssize _tmp8_ = 0L;
	gssize _tmp13_ = 0L;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_vala_bytes_read = (gulong) 0;
	_tmp1_ = self->priv->remote_socket;
	if (_tmp1_ >= 0) {
		gint _tmp2_ = 0;
		_tmp2_ = self->priv->remote_socket;
		_tmp0_ = _tmp2_;
	} else {
		gint _tmp3_ = 0;
		_tmp3_ = self->priv->local_socket;
		_tmp0_ = _tmp3_;
	}
	fd = _tmp0_;
	_tmp4_ = fd;
	_tmp5_ = buffer;
	_tmp5__length1 = buffer_length1;
	_tmp6_ = buffer;
	_tmp6__length1 = buffer_length1;
	_tmp7_ = read (_tmp4_, (void*) _tmp5_, (gsize) _tmp6__length1);
	_result_ = _tmp7_;
	_tmp8_ = _result_;
	if (_tmp8_ < ((gssize) 0)) {
		gchar* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
		GError* _tmp11_ = NULL;
		GError* _tmp12_ = NULL;
		diorite_ipc_channel_close (self);
		_tmp9_ = get_last_error_msg ();
		_tmp10_ = _tmp9_;
		_tmp11_ = g_error_new (DIORITE_IO_ERROR, DIORITE_IO_ERROR_READ, "Failed to read from socket. %s", _tmp10_);
		_tmp12_ = _tmp11_;
		_g_free0 (_tmp10_);
		_inner_error_ = _tmp12_;
		if (_inner_error_->domain == DIORITE_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp13_ = _result_;
	_vala_bytes_read = (gulong) _tmp13_;
	if (bytes_read) {
		*bytes_read = _vala_bytes_read;
	}
}


static void diorite_ipc_channel_read_bytes_async_data_free (gpointer _data) {
	DioriteIpcChannelReadBytesAsyncData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->in_stream);
	_diorite_ipc_channel_unref0 (_data_->self);
	g_slice_free (DioriteIpcChannelReadBytesAsyncData, _data_);
}


void diorite_ipc_channel_read_bytes_async (DioriteIpcChannel* self, GInputStream* in_stream, guint timeout, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	DioriteIpcChannelReadBytesAsyncData* _data_;
	DioriteIpcChannel* _tmp0_ = NULL;
	GInputStream* _tmp1_ = NULL;
	GInputStream* _tmp2_ = NULL;
	guint _tmp3_ = 0U;
	_data_ = g_slice_new0 (DioriteIpcChannelReadBytesAsyncData);
	_data_->_async_result = g_simple_async_result_new (NULL, _callback_, _user_data_, diorite_ipc_channel_read_bytes_async);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, diorite_ipc_channel_read_bytes_async_data_free);
	_tmp0_ = _diorite_ipc_channel_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = in_stream;
	_tmp2_ = _g_object_ref0 (_tmp1_);
	_g_object_unref0 (_data_->in_stream);
	_data_->in_stream = _tmp2_;
	_tmp3_ = timeout;
	_data_->timeout = _tmp3_;
	_g_object_unref0 (_data_->cancellable);
	_data_->cancellable = cancellable;
	diorite_ipc_channel_read_bytes_async_co (_data_);
}


void diorite_ipc_channel_read_bytes_finish (DioriteIpcChannel* self, GAsyncResult* _res_, GByteArray** bytes, GError** error) {
	DioriteIpcChannelReadBytesAsyncData* _data_;
	if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (_res_), error)) {
		return;
	}
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
	if (bytes) {
		*bytes = _data_->bytes;
	} else {
		_g_byte_array_unref0 (_data_->bytes);
	}
	_data_->bytes = NULL;
}


static Block1Data* block1_data_ref (Block1Data* _data1_) {
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}


static void block1_data_unref (void * _userdata_) {
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		DioriteIpcChannel* self;
		self = _data1_->self;
		_g_object_unref0 (_data1_->cancellable);
		_diorite_ipc_channel_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}


static gboolean ___lambda4_ (Block1Data* _data1_) {
	DioriteIpcChannel* self;
	gboolean result = FALSE;
	GCancellable* _tmp0_ = NULL;
	self = _data1_->self;
	_data1_->cancel_id = (guint) 0;
	_tmp0_ = _data1_->cancellable;
	g_cancellable_cancel (_tmp0_);
	result = FALSE;
	return result;
}


static gboolean ____lambda4__gsource_func (gpointer self) {
	gboolean result;
	result = ___lambda4_ (self);
	return result;
}


static void diorite_ipc_channel_read_bytes_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	DioriteIpcChannelReadBytesAsyncData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	diorite_ipc_channel_read_bytes_async_co (_data_);
}


static gboolean diorite_ipc_channel_read_bytes_async_co (DioriteIpcChannelReadBytesAsyncData* _data_) {
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data1_ = g_slice_new0 (Block1Data);
	_data_->_data1_->_ref_count_ = 1;
	_data_->_data1_->self = diorite_ipc_channel_ref (_data_->self);
	_data_->_tmp0_ = NULL;
	_data_->_tmp0_ = _data_->cancellable;
	_g_object_unref0 (_data_->_data1_->cancellable);
	_data_->_data1_->cancellable = _data_->_tmp0_;
	_data_->_data1_->_async_data_ = _data_;
	_data_->_tmp1_ = NULL;
	_data_->_tmp1_ = g_byte_array_new ();
	_g_byte_array_unref0 (_data_->bytes);
	_data_->bytes = _data_->_tmp1_;
	_data_->_data1_->cancel_id = (guint) 0;
	_data_->_tmp2_ = 0U;
	_data_->_tmp2_ = _data_->timeout;
	if (_data_->_tmp2_ > ((guint) 0)) {
		_data_->_tmp3_ = NULL;
		_data_->_tmp3_ = _data_->_data1_->cancellable;
		if (_data_->_tmp3_ == NULL) {
			_data_->_tmp4_ = NULL;
			_data_->_tmp4_ = g_cancellable_new ();
			_g_object_unref0 (_data_->_data1_->cancellable);
			_data_->_data1_->cancellable = _data_->_tmp4_;
		}
		_data_->_tmp5_ = 0U;
		_data_->_tmp5_ = _data_->timeout;
		_data_->_tmp6_ = 0U;
		_data_->_tmp6_ = g_timeout_add_full (G_PRIORITY_DEFAULT, _data_->_tmp5_, ____lambda4__gsource_func, block1_data_ref (_data_->_data1_), block1_data_unref);
		_data_->_data1_->cancel_id = _data_->_tmp6_;
	}
	{
		_data_->_tmp7_ = NULL;
		_data_->_tmp7_ = g_new0 (guint8, DIORITE_IPC_MESSAGE_BUFSIZE);
		_data_->real_buffer_length1 = 0;
		_data_->_real_buffer_size_ = 0;
		_data_->real_buffer = _data_->_tmp7_;
		_data_->real_buffer_length1 = DIORITE_IPC_MESSAGE_BUFSIZE;
		_data_->_real_buffer_size_ = _data_->real_buffer_length1;
		_data_->_tmp8_ = NULL;
		_data_->_tmp8__length1 = 0;
		_data_->_tmp8_ = _data_->real_buffer;
		_data_->_tmp8__length1 = _data_->real_buffer_length1;
		_data_->buffer_length1 = 0;
		_data_->_buffer_size_ = 0;
		_data_->buffer = _data_->_tmp8_;
		_data_->buffer_length1 = _data_->_tmp8__length1;
		_data_->_buffer_size_ = _data_->buffer_length1;
		_data_->bytes_to_read = (gint) sizeof (guint32);
		_data_->message_size = (guint64) 0;
		{
			_data_->_tmp9_ = 0;
			_data_->_tmp9_ = _data_->bytes_to_read;
			_data_->buffer_length1 = _data_->_tmp9_;
			_data_->_tmp10_ = 0;
			_data_->_tmp10_ = _data_->buffer_length1;
			_data_->_tmp11_ = NULL;
			_data_->_tmp11_ = _data_->in_stream;
			_data_->_tmp12_ = NULL;
			_data_->_tmp12__length1 = 0;
			_data_->_tmp12_ = _data_->buffer;
			_data_->_tmp12__length1 = _data_->buffer_length1;
			_data_->_tmp13_ = NULL;
			_data_->_tmp13_ = _data_->_data1_->cancellable;
			_data_->_state_ = 1;
			g_input_stream_read_async (_data_->_tmp11_, _data_->_tmp12_, (gsize) _data_->_tmp12__length1, G_PRIORITY_DEFAULT, _data_->_tmp13_, diorite_ipc_channel_read_bytes_async_ready, _data_);
			return FALSE;
			_state_1:
			_data_->_tmp14_ = 0L;
			_data_->_tmp14_ = g_input_stream_read_finish (_data_->_tmp11_, _data_->_res_, &_data_->_inner_error_);
			_data_->_result_ = _data_->_tmp14_;
			if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
				if (_data_->_inner_error_->domain == G_IO_ERROR) {
					goto __catch13_g_io_error;
				}
				_data_->real_buffer = (g_free (_data_->real_buffer), NULL);
				{
					_data_->_tmp15_ = 0U;
					_data_->_tmp15_ = _data_->_data1_->cancel_id;
					if (_data_->_tmp15_ != ((guint) 0)) {
						_data_->_tmp16_ = 0U;
						_data_->_tmp16_ = _data_->_data1_->cancel_id;
						g_source_remove (_data_->_tmp16_);
					}
				}
				block1_data_unref (_data_->_data1_);
				_data_->_data1_ = NULL;
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
				g_clear_error (&_data_->_inner_error_);
				return FALSE;
			}
			_data_->_tmp17_ = 0L;
			_data_->_tmp17_ = _data_->_result_;
			_data_->_tmp18_ = 0;
			_data_->_tmp18_ = _data_->bytes_to_read;
			if (_data_->_tmp17_ != ((gssize) _data_->_tmp18_)) {
				_data_->_tmp19_ = NULL;
				_data_->_tmp19_ = g_error_new_literal (DIORITE_IO_ERROR, DIORITE_IO_ERROR_READ, "Failed to read message size.");
				_data_->_inner_error_ = _data_->_tmp19_;
				if (_data_->_inner_error_->domain == G_IO_ERROR) {
					goto __catch13_g_io_error;
				}
				goto __finally13;
			}
			_data_->_tmp20_ = NULL;
			_data_->_tmp20__length1 = 0;
			_data_->_tmp20_ = _data_->buffer;
			_data_->_tmp20__length1 = _data_->buffer_length1;
			_data_->_tmp21_ = 0U;
			diorite_ipc_uint32_from_bytes (_data_->_tmp20_, _data_->_tmp20__length1, &_data_->_tmp21_, (guint) 0);
			_data_->message_size = (guint64) _data_->_tmp21_;
		}
		goto __finally13;
		__catch13_g_io_error:
		{
			_data_->e = _data_->_inner_error_;
			_data_->_inner_error_ = NULL;
			_data_->_tmp22_ = NULL;
			_data_->_tmp22_ = _data_->e;
			_data_->_tmp23_ = NULL;
			_data_->_tmp23_ = _data_->_tmp22_->message;
			_data_->_tmp24_ = NULL;
			_data_->_tmp24_ = g_error_new (DIORITE_IO_ERROR, DIORITE_IO_ERROR_READ, "Failed to read from socket. %s", _data_->_tmp23_);
			_data_->_inner_error_ = _data_->_tmp24_;
			_g_error_free0 (_data_->e);
			goto __finally13;
		}
		__finally13:
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
			_data_->real_buffer = (g_free (_data_->real_buffer), NULL);
			goto __finally12;
		}
		_data_->_tmp25_ = 0ULL;
		_data_->_tmp25_ = _data_->message_size;
		if (_data_->_tmp25_ == ((guint64) 0)) {
			_data_->_tmp26_ = NULL;
			_data_->_tmp26_ = g_error_new_literal (DIORITE_IO_ERROR, DIORITE_IO_ERROR_READ, "Empty message received.");
			_data_->_inner_error_ = _data_->_tmp26_;
			_data_->real_buffer = (g_free (_data_->real_buffer), NULL);
			goto __finally12;
		}
		_data_->bytes_read_total = (gsize) 0;
		while (TRUE) {
			_data_->_tmp27_ = 0UL;
			_data_->_tmp27_ = _data_->bytes_read_total;
			_data_->_tmp28_ = 0ULL;
			_data_->_tmp28_ = _data_->message_size;
			if (!(((guint64) _data_->_tmp27_) < _data_->_tmp28_)) {
				break;
			}
			{
				_data_->_tmp29_ = 0ULL;
				_data_->_tmp29_ = _data_->message_size;
				_data_->_tmp30_ = 0UL;
				_data_->_tmp30_ = _data_->bytes_read_total;
				_data_->_tmp31_ = 0;
				_data_->_tmp31_ = MIN ((gint) (_data_->_tmp29_ - _data_->_tmp30_), DIORITE_IPC_MESSAGE_BUFSIZE);
				_data_->buffer_length1 = _data_->_tmp31_;
				_data_->_tmp32_ = 0;
				_data_->_tmp32_ = _data_->buffer_length1;
				_data_->_tmp34_ = NULL;
				_data_->_tmp34_ = _data_->in_stream;
				_data_->_tmp35_ = NULL;
				_data_->_tmp35__length1 = 0;
				_data_->_tmp35_ = _data_->buffer;
				_data_->_tmp35__length1 = _data_->buffer_length1;
				_data_->_tmp36_ = NULL;
				_data_->_tmp36_ = _data_->_data1_->cancellable;
				_data_->_state_ = 2;
				g_input_stream_read_async (_data_->_tmp34_, _data_->_tmp35_, (gsize) _data_->_tmp35__length1, G_PRIORITY_DEFAULT, _data_->_tmp36_, diorite_ipc_channel_read_bytes_async_ready, _data_);
				return FALSE;
				_state_2:
				_data_->_tmp37_ = 0L;
				_data_->_tmp37_ = g_input_stream_read_finish (_data_->_tmp34_, _data_->_res_, &_data_->_inner_error_);
				_data_->_tmp33_ = _data_->_tmp37_;
				if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
					if (_data_->_inner_error_->domain == G_IO_ERROR) {
						goto __catch14_g_io_error;
					}
					_data_->real_buffer = (g_free (_data_->real_buffer), NULL);
					{
						_data_->_tmp38_ = 0U;
						_data_->_tmp38_ = _data_->_data1_->cancel_id;
						if (_data_->_tmp38_ != ((guint) 0)) {
							_data_->_tmp39_ = 0U;
							_data_->_tmp39_ = _data_->_data1_->cancel_id;
							g_source_remove (_data_->_tmp39_);
						}
					}
					block1_data_unref (_data_->_data1_);
					_data_->_data1_ = NULL;
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
					g_clear_error (&_data_->_inner_error_);
					return FALSE;
				}
				_data_->bytes_read = (gsize) _data_->_tmp33_;
			}
			goto __finally14;
			__catch14_g_io_error:
			{
				_data_->_vala1_e = _data_->_inner_error_;
				_data_->_inner_error_ = NULL;
				_data_->_tmp40_ = NULL;
				_data_->_tmp40_ = _data_->_vala1_e;
				_data_->_tmp41_ = NULL;
				_data_->_tmp41_ = _data_->_tmp40_->message;
				_data_->_tmp42_ = NULL;
				_data_->_tmp42_ = g_error_new (DIORITE_IO_ERROR, DIORITE_IO_ERROR_READ, "Failed to read from socket. %s", _data_->_tmp41_);
				_data_->_inner_error_ = _data_->_tmp42_;
				_g_error_free0 (_data_->_vala1_e);
				goto __finally14;
			}
			__finally14:
			if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
				_data_->real_buffer = (g_free (_data_->real_buffer), NULL);
				goto __finally12;
			}
			_data_->_tmp43_ = 0UL;
			_data_->_tmp43_ = _data_->bytes_read;
			_data_->buffer_length1 = (gint) _data_->_tmp43_;
			_data_->_tmp44_ = 0;
			_data_->_tmp44_ = _data_->buffer_length1;
			_data_->_tmp45_ = NULL;
			_data_->_tmp45_ = _data_->bytes;
			_data_->_tmp46_ = NULL;
			_data_->_tmp46__length1 = 0;
			_data_->_tmp46_ = _data_->buffer;
			_data_->_tmp46__length1 = _data_->buffer_length1;
			g_byte_array_append (_data_->_tmp45_, _data_->_tmp46_, _data_->_tmp46__length1);
			_data_->_tmp47_ = 0UL;
			_data_->_tmp47_ = _data_->bytes_read_total;
			_data_->_tmp48_ = 0UL;
			_data_->_tmp48_ = _data_->bytes_read;
			_data_->bytes_read_total = _data_->_tmp47_ + _data_->_tmp48_;
		}
		_data_->real_buffer = (g_free (_data_->real_buffer), NULL);
	}
	__finally12:
	{
		_data_->_tmp49_ = 0U;
		_data_->_tmp49_ = _data_->_data1_->cancel_id;
		if (_data_->_tmp49_ != ((guint) 0)) {
			_data_->_tmp50_ = 0U;
			_data_->_tmp50_ = _data_->_data1_->cancel_id;
			g_source_remove (_data_->_tmp50_);
		}
	}
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
		if (_data_->_inner_error_->domain == DIORITE_IO_ERROR) {
			g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
			g_error_free (_data_->_inner_error_);
			block1_data_unref (_data_->_data1_);
			_data_->_data1_ = NULL;
			if (_data_->_state_ == 0) {
				g_simple_async_result_complete_in_idle (_data_->_async_result);
			} else {
				g_simple_async_result_complete (_data_->_async_result);
			}
			g_object_unref (_data_->_async_result);
			return FALSE;
		} else {
			block1_data_unref (_data_->_data1_);
			_data_->_data1_ = NULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
			g_clear_error (&_data_->_inner_error_);
			return FALSE;
		}
	}
	block1_data_unref (_data_->_data1_);
	_data_->_data1_ = NULL;
	if (_data_->_state_ == 0) {
		g_simple_async_result_complete_in_idle (_data_->_async_result);
	} else {
		g_simple_async_result_complete (_data_->_async_result);
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


void diorite_ipc_channel_check_connected (DioriteIpcChannel* self, GError** error) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = diorite_ipc_channel_get_connected (self);
	_tmp1_ = _tmp0_;
	if (!_tmp1_) {
		GError* _tmp2_ = NULL;
		_tmp2_ = g_error_new_literal (DIORITE_IO_ERROR, DIORITE_IO_ERROR_NOT_CONNECTED, "Not connected.");
		_inner_error_ = _tmp2_;
		if (_inner_error_->domain == DIORITE_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


gsize diorite_ipc_channel_get_max_message_size (void) {
	gsize result = 0UL;
	result = (gsize) (G_MAXUINT32 - sizeof (guint32));
	return result;
}


static gboolean diorite_ipc_channel_get_connected (DioriteIpcChannel* self) {
	gboolean result;
	gint _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->local_socket;
	result = _tmp0_ > (-1);
	return result;
}


gboolean diorite_ipc_channel_get_listening (DioriteIpcChannel* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_listening;
	result = _tmp0_;
	return result;
}


static void diorite_ipc_value_channel_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void diorite_ipc_value_channel_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		diorite_ipc_channel_unref (value->data[0].v_pointer);
	}
}


static void diorite_ipc_value_channel_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = diorite_ipc_channel_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer diorite_ipc_value_channel_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* diorite_ipc_value_channel_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		DioriteIpcChannel* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = diorite_ipc_channel_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* diorite_ipc_value_channel_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	DioriteIpcChannel** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = diorite_ipc_channel_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* diorite_ipc_param_spec_channel (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	DioriteIpcParamSpecChannel* spec;
	g_return_val_if_fail (g_type_is_a (object_type, DIORITE_IPC_TYPE_CHANNEL), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer diorite_ipc_value_get_channel (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIORITE_IPC_TYPE_CHANNEL), NULL);
	return value->data[0].v_pointer;
}


void diorite_ipc_value_set_channel (GValue* value, gpointer v_object) {
	DioriteIpcChannel* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIORITE_IPC_TYPE_CHANNEL));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIORITE_IPC_TYPE_CHANNEL));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		diorite_ipc_channel_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		diorite_ipc_channel_unref (old);
	}
}


void diorite_ipc_value_take_channel (GValue* value, gpointer v_object) {
	DioriteIpcChannel* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIORITE_IPC_TYPE_CHANNEL));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIORITE_IPC_TYPE_CHANNEL));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		diorite_ipc_channel_unref (old);
	}
}


static void diorite_ipc_channel_class_init (DioriteIpcChannelClass * klass) {
	diorite_ipc_channel_parent_class = g_type_class_peek_parent (klass);
	((DioriteIpcChannelClass *) klass)->finalize = diorite_ipc_channel_finalize;
	g_type_class_add_private (klass, sizeof (DioriteIpcChannelPrivate));
}


static void diorite_ipc_channel_instance_init (DioriteIpcChannel * self) {
	self->priv = DIORITE_IPC_CHANNEL_GET_PRIVATE (self);
	self->priv->_listening = FALSE;
	self->priv->local_socket = -1;
	self->priv->remote_socket = -1;
	self->ref_count = 1;
}


static void diorite_ipc_channel_finalize (DioriteIpcChannel* obj) {
	DioriteIpcChannel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIORITE_IPC_TYPE_CHANNEL, DioriteIpcChannel);
	g_signal_handlers_destroy (self);
	_g_free0 (self->priv->name);
	_g_free0 (self->priv->path);
}


GType diorite_ipc_channel_get_type (void) {
	static volatile gsize diorite_ipc_channel_type_id__volatile = 0;
	if (g_once_init_enter (&diorite_ipc_channel_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { diorite_ipc_value_channel_init, diorite_ipc_value_channel_free_value, diorite_ipc_value_channel_copy_value, diorite_ipc_value_channel_peek_pointer, "p", diorite_ipc_value_channel_collect_value, "p", diorite_ipc_value_channel_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DioriteIpcChannelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) diorite_ipc_channel_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DioriteIpcChannel), 0, (GInstanceInitFunc) diorite_ipc_channel_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType diorite_ipc_channel_type_id;
		diorite_ipc_channel_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DioriteIpcChannel", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&diorite_ipc_channel_type_id__volatile, diorite_ipc_channel_type_id);
	}
	return diorite_ipc_channel_type_id__volatile;
}


gpointer diorite_ipc_channel_ref (gpointer instance) {
	DioriteIpcChannel* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void diorite_ipc_channel_unref (gpointer instance) {
	DioriteIpcChannel* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		DIORITE_IPC_CHANNEL_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


gchar* get_last_error_msg (void) {
	gchar* result = NULL;
	gint last_error = 0;
	gint _tmp0_ = 0;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	_tmp0_ = errno;
	last_error = _tmp0_;
	_tmp1_ = strerror (last_error);
	_tmp2_ = g_strdup_printf ("Error %d: %s", last_error, _tmp1_);
	result = _tmp2_;
	return result;
}



