/* ipcclient.c generated by valac 0.29.1, the Vala compiler
 * generated from ipcclient.vala, do not modify */

/*
 * Copyright 2014 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gobject/gvaluecollector.h>


#define DIORITE_IPC_TYPE_CLIENT (diorite_ipc_client_get_type ())
#define DIORITE_IPC_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITE_IPC_TYPE_CLIENT, DioriteIpcClient))
#define DIORITE_IPC_CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITE_IPC_TYPE_CLIENT, DioriteIpcClientClass))
#define DIORITE_IPC_IS_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITE_IPC_TYPE_CLIENT))
#define DIORITE_IPC_IS_CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITE_IPC_TYPE_CLIENT))
#define DIORITE_IPC_CLIENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITE_IPC_TYPE_CLIENT, DioriteIpcClientClass))

typedef struct _DioriteIpcClient DioriteIpcClient;
typedef struct _DioriteIpcClientClass DioriteIpcClientClass;
typedef struct _DioriteIpcClientPrivate DioriteIpcClientPrivate;

#define DIORITE_IPC_TYPE_CHANNEL (diorite_ipc_channel_get_type ())
#define DIORITE_IPC_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITE_IPC_TYPE_CHANNEL, DioriteIpcChannel))
#define DIORITE_IPC_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITE_IPC_TYPE_CHANNEL, DioriteIpcChannelClass))
#define DIORITE_IPC_IS_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITE_IPC_TYPE_CHANNEL))
#define DIORITE_IPC_IS_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITE_IPC_TYPE_CHANNEL))
#define DIORITE_IPC_CHANNEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITE_IPC_TYPE_CHANNEL, DioriteIpcChannelClass))

typedef struct _DioriteIpcChannel DioriteIpcChannel;
typedef struct _DioriteIpcChannelClass DioriteIpcChannelClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _diorite_ipc_channel_unref0(var) ((var == NULL) ? NULL : (var = (diorite_ipc_channel_unref (var), NULL)))
#define _g_byte_array_unref0(var) ((var == NULL) ? NULL : (var = (g_byte_array_unref (var), NULL)))
#define _diorite_ipc_client_unref0(var) ((var == NULL) ? NULL : (var = (diorite_ipc_client_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _DioriteIpcClientSendAsyncData DioriteIpcClientSendAsyncData;
typedef struct _DioriteIpcParamSpecClient DioriteIpcParamSpecClient;

struct _DioriteIpcClient {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DioriteIpcClientPrivate * priv;
};

struct _DioriteIpcClientClass {
	GTypeClass parent_class;
	void (*finalize) (DioriteIpcClient *self);
};

struct _DioriteIpcClientPrivate {
	gchar* _name;
	DioriteIpcChannel* channel;
	guint timeout;
};

typedef enum  {
	DIORITE_IO_ERROR_CONN_FAILED,
	DIORITE_IO_ERROR_TIMEOUT,
	DIORITE_IO_ERROR_RW_FAILED,
	DIORITE_IO_ERROR_READ,
	DIORITE_IO_ERROR_WRITE,
	DIORITE_IO_ERROR_TOO_MANY_DATA,
	DIORITE_IO_ERROR_NOT_CONNECTED,
	DIORITE_IO_ERROR_OP_FAILED
} DioriteIOError;
#define DIORITE_IO_ERROR diorite_io_error_quark ()
struct _DioriteIpcClientSendAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	DioriteIpcClient* self;
	GByteArray* request;
	GByteArray* response;
	GSocketConnection* connection;
	DioriteIpcChannel* _tmp0_;
	GSocketConnection* _tmp1_;
	GDataOutputStream* out_stream;
	GSocketConnection* _tmp2_;
	GOutputStream* _tmp3_;
	GOutputStream* _tmp4_;
	GDataOutputStream* _tmp5_;
	DioriteIpcChannel* _tmp6_;
	GDataOutputStream* _tmp7_;
	GByteArray* _tmp8_;
	GDataInputStream* in_stream;
	GSocketConnection* _tmp9_;
	GInputStream* _tmp10_;
	GInputStream* _tmp11_;
	GDataInputStream* _tmp12_;
	DioriteIpcChannel* _tmp13_;
	GDataInputStream* _tmp14_;
	guint _tmp15_;
	GByteArray* _tmp16_;
	GError * _inner_error_;
};

struct _DioriteIpcParamSpecClient {
	GParamSpec parent_instance;
};


static gpointer diorite_ipc_client_parent_class = NULL;

gpointer diorite_ipc_client_ref (gpointer instance);
void diorite_ipc_client_unref (gpointer instance);
GParamSpec* diorite_ipc_param_spec_client (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void diorite_ipc_value_set_client (GValue* value, gpointer v_object);
void diorite_ipc_value_take_client (GValue* value, gpointer v_object);
gpointer diorite_ipc_value_get_client (const GValue* value);
GType diorite_ipc_client_get_type (void) G_GNUC_CONST;
gpointer diorite_ipc_channel_ref (gpointer instance);
void diorite_ipc_channel_unref (gpointer instance);
GParamSpec* diorite_ipc_param_spec_channel (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void diorite_ipc_value_set_channel (GValue* value, gpointer v_object);
void diorite_ipc_value_take_channel (GValue* value, gpointer v_object);
gpointer diorite_ipc_value_get_channel (const GValue* value);
GType diorite_ipc_channel_get_type (void) G_GNUC_CONST;
#define DIORITE_IPC_CLIENT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DIORITE_IPC_TYPE_CLIENT, DioriteIpcClientPrivate))
enum  {
	DIORITE_IPC_CLIENT_DUMMY_PROPERTY
};
DioriteIpcClient* diorite_ipc_client_new (const gchar* name, guint timeout);
DioriteIpcClient* diorite_ipc_client_construct (GType object_type, const gchar* name, guint timeout);
static void diorite_ipc_client_set_name (DioriteIpcClient* self, const gchar* value);
DioriteIpcChannel* diorite_ipc_channel_new (const gchar* name);
DioriteIpcChannel* diorite_ipc_channel_construct (GType object_type, const gchar* name);
GQuark diorite_io_error_quark (void);
void diorite_ipc_client_send (DioriteIpcClient* self, GByteArray* request, GByteArray** response, GError** error);
void diorite_ipc_channel_connect (DioriteIpcChannel* self, guint timeout, GError** error);
void diorite_ipc_channel_write_bytes (DioriteIpcChannel* self, GByteArray* bytes, GError** error);
void diorite_ipc_channel_read_bytes (DioriteIpcChannel* self, GByteArray** bytes, GError** error);
void diorite_ipc_channel_close (DioriteIpcChannel* self);
static void diorite_ipc_client_send_async_data_free (gpointer _data);
void diorite_ipc_client_send_async (DioriteIpcClient* self, GByteArray* request, GAsyncReadyCallback _callback_, gpointer _user_data_);
void diorite_ipc_client_send_finish (DioriteIpcClient* self, GAsyncResult* _res_, GByteArray** response, GError** error);
static gboolean diorite_ipc_client_send_async_co (DioriteIpcClientSendAsyncData* _data_);
GSocketConnection* diorite_ipc_channel_create_connection (DioriteIpcChannel* self, GCancellable* cancellable, GError** error);
void diorite_ipc_channel_write_bytes_async (DioriteIpcChannel* self, GOutputStream* out_stream, GByteArray* bytes, GAsyncReadyCallback _callback_, gpointer _user_data_);
void diorite_ipc_channel_write_bytes_finish (DioriteIpcChannel* self, GAsyncResult* _res_, GError** error);
static void diorite_ipc_client_send_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
void diorite_ipc_channel_read_bytes_async (DioriteIpcChannel* self, GInputStream* in_stream, guint timeout, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
void diorite_ipc_channel_read_bytes_finish (DioriteIpcChannel* self, GAsyncResult* _res_, GByteArray** bytes, GError** error);
const gchar* diorite_ipc_client_get_name (DioriteIpcClient* self);
static void diorite_ipc_client_finalize (DioriteIpcClient* obj);


DioriteIpcClient* diorite_ipc_client_construct (GType object_type, const gchar* name, guint timeout) {
	DioriteIpcClient* self = NULL;
	const gchar* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	const gchar* _tmp2_ = NULL;
	DioriteIpcChannel* _tmp3_ = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	self = (DioriteIpcClient*) g_type_create_instance (object_type);
	_tmp0_ = name;
	diorite_ipc_client_set_name (self, _tmp0_);
	_tmp1_ = timeout;
	self->priv->timeout = _tmp1_;
	_tmp2_ = name;
	_tmp3_ = diorite_ipc_channel_new (_tmp2_);
	_diorite_ipc_channel_unref0 (self->priv->channel);
	self->priv->channel = _tmp3_;
	return self;
}


DioriteIpcClient* diorite_ipc_client_new (const gchar* name, guint timeout) {
	return diorite_ipc_client_construct (DIORITE_IPC_TYPE_CLIENT, name, timeout);
}


void diorite_ipc_client_send (DioriteIpcClient* self, GByteArray* request, GByteArray** response, GError** error) {
	GByteArray* _vala_response = NULL;
	DioriteIpcChannel* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	DioriteIpcChannel* _tmp2_ = NULL;
	GByteArray* _tmp3_ = NULL;
	DioriteIpcChannel* _tmp4_ = NULL;
	GByteArray* _tmp5_ = NULL;
	DioriteIpcChannel* _tmp6_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (request != NULL);
	_g_byte_array_unref0 (_vala_response);
	_vala_response = NULL;
	_tmp0_ = self->priv->channel;
	_tmp1_ = self->priv->timeout;
	diorite_ipc_channel_connect (_tmp0_, _tmp1_, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DIORITE_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp2_ = self->priv->channel;
	_tmp3_ = request;
	diorite_ipc_channel_write_bytes (_tmp2_, _tmp3_, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DIORITE_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp4_ = self->priv->channel;
	diorite_ipc_channel_read_bytes (_tmp4_, &_tmp5_, &_inner_error_);
	_g_byte_array_unref0 (_vala_response);
	_vala_response = _tmp5_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DIORITE_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp6_ = self->priv->channel;
	diorite_ipc_channel_close (_tmp6_);
	if (response) {
		*response = _vala_response;
	} else {
		_g_byte_array_unref0 (_vala_response);
	}
}


static void diorite_ipc_client_send_async_data_free (gpointer _data) {
	DioriteIpcClientSendAsyncData* _data_;
	_data_ = _data;
	_g_byte_array_unref0 (_data_->request);
	_diorite_ipc_client_unref0 (_data_->self);
	g_slice_free (DioriteIpcClientSendAsyncData, _data_);
}


static gpointer _diorite_ipc_client_ref0 (gpointer self) {
	return self ? diorite_ipc_client_ref (self) : NULL;
}


static gpointer _g_byte_array_ref0 (gpointer self) {
	return self ? g_byte_array_ref (self) : NULL;
}


void diorite_ipc_client_send_async (DioriteIpcClient* self, GByteArray* request, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	DioriteIpcClientSendAsyncData* _data_;
	DioriteIpcClient* _tmp0_ = NULL;
	GByteArray* _tmp1_ = NULL;
	GByteArray* _tmp2_ = NULL;
	_data_ = g_slice_new0 (DioriteIpcClientSendAsyncData);
	_data_->_async_result = g_simple_async_result_new (NULL, _callback_, _user_data_, diorite_ipc_client_send_async);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, diorite_ipc_client_send_async_data_free);
	_tmp0_ = _diorite_ipc_client_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = request;
	_tmp2_ = _g_byte_array_ref0 (_tmp1_);
	_g_byte_array_unref0 (_data_->request);
	_data_->request = _tmp2_;
	diorite_ipc_client_send_async_co (_data_);
}


void diorite_ipc_client_send_finish (DioriteIpcClient* self, GAsyncResult* _res_, GByteArray** response, GError** error) {
	DioriteIpcClientSendAsyncData* _data_;
	if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (_res_), error)) {
		return;
	}
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
	if (response) {
		*response = _data_->response;
	} else {
		_g_byte_array_unref0 (_data_->response);
	}
	_data_->response = NULL;
}


static void diorite_ipc_client_send_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	DioriteIpcClientSendAsyncData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	diorite_ipc_client_send_async_co (_data_);
}


static gboolean diorite_ipc_client_send_async_co (DioriteIpcClientSendAsyncData* _data_) {
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = NULL;
	_data_->_tmp0_ = _data_->self->priv->channel;
	_data_->_tmp1_ = NULL;
	_data_->_tmp1_ = diorite_ipc_channel_create_connection (_data_->_tmp0_, NULL, &_data_->_inner_error_);
	_data_->connection = _data_->_tmp1_;
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
		if (_data_->_inner_error_->domain == DIORITE_IO_ERROR) {
			g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
			g_error_free (_data_->_inner_error_);
			if (_data_->_state_ == 0) {
				g_simple_async_result_complete_in_idle (_data_->_async_result);
			} else {
				g_simple_async_result_complete (_data_->_async_result);
			}
			g_object_unref (_data_->_async_result);
			return FALSE;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
			g_clear_error (&_data_->_inner_error_);
			return FALSE;
		}
	}
	_data_->_tmp2_ = NULL;
	_data_->_tmp2_ = _data_->connection;
	_data_->_tmp3_ = NULL;
	_data_->_tmp3_ = g_io_stream_get_output_stream ((GIOStream*) _data_->_tmp2_);
	_data_->_tmp4_ = NULL;
	_data_->_tmp4_ = _data_->_tmp3_;
	_data_->_tmp5_ = NULL;
	_data_->_tmp5_ = g_data_output_stream_new (_data_->_tmp4_);
	_data_->out_stream = _data_->_tmp5_;
	_data_->_tmp6_ = NULL;
	_data_->_tmp6_ = _data_->self->priv->channel;
	_data_->_tmp7_ = NULL;
	_data_->_tmp7_ = _data_->out_stream;
	_data_->_tmp8_ = NULL;
	_data_->_tmp8_ = _data_->request;
	_data_->_state_ = 1;
	diorite_ipc_channel_write_bytes_async (_data_->_tmp6_, (GOutputStream*) _data_->_tmp7_, _data_->_tmp8_, diorite_ipc_client_send_async_ready, _data_);
	return FALSE;
	_state_1:
	diorite_ipc_channel_write_bytes_finish (_data_->_tmp6_, _data_->_res_, &_data_->_inner_error_);
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
		if (_data_->_inner_error_->domain == DIORITE_IO_ERROR) {
			g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
			g_error_free (_data_->_inner_error_);
			_g_object_unref0 (_data_->out_stream);
			_g_object_unref0 (_data_->connection);
			if (_data_->_state_ == 0) {
				g_simple_async_result_complete_in_idle (_data_->_async_result);
			} else {
				g_simple_async_result_complete (_data_->_async_result);
			}
			g_object_unref (_data_->_async_result);
			return FALSE;
		} else {
			_g_object_unref0 (_data_->out_stream);
			_g_object_unref0 (_data_->connection);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
			g_clear_error (&_data_->_inner_error_);
			return FALSE;
		}
	}
	_data_->_tmp9_ = NULL;
	_data_->_tmp9_ = _data_->connection;
	_data_->_tmp10_ = NULL;
	_data_->_tmp10_ = g_io_stream_get_input_stream ((GIOStream*) _data_->_tmp9_);
	_data_->_tmp11_ = NULL;
	_data_->_tmp11_ = _data_->_tmp10_;
	_data_->_tmp12_ = NULL;
	_data_->_tmp12_ = g_data_input_stream_new (_data_->_tmp11_);
	_data_->in_stream = _data_->_tmp12_;
	_data_->_tmp13_ = NULL;
	_data_->_tmp13_ = _data_->self->priv->channel;
	_data_->_tmp14_ = NULL;
	_data_->_tmp14_ = _data_->in_stream;
	_data_->_tmp15_ = 0U;
	_data_->_tmp15_ = _data_->self->priv->timeout;
	_data_->_tmp16_ = NULL;
	_data_->_state_ = 2;
	diorite_ipc_channel_read_bytes_async (_data_->_tmp13_, (GInputStream*) _data_->_tmp14_, _data_->_tmp15_, NULL, diorite_ipc_client_send_async_ready, _data_);
	return FALSE;
	_state_2:
	diorite_ipc_channel_read_bytes_finish (_data_->_tmp13_, _data_->_res_, &_data_->_tmp16_, &_data_->_inner_error_);
	_g_byte_array_unref0 (_data_->response);
	_data_->response = _data_->_tmp16_;
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
		if (_data_->_inner_error_->domain == DIORITE_IO_ERROR) {
			g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
			g_error_free (_data_->_inner_error_);
			_g_object_unref0 (_data_->in_stream);
			_g_object_unref0 (_data_->out_stream);
			_g_object_unref0 (_data_->connection);
			if (_data_->_state_ == 0) {
				g_simple_async_result_complete_in_idle (_data_->_async_result);
			} else {
				g_simple_async_result_complete (_data_->_async_result);
			}
			g_object_unref (_data_->_async_result);
			return FALSE;
		} else {
			_g_object_unref0 (_data_->in_stream);
			_g_object_unref0 (_data_->out_stream);
			_g_object_unref0 (_data_->connection);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
			g_clear_error (&_data_->_inner_error_);
			return FALSE;
		}
	}
	_g_object_unref0 (_data_->in_stream);
	_g_object_unref0 (_data_->out_stream);
	_g_object_unref0 (_data_->connection);
	if (_data_->_state_ == 0) {
		g_simple_async_result_complete_in_idle (_data_->_async_result);
	} else {
		g_simple_async_result_complete (_data_->_async_result);
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


const gchar* diorite_ipc_client_get_name (DioriteIpcClient* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}


static void diorite_ipc_client_set_name (DioriteIpcClient* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_name);
	self->priv->_name = _tmp1_;
}


static void diorite_ipc_value_client_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void diorite_ipc_value_client_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		diorite_ipc_client_unref (value->data[0].v_pointer);
	}
}


static void diorite_ipc_value_client_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = diorite_ipc_client_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer diorite_ipc_value_client_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* diorite_ipc_value_client_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		DioriteIpcClient* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = diorite_ipc_client_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* diorite_ipc_value_client_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	DioriteIpcClient** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = diorite_ipc_client_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* diorite_ipc_param_spec_client (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	DioriteIpcParamSpecClient* spec;
	g_return_val_if_fail (g_type_is_a (object_type, DIORITE_IPC_TYPE_CLIENT), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer diorite_ipc_value_get_client (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIORITE_IPC_TYPE_CLIENT), NULL);
	return value->data[0].v_pointer;
}


void diorite_ipc_value_set_client (GValue* value, gpointer v_object) {
	DioriteIpcClient* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIORITE_IPC_TYPE_CLIENT));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIORITE_IPC_TYPE_CLIENT));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		diorite_ipc_client_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		diorite_ipc_client_unref (old);
	}
}


void diorite_ipc_value_take_client (GValue* value, gpointer v_object) {
	DioriteIpcClient* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIORITE_IPC_TYPE_CLIENT));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIORITE_IPC_TYPE_CLIENT));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		diorite_ipc_client_unref (old);
	}
}


static void diorite_ipc_client_class_init (DioriteIpcClientClass * klass) {
	diorite_ipc_client_parent_class = g_type_class_peek_parent (klass);
	((DioriteIpcClientClass *) klass)->finalize = diorite_ipc_client_finalize;
	g_type_class_add_private (klass, sizeof (DioriteIpcClientPrivate));
}


static void diorite_ipc_client_instance_init (DioriteIpcClient * self) {
	self->priv = DIORITE_IPC_CLIENT_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void diorite_ipc_client_finalize (DioriteIpcClient* obj) {
	DioriteIpcClient * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIORITE_IPC_TYPE_CLIENT, DioriteIpcClient);
	g_signal_handlers_destroy (self);
	_g_free0 (self->priv->_name);
	_diorite_ipc_channel_unref0 (self->priv->channel);
}


GType diorite_ipc_client_get_type (void) {
	static volatile gsize diorite_ipc_client_type_id__volatile = 0;
	if (g_once_init_enter (&diorite_ipc_client_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { diorite_ipc_value_client_init, diorite_ipc_value_client_free_value, diorite_ipc_value_client_copy_value, diorite_ipc_value_client_peek_pointer, "p", diorite_ipc_value_client_collect_value, "p", diorite_ipc_value_client_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DioriteIpcClientClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) diorite_ipc_client_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DioriteIpcClient), 0, (GInstanceInitFunc) diorite_ipc_client_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType diorite_ipc_client_type_id;
		diorite_ipc_client_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DioriteIpcClient", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&diorite_ipc_client_type_id__volatile, diorite_ipc_client_type_id);
	}
	return diorite_ipc_client_type_id__volatile;
}


gpointer diorite_ipc_client_ref (gpointer instance) {
	DioriteIpcClient* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void diorite_ipc_client_unref (gpointer instance) {
	DioriteIpcClient* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		DIORITE_IPC_CLIENT_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}



