/* ipcserver.c generated by valac 0.29.1, the Vala compiler
 * generated from ipcserver.vala, do not modify */

/*
 * Copyright 2014 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gobject/gvaluecollector.h>


#define DIORITE_IPC_TYPE_SERVER (diorite_ipc_server_get_type ())
#define DIORITE_IPC_SERVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITE_IPC_TYPE_SERVER, DioriteIpcServer))
#define DIORITE_IPC_SERVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITE_IPC_TYPE_SERVER, DioriteIpcServerClass))
#define DIORITE_IPC_IS_SERVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITE_IPC_TYPE_SERVER))
#define DIORITE_IPC_IS_SERVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITE_IPC_TYPE_SERVER))
#define DIORITE_IPC_SERVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITE_IPC_TYPE_SERVER, DioriteIpcServerClass))

typedef struct _DioriteIpcServer DioriteIpcServer;
typedef struct _DioriteIpcServerClass DioriteIpcServerClass;
typedef struct _DioriteIpcServerPrivate DioriteIpcServerPrivate;

#define DIORITE_IPC_TYPE_CHANNEL (diorite_ipc_channel_get_type ())
#define DIORITE_IPC_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITE_IPC_TYPE_CHANNEL, DioriteIpcChannel))
#define DIORITE_IPC_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITE_IPC_TYPE_CHANNEL, DioriteIpcChannelClass))
#define DIORITE_IPC_IS_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITE_IPC_TYPE_CHANNEL))
#define DIORITE_IPC_IS_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITE_IPC_TYPE_CHANNEL))
#define DIORITE_IPC_CHANNEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITE_IPC_TYPE_CHANNEL, DioriteIpcChannelClass))

typedef struct _DioriteIpcChannel DioriteIpcChannel;
typedef struct _DioriteIpcChannelClass DioriteIpcChannelClass;
#define _diorite_ipc_channel_unref0(var) ((var == NULL) ? NULL : (var = (diorite_ipc_channel_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _diorite_ipc_server_unref0(var) ((var == NULL) ? NULL : (var = (diorite_ipc_server_unref (var), NULL)))
#define _g_byte_array_unref0(var) ((var == NULL) ? NULL : (var = (g_byte_array_unref (var), NULL)))
typedef struct _DioriteIpcServerProcessConnectionData DioriteIpcServerProcessConnectionData;
typedef struct _DioriteIpcParamSpecServer DioriteIpcParamSpecServer;

typedef enum  {
	DIORITE_IO_ERROR_CONN_FAILED,
	DIORITE_IO_ERROR_TIMEOUT,
	DIORITE_IO_ERROR_RW_FAILED,
	DIORITE_IO_ERROR_READ,
	DIORITE_IO_ERROR_WRITE,
	DIORITE_IO_ERROR_TOO_MANY_DATA,
	DIORITE_IO_ERROR_NOT_CONNECTED,
	DIORITE_IO_ERROR_OP_FAILED
} DioriteIOError;
#define DIORITE_IO_ERROR diorite_io_error_quark ()
struct _DioriteIpcServer {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DioriteIpcServerPrivate * priv;
};

struct _DioriteIpcServerClass {
	GTypeClass parent_class;
	void (*finalize) (DioriteIpcServer *self);
	gboolean (*handle) (DioriteIpcServer* self, GByteArray* request, GByteArray** response);
	void (*async_error) (DioriteIpcServer* self, GError* e);
};

struct _DioriteIpcServerPrivate {
	DioriteIpcChannel* channel;
	guint _timeout;
	gchar* _name;
	GSocketService* service;
};

struct _DioriteIpcServerProcessConnectionData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	DioriteIpcServer* self;
	GSocketConnection* connection;
	GByteArray* request;
	GDataInputStream* in_stream;
	GSocketConnection* _tmp0_;
	GInputStream* _tmp1_;
	GInputStream* _tmp2_;
	GDataInputStream* _tmp3_;
	DioriteIpcChannel* _tmp4_;
	GDataInputStream* _tmp5_;
	guint _tmp6_;
	GByteArray* _tmp7_;
	GByteArray* response;
	GByteArray* _tmp8_;
	GByteArray* _tmp9_;
	gboolean _tmp10_;
	GByteArray* _tmp11_;
	GDataOutputStream* out_stream;
	GSocketConnection* _tmp12_;
	GOutputStream* _tmp13_;
	GOutputStream* _tmp14_;
	GDataOutputStream* _tmp15_;
	DioriteIpcChannel* _tmp16_;
	GDataOutputStream* _tmp17_;
	GByteArray* _tmp18_;
	GError * _inner_error_;
};

struct _DioriteIpcParamSpecServer {
	GParamSpec parent_instance;
};


static gpointer diorite_ipc_server_parent_class = NULL;
static gboolean diorite_ipc_server_log_comunication;
static gboolean diorite_ipc_server_log_comunication = FALSE;

gpointer diorite_ipc_server_ref (gpointer instance);
void diorite_ipc_server_unref (gpointer instance);
GParamSpec* diorite_ipc_param_spec_server (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void diorite_ipc_value_set_server (GValue* value, gpointer v_object);
void diorite_ipc_value_take_server (GValue* value, gpointer v_object);
gpointer diorite_ipc_value_get_server (const GValue* value);
GType diorite_ipc_server_get_type (void) G_GNUC_CONST;
GQuark diorite_io_error_quark (void);
gpointer diorite_ipc_channel_ref (gpointer instance);
void diorite_ipc_channel_unref (gpointer instance);
GParamSpec* diorite_ipc_param_spec_channel (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void diorite_ipc_value_set_channel (GValue* value, gpointer v_object);
void diorite_ipc_value_take_channel (GValue* value, gpointer v_object);
gpointer diorite_ipc_value_get_channel (const GValue* value);
GType diorite_ipc_channel_get_type (void) G_GNUC_CONST;
#define DIORITE_IPC_SERVER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DIORITE_IPC_TYPE_SERVER, DioriteIpcServerPrivate))
enum  {
	DIORITE_IPC_SERVER_DUMMY_PROPERTY
};
DioriteIpcServer* diorite_ipc_server_new (const gchar* name, guint timeout);
DioriteIpcServer* diorite_ipc_server_construct (GType object_type, const gchar* name, guint timeout);
static void diorite_ipc_server_set_name (DioriteIpcServer* self, const gchar* value);
void diorite_ipc_server_set_timeout (DioriteIpcServer* self, guint value);
DioriteIpcChannel* diorite_ipc_channel_new (const gchar* name);
DioriteIpcChannel* diorite_ipc_channel_construct (GType object_type, const gchar* name);
void diorite_ipc_server_start_service (DioriteIpcServer* self, GError** error);
GSocketService* diorite_ipc_channel_create_service (DioriteIpcChannel* self, GError** error);
static gboolean diorite_ipc_server_on_incoming (DioriteIpcServer* self, GSocketConnection* connection, GObject* source_object);
static gboolean _diorite_ipc_server_on_incoming_g_socket_service_incoming (GSocketService* _sender, GSocketConnection* connection, GObject* source_object, gpointer self);
void diorite_ipc_server_stop_service (DioriteIpcServer* self, GError** error);
static void diorite_ipc_server_process_connection (DioriteIpcServer* self, GSocketConnection* connection, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void diorite_ipc_server_process_connection_finish (DioriteIpcServer* self, GAsyncResult* _res_, GError** error);
static void diorite_ipc_server_on_process_incoming_done (DioriteIpcServer* self, GObject* o, GAsyncResult* _result_);
static void _diorite_ipc_server_on_process_incoming_done_gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self);
static void diorite_ipc_server_process_connection_data_free (gpointer _data);
static gboolean diorite_ipc_server_process_connection_co (DioriteIpcServerProcessConnectionData* _data_);
void diorite_ipc_channel_read_bytes_async (DioriteIpcChannel* self, GInputStream* in_stream, guint timeout, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
void diorite_ipc_channel_read_bytes_finish (DioriteIpcChannel* self, GAsyncResult* _res_, GByteArray** bytes, GError** error);
guint diorite_ipc_server_get_timeout (DioriteIpcServer* self);
static void diorite_ipc_server_process_connection_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
gboolean diorite_ipc_server_handle (DioriteIpcServer* self, GByteArray* request, GByteArray** response);
void diorite_ipc_channel_write_bytes_async (DioriteIpcChannel* self, GOutputStream* out_stream, GByteArray* bytes, GAsyncReadyCallback _callback_, gpointer _user_data_);
void diorite_ipc_channel_write_bytes_finish (DioriteIpcChannel* self, GAsyncResult* _res_, GError** error);
static gboolean diorite_ipc_server_real_handle (DioriteIpcServer* self, GByteArray* request, GByteArray** response);
gboolean diorite_ipc_server_get_listening (DioriteIpcServer* self);
gboolean diorite_ipc_channel_get_listening (DioriteIpcChannel* self);
const gchar* diorite_ipc_server_get_name (DioriteIpcServer* self);
static void diorite_ipc_server_real_async_error (DioriteIpcServer* self, GError* e);
static void diorite_ipc_server_finalize (DioriteIpcServer* obj);


DioriteIpcServer* diorite_ipc_server_construct (GType object_type, const gchar* name, guint timeout) {
	DioriteIpcServer* self = NULL;
	const gchar* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	const gchar* _tmp2_ = NULL;
	DioriteIpcChannel* _tmp3_ = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	self = (DioriteIpcServer*) g_type_create_instance (object_type);
	_tmp0_ = name;
	diorite_ipc_server_set_name (self, _tmp0_);
	_tmp1_ = timeout;
	diorite_ipc_server_set_timeout (self, _tmp1_);
	_tmp2_ = name;
	_tmp3_ = diorite_ipc_channel_new (_tmp2_);
	_diorite_ipc_channel_unref0 (self->priv->channel);
	self->priv->channel = _tmp3_;
	return self;
}


DioriteIpcServer* diorite_ipc_server_new (const gchar* name, guint timeout) {
	return diorite_ipc_server_construct (DIORITE_IPC_TYPE_SERVER, name, timeout);
}


static gboolean _diorite_ipc_server_on_incoming_g_socket_service_incoming (GSocketService* _sender, GSocketConnection* connection, GObject* source_object, gpointer self) {
	gboolean result;
	result = diorite_ipc_server_on_incoming ((DioriteIpcServer*) self, connection, source_object);
	return result;
}


void diorite_ipc_server_start_service (DioriteIpcServer* self, GError** error) {
	GSocketService* _tmp0_ = NULL;
	DioriteIpcChannel* _tmp1_ = NULL;
	GSocketService* _tmp2_ = NULL;
	GSocketService* _tmp3_ = NULL;
	GSocketService* _tmp4_ = NULL;
	GSocketService* _tmp5_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->channel;
	_tmp2_ = diorite_ipc_channel_create_service (_tmp1_, &_inner_error_);
	_tmp0_ = _tmp2_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DIORITE_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp3_ = _tmp0_;
	_tmp0_ = NULL;
	_g_object_unref0 (self->priv->service);
	self->priv->service = _tmp3_;
	_tmp4_ = self->priv->service;
	g_signal_connect (_tmp4_, "incoming", (GCallback) _diorite_ipc_server_on_incoming_g_socket_service_incoming, self);
	_tmp5_ = self->priv->service;
	g_socket_service_start (_tmp5_);
	_g_object_unref0 (_tmp0_);
}


void diorite_ipc_server_stop_service (DioriteIpcServer* self, GError** error) {
	GSocketService* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->service;
	if (_tmp0_ != NULL) {
		GSocketService* _tmp1_ = NULL;
		_tmp1_ = self->priv->service;
		g_socket_service_stop (_tmp1_);
		_g_object_unref0 (self->priv->service);
		self->priv->service = NULL;
	}
}


static void _diorite_ipc_server_on_process_incoming_done_gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self) {
	diorite_ipc_server_on_process_incoming_done ((DioriteIpcServer*) self, source_object, res);
	diorite_ipc_server_unref (self);
}


static gboolean diorite_ipc_server_on_incoming (DioriteIpcServer* self, GSocketConnection* connection, GObject* source_object) {
	gboolean result = FALSE;
	GSocketConnection* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (connection != NULL, FALSE);
	_tmp0_ = connection;
	diorite_ipc_server_process_connection (self, _tmp0_, _diorite_ipc_server_on_process_incoming_done_gasync_ready_callback, diorite_ipc_server_ref (self));
	result = TRUE;
	return result;
}


static void diorite_ipc_server_on_process_incoming_done (DioriteIpcServer* self, GObject* o, GAsyncResult* _result_) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (_result_ != NULL);
	{
		GAsyncResult* _tmp0_ = NULL;
		_tmp0_ = _result_;
		diorite_ipc_server_process_connection_finish (self, _tmp0_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == DIORITE_IO_ERROR) {
				goto __catch21_diorite_io_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	goto __finally21;
	__catch21_diorite_io_error:
	{
		GError* e = NULL;
		gboolean _tmp1_ = FALSE;
		GError* _tmp4_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp1_ = diorite_ipc_server_log_comunication;
		if (_tmp1_) {
			GError* _tmp2_ = NULL;
			const gchar* _tmp3_ = NULL;
			_tmp2_ = e;
			_tmp3_ = _tmp2_->message;
			g_debug ("ipcserver.vala:90: Connection processed with error: %s", _tmp3_);
		}
		_tmp4_ = e;
		g_signal_emit_by_name (self, "async-error", _tmp4_);
		_g_error_free0 (e);
	}
	__finally21:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void diorite_ipc_server_process_connection_data_free (gpointer _data) {
	DioriteIpcServerProcessConnectionData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->connection);
	_diorite_ipc_server_unref0 (_data_->self);
	g_slice_free (DioriteIpcServerProcessConnectionData, _data_);
}


static gpointer _diorite_ipc_server_ref0 (gpointer self) {
	return self ? diorite_ipc_server_ref (self) : NULL;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void diorite_ipc_server_process_connection (DioriteIpcServer* self, GSocketConnection* connection, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	DioriteIpcServerProcessConnectionData* _data_;
	DioriteIpcServer* _tmp0_ = NULL;
	GSocketConnection* _tmp1_ = NULL;
	GSocketConnection* _tmp2_ = NULL;
	_data_ = g_slice_new0 (DioriteIpcServerProcessConnectionData);
	_data_->_async_result = g_simple_async_result_new (NULL, _callback_, _user_data_, diorite_ipc_server_process_connection);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, diorite_ipc_server_process_connection_data_free);
	_tmp0_ = _diorite_ipc_server_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = connection;
	_tmp2_ = _g_object_ref0 (_tmp1_);
	_g_object_unref0 (_data_->connection);
	_data_->connection = _tmp2_;
	diorite_ipc_server_process_connection_co (_data_);
}


static void diorite_ipc_server_process_connection_finish (DioriteIpcServer* self, GAsyncResult* _res_, GError** error) {
	DioriteIpcServerProcessConnectionData* _data_;
	if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (_res_), error)) {
		return;
	}
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


static void diorite_ipc_server_process_connection_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	DioriteIpcServerProcessConnectionData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	diorite_ipc_server_process_connection_co (_data_);
}


static gboolean diorite_ipc_server_process_connection_co (DioriteIpcServerProcessConnectionData* _data_) {
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = NULL;
	_data_->_tmp0_ = _data_->connection;
	_data_->_tmp1_ = NULL;
	_data_->_tmp1_ = g_io_stream_get_input_stream ((GIOStream*) _data_->_tmp0_);
	_data_->_tmp2_ = NULL;
	_data_->_tmp2_ = _data_->_tmp1_;
	_data_->_tmp3_ = NULL;
	_data_->_tmp3_ = g_data_input_stream_new (_data_->_tmp2_);
	_data_->in_stream = _data_->_tmp3_;
	_data_->_tmp4_ = NULL;
	_data_->_tmp4_ = _data_->self->priv->channel;
	_data_->_tmp5_ = NULL;
	_data_->_tmp5_ = _data_->in_stream;
	_data_->_tmp6_ = 0U;
	_data_->_tmp6_ = _data_->self->priv->_timeout;
	_data_->_tmp7_ = NULL;
	_data_->_state_ = 1;
	diorite_ipc_channel_read_bytes_async (_data_->_tmp4_, (GInputStream*) _data_->_tmp5_, _data_->_tmp6_, NULL, diorite_ipc_server_process_connection_ready, _data_);
	return FALSE;
	_state_1:
	diorite_ipc_channel_read_bytes_finish (_data_->_tmp4_, _data_->_res_, &_data_->_tmp7_, &_data_->_inner_error_);
	_g_byte_array_unref0 (_data_->request);
	_data_->request = _data_->_tmp7_;
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
		if (_data_->_inner_error_->domain == DIORITE_IO_ERROR) {
			g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
			g_error_free (_data_->_inner_error_);
			_g_object_unref0 (_data_->in_stream);
			_g_byte_array_unref0 (_data_->request);
			if (_data_->_state_ == 0) {
				g_simple_async_result_complete_in_idle (_data_->_async_result);
			} else {
				g_simple_async_result_complete (_data_->_async_result);
			}
			g_object_unref (_data_->_async_result);
			return FALSE;
		} else {
			_g_object_unref0 (_data_->in_stream);
			_g_byte_array_unref0 (_data_->request);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
			g_clear_error (&_data_->_inner_error_);
			return FALSE;
		}
	}
	_data_->_tmp8_ = NULL;
	_data_->_tmp8_ = _data_->request;
	_data_->request = NULL;
	_data_->_tmp9_ = NULL;
	_data_->_tmp10_ = FALSE;
	_data_->_tmp10_ = diorite_ipc_server_handle (_data_->self, _data_->_tmp8_, &_data_->_tmp9_);
	_g_byte_array_unref0 (_data_->response);
	_data_->response = _data_->_tmp9_;
	if (!_data_->_tmp10_) {
		_data_->_tmp11_ = NULL;
		_data_->_tmp11_ = g_byte_array_new ();
		_g_byte_array_unref0 (_data_->response);
		_data_->response = _data_->_tmp11_;
	}
	_data_->_tmp12_ = NULL;
	_data_->_tmp12_ = _data_->connection;
	_data_->_tmp13_ = NULL;
	_data_->_tmp13_ = g_io_stream_get_output_stream ((GIOStream*) _data_->_tmp12_);
	_data_->_tmp14_ = NULL;
	_data_->_tmp14_ = _data_->_tmp13_;
	_data_->_tmp15_ = NULL;
	_data_->_tmp15_ = g_data_output_stream_new (_data_->_tmp14_);
	_data_->out_stream = _data_->_tmp15_;
	_data_->_tmp16_ = NULL;
	_data_->_tmp16_ = _data_->self->priv->channel;
	_data_->_tmp17_ = NULL;
	_data_->_tmp17_ = _data_->out_stream;
	_data_->_tmp18_ = NULL;
	_data_->_tmp18_ = _data_->response;
	_data_->_state_ = 2;
	diorite_ipc_channel_write_bytes_async (_data_->_tmp16_, (GOutputStream*) _data_->_tmp17_, _data_->_tmp18_, diorite_ipc_server_process_connection_ready, _data_);
	return FALSE;
	_state_2:
	diorite_ipc_channel_write_bytes_finish (_data_->_tmp16_, _data_->_res_, &_data_->_inner_error_);
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
		if (_data_->_inner_error_->domain == DIORITE_IO_ERROR) {
			g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
			g_error_free (_data_->_inner_error_);
			_g_object_unref0 (_data_->out_stream);
			_g_byte_array_unref0 (_data_->response);
			_g_object_unref0 (_data_->in_stream);
			_g_byte_array_unref0 (_data_->request);
			if (_data_->_state_ == 0) {
				g_simple_async_result_complete_in_idle (_data_->_async_result);
			} else {
				g_simple_async_result_complete (_data_->_async_result);
			}
			g_object_unref (_data_->_async_result);
			return FALSE;
		} else {
			_g_object_unref0 (_data_->out_stream);
			_g_byte_array_unref0 (_data_->response);
			_g_object_unref0 (_data_->in_stream);
			_g_byte_array_unref0 (_data_->request);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
			g_clear_error (&_data_->_inner_error_);
			return FALSE;
		}
	}
	_g_object_unref0 (_data_->out_stream);
	_g_byte_array_unref0 (_data_->response);
	_g_object_unref0 (_data_->in_stream);
	_g_byte_array_unref0 (_data_->request);
	if (_data_->_state_ == 0) {
		g_simple_async_result_complete_in_idle (_data_->_async_result);
	} else {
		g_simple_async_result_complete (_data_->_async_result);
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


static gboolean diorite_ipc_server_real_handle (DioriteIpcServer* self, GByteArray* request, GByteArray** response) {
	GByteArray* _vala_response = NULL;
	gboolean result = FALSE;
	GByteArray* _tmp0_ = NULL;
	g_return_val_if_fail (request != NULL, FALSE);
	_tmp0_ = request;
	request = NULL;
	_g_byte_array_unref0 (_vala_response);
	_vala_response = _tmp0_;
	result = TRUE;
	_g_byte_array_unref0 (request);
	if (response) {
		*response = _vala_response;
	} else {
		_g_byte_array_unref0 (_vala_response);
	}
	return result;
}


gboolean diorite_ipc_server_handle (DioriteIpcServer* self, GByteArray* request, GByteArray** response) {
	g_return_val_if_fail (self != NULL, FALSE);
	return DIORITE_IPC_SERVER_GET_CLASS (self)->handle (self, request, response);
}


gboolean diorite_ipc_server_get_listening (DioriteIpcServer* self) {
	gboolean result;
	DioriteIpcChannel* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->channel;
	_tmp1_ = diorite_ipc_channel_get_listening (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}


guint diorite_ipc_server_get_timeout (DioriteIpcServer* self) {
	guint result;
	guint _tmp0_ = 0U;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_timeout;
	result = _tmp0_;
	return result;
}


void diorite_ipc_server_set_timeout (DioriteIpcServer* self, guint value) {
	guint _tmp0_ = 0U;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_timeout = _tmp0_;
}


const gchar* diorite_ipc_server_get_name (DioriteIpcServer* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}


static void diorite_ipc_server_set_name (DioriteIpcServer* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_name);
	self->priv->_name = _tmp1_;
}


static void diorite_ipc_server_real_async_error (DioriteIpcServer* self, GError* e) {
	GError* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	_tmp0_ = e;
	_tmp1_ = _tmp0_->message;
	g_warning ("ipcserver.vala:72: Async IOError: %s", _tmp1_);
}


static void diorite_ipc_value_server_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void diorite_ipc_value_server_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		diorite_ipc_server_unref (value->data[0].v_pointer);
	}
}


static void diorite_ipc_value_server_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = diorite_ipc_server_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer diorite_ipc_value_server_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* diorite_ipc_value_server_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		DioriteIpcServer* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = diorite_ipc_server_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* diorite_ipc_value_server_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	DioriteIpcServer** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = diorite_ipc_server_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* diorite_ipc_param_spec_server (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	DioriteIpcParamSpecServer* spec;
	g_return_val_if_fail (g_type_is_a (object_type, DIORITE_IPC_TYPE_SERVER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer diorite_ipc_value_get_server (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIORITE_IPC_TYPE_SERVER), NULL);
	return value->data[0].v_pointer;
}


void diorite_ipc_value_set_server (GValue* value, gpointer v_object) {
	DioriteIpcServer* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIORITE_IPC_TYPE_SERVER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIORITE_IPC_TYPE_SERVER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		diorite_ipc_server_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		diorite_ipc_server_unref (old);
	}
}


void diorite_ipc_value_take_server (GValue* value, gpointer v_object) {
	DioriteIpcServer* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIORITE_IPC_TYPE_SERVER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIORITE_IPC_TYPE_SERVER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		diorite_ipc_server_unref (old);
	}
}


static void diorite_ipc_server_class_init (DioriteIpcServerClass * klass) {
	const gchar* _tmp0_ = NULL;
	diorite_ipc_server_parent_class = g_type_class_peek_parent (klass);
	((DioriteIpcServerClass *) klass)->finalize = diorite_ipc_server_finalize;
	g_type_class_add_private (klass, sizeof (DioriteIpcServerPrivate));
	((DioriteIpcServerClass *) klass)->handle = diorite_ipc_server_real_handle;
	((DioriteIpcServerClass *) klass)->async_error = diorite_ipc_server_real_async_error;
	g_signal_new ("async_error", DIORITE_IPC_TYPE_SERVER, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DioriteIpcServerClass, async_error), NULL, NULL, g_cclosure_marshal_VOID__POINTER, G_TYPE_NONE, 1, G_TYPE_POINTER);
	_tmp0_ = g_getenv ("DIORITE_LOG_IPC_SERVER");
	diorite_ipc_server_log_comunication = g_strcmp0 (_tmp0_, "yes") == 0;
}


static void diorite_ipc_server_instance_init (DioriteIpcServer * self) {
	self->priv = DIORITE_IPC_SERVER_GET_PRIVATE (self);
	self->priv->service = NULL;
	self->ref_count = 1;
}


static void diorite_ipc_server_finalize (DioriteIpcServer* obj) {
	DioriteIpcServer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIORITE_IPC_TYPE_SERVER, DioriteIpcServer);
	g_signal_handlers_destroy (self);
	_diorite_ipc_channel_unref0 (self->priv->channel);
	_g_free0 (self->priv->_name);
	_g_object_unref0 (self->priv->service);
}


GType diorite_ipc_server_get_type (void) {
	static volatile gsize diorite_ipc_server_type_id__volatile = 0;
	if (g_once_init_enter (&diorite_ipc_server_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { diorite_ipc_value_server_init, diorite_ipc_value_server_free_value, diorite_ipc_value_server_copy_value, diorite_ipc_value_server_peek_pointer, "p", diorite_ipc_value_server_collect_value, "p", diorite_ipc_value_server_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DioriteIpcServerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) diorite_ipc_server_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DioriteIpcServer), 0, (GInstanceInitFunc) diorite_ipc_server_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType diorite_ipc_server_type_id;
		diorite_ipc_server_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DioriteIpcServer", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&diorite_ipc_server_type_id__volatile, diorite_ipc_server_type_id);
	}
	return diorite_ipc_server_type_id__volatile;
}


gpointer diorite_ipc_server_ref (gpointer instance) {
	DioriteIpcServer* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void diorite_ipc_server_unref (gpointer instance) {
	DioriteIpcServer* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		DIORITE_IPC_SERVER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}



