/* logger.c generated by valac 0.29.1, the Vala compiler
 * generated from logger.vala, do not modify */

/*
 * Copyright 2011-2014 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <unistd.h>
#include <stdarg.h>
#include <gobject/gvaluecollector.h>


#define DIORITE_TYPE_LOGGER (diorite_logger_get_type ())
#define DIORITE_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITE_TYPE_LOGGER, DioriteLogger))
#define DIORITE_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITE_TYPE_LOGGER, DioriteLoggerClass))
#define DIORITE_IS_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITE_TYPE_LOGGER))
#define DIORITE_IS_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITE_TYPE_LOGGER))
#define DIORITE_LOGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITE_TYPE_LOGGER, DioriteLoggerClass))

typedef struct _DioriteLogger DioriteLogger;
typedef struct _DioriteLoggerClass DioriteLoggerClass;
typedef struct _DioriteLoggerPrivate DioriteLoggerPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _DioriteParamSpecLogger DioriteParamSpecLogger;

struct _DioriteLogger {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DioriteLoggerPrivate * priv;
};

struct _DioriteLoggerClass {
	GTypeClass parent_class;
	void (*finalize) (DioriteLogger *self);
};

struct _DioriteParamSpecLogger {
	GParamSpec parent_instance;
};


static gpointer diorite_logger_parent_class = NULL;
static GLogLevelFlags diorite_logger_display_level;
static GLogLevelFlags diorite_logger_display_level = 0;
static FILE* diorite_logger_output;
static GRecMutex __lock_diorite_logger_output = {0};
static FILE* diorite_logger_output = NULL;
static gboolean diorite_logger_colorful;
static gboolean diorite_logger_colorful = FALSE;
static gchar* diorite_logger_hint;
static gchar* diorite_logger_hint = NULL;

#define G_LOG_DOMAIN "DioriteGlib"
gpointer diorite_logger_ref (gpointer instance);
void diorite_logger_unref (gpointer instance);
GParamSpec* diorite_param_spec_logger (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void diorite_value_set_logger (GValue* value, gpointer v_object);
void diorite_value_take_logger (GValue* value, gpointer v_object);
gpointer diorite_value_get_logger (const GValue* value);
GType diorite_logger_get_type (void) G_GNUC_CONST;
enum  {
	DIORITE_LOGGER_DUMMY_PROPERTY
};
#define DIORITE_LOGGER_COLOR_FOREGROUND 30
#define DIORITE_LOGGER_COLOR_BACKGROUND 40
#define DIORITE_LOGGER_COLOR_BLACK 0
#define DIORITE_LOGGER_COLOR_RED 1
#define DIORITE_LOGGER_COLOR_GREEN 2
#define DIORITE_LOGGER_COLOR_YELLOW 3
#define DIORITE_LOGGER_COLOR_BLUE 4
#define DIORITE_LOGGER_COLOR_MAGENTA 5
#define DIORITE_LOGGER_COLOR_CYAN 6
#define DIORITE_LOGGER_COLOR_WHITE 7
void diorite_logger_init (FILE* output, GLogLevelFlags display_level, const gchar* hint);
gboolean diorite_logger_colors_supported (void);
static void diorite_logger_log_handler (const gchar* domain, GLogLevelFlags level, const gchar* message);
static void _diorite_logger_log_handler_glog_func (const gchar* log_domain, GLogLevelFlags log_levels, const gchar* message, gpointer self);
void diorite_logger_printf (const gchar* format, ...);
void diorite_logger_log (const gchar* line);
static void diorite_logger_print (const gchar* domain, GLogLevelFlags level, const gchar* message);
DioriteLogger* diorite_logger_new (void);
DioriteLogger* diorite_logger_construct (GType object_type);
static void diorite_logger_finalize (DioriteLogger* obj);


/**
 * Initializes new logger for GLib
 * 
 * @param output           output to write logger messages to (e. g. sys.stderr)
 * @param display_level    lowest log level to log
 */
static void _diorite_logger_log_handler_glog_func (const gchar* log_domain, GLogLevelFlags log_levels, const gchar* message, gpointer self) {
	diorite_logger_log_handler (log_domain, log_levels, message);
}


void diorite_logger_init (FILE* output, GLogLevelFlags display_level, const gchar* hint) {
	FILE* _tmp0_ = NULL;
	GLogLevelFlags _tmp1_ = 0;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp6_ = NULL;
	gchar* use_colors = NULL;
	const gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	const gchar* _tmp9_ = NULL;
	g_return_if_fail (output != NULL);
	_tmp0_ = output;
	diorite_logger_output = _tmp0_;
	_tmp1_ = display_level;
	diorite_logger_display_level = _tmp1_;
	_tmp3_ = hint;
	if (_tmp3_ != NULL) {
		const gchar* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		_tmp4_ = hint;
		_tmp5_ = g_strconcat (_tmp4_, ":", NULL);
		_g_free0 (_tmp2_);
		_tmp2_ = _tmp5_;
	} else {
		_g_free0 (_tmp2_);
		_tmp2_ = NULL;
	}
	_tmp6_ = g_strdup (_tmp2_);
	_g_free0 (diorite_logger_hint);
	diorite_logger_hint = _tmp6_;
	_tmp7_ = g_getenv ("DIORITE_LOGGER_USE_COLORS");
	_tmp8_ = g_strdup (_tmp7_);
	use_colors = _tmp8_;
	_tmp9_ = use_colors;
	if (g_strcmp0 (_tmp9_, "yes") == 0) {
		diorite_logger_colorful = TRUE;
	} else {
		const gchar* _tmp10_ = NULL;
		_tmp10_ = use_colors;
		if (g_strcmp0 (_tmp10_, "no") == 0) {
			diorite_logger_colorful = FALSE;
		} else {
			gboolean _tmp11_ = FALSE;
			const gchar* _tmp12_ = NULL;
			gboolean _tmp13_ = FALSE;
			_tmp11_ = diorite_logger_colors_supported ();
			diorite_logger_colorful = _tmp11_;
			_tmp13_ = diorite_logger_colorful;
			if (_tmp13_) {
				_tmp12_ = "yes";
			} else {
				_tmp12_ = "no";
			}
			g_setenv ("DIORITE_LOGGER_USE_COLORS", _tmp12_, FALSE);
		}
	}
	g_log_set_default_handler (_diorite_logger_log_handler_glog_func, NULL);
	_g_free0 (use_colors);
	_g_free0 (_tmp2_);
}


gboolean diorite_logger_colors_supported (void) {
	gboolean result = FALSE;
	FILE* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gboolean _tmp2_ = FALSE;
	_tmp0_ = diorite_logger_output;
	_tmp1_ = fileno (_tmp0_);
	_tmp2_ = isatty (_tmp1_);
	result = _tmp2_;
	return result;
}


/**
 * Prints message to log
 * 
 * @param format    message format
 */
void diorite_logger_printf (const gchar* format, ...) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (format != NULL);
	{
		FILE* _tmp0_ = NULL;
		_tmp0_ = diorite_logger_output;
		g_rec_mutex_lock (&__lock_diorite_logger_output);
		{
			const gchar* _tmp1_ = NULL;
			FILE* _tmp5_ = NULL;
			const gchar* _tmp6_ = NULL;
			va_list _tmp7_ = {0};
			FILE* _tmp8_ = NULL;
			FILE* _tmp9_ = NULL;
			_tmp1_ = diorite_logger_hint;
			if (_tmp1_ != NULL) {
				FILE* _tmp2_ = NULL;
				const gchar* _tmp3_ = NULL;
				FILE* _tmp4_ = NULL;
				_tmp2_ = diorite_logger_output;
				_tmp3_ = diorite_logger_hint;
				fputs (_tmp3_, _tmp2_);
				_tmp4_ = diorite_logger_output;
				fputc (' ', _tmp4_);
			}
			_tmp5_ = diorite_logger_output;
			_tmp6_ = format;
			va_start (_tmp7_, format);
			vfprintf (_tmp5_, _tmp6_, _tmp7_);
			va_end (_tmp7_);
			_tmp8_ = diorite_logger_output;
			fflush (_tmp8_);
			_tmp9_ = diorite_logger_output;
			fflush (_tmp9_);
		}
		__finally22:
		{
			FILE* _tmp10_ = NULL;
			_tmp10_ = diorite_logger_output;
			g_rec_mutex_unlock (&__lock_diorite_logger_output);
		}
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


/**
 * Prints line to log
 * 
 * @param line    line to log
 */
void diorite_logger_log (const gchar* line) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (line != NULL);
	{
		FILE* _tmp0_ = NULL;
		_tmp0_ = diorite_logger_output;
		g_rec_mutex_lock (&__lock_diorite_logger_output);
		{
			const gchar* _tmp1_ = NULL;
			FILE* _tmp5_ = NULL;
			const gchar* _tmp6_ = NULL;
			FILE* _tmp7_ = NULL;
			_tmp1_ = diorite_logger_hint;
			if (_tmp1_ != NULL) {
				FILE* _tmp2_ = NULL;
				const gchar* _tmp3_ = NULL;
				FILE* _tmp4_ = NULL;
				_tmp2_ = diorite_logger_output;
				_tmp3_ = diorite_logger_hint;
				fputs (_tmp3_, _tmp2_);
				_tmp4_ = diorite_logger_output;
				fputc (' ', _tmp4_);
			}
			_tmp5_ = diorite_logger_output;
			_tmp6_ = line;
			fputs (_tmp6_, _tmp5_);
			_tmp7_ = diorite_logger_output;
			fflush (_tmp7_);
		}
		__finally23:
		{
			FILE* _tmp8_ = NULL;
			_tmp8_ = diorite_logger_output;
			g_rec_mutex_unlock (&__lock_diorite_logger_output);
		}
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


static void diorite_logger_log_handler (const gchar* domain, GLogLevelFlags level, const gchar* message) {
	GLogLevelFlags _tmp0_ = 0;
	GLogLevelFlags _tmp1_ = 0;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	GLogLevelFlags _tmp4_ = 0;
	const gchar* _tmp5_ = NULL;
	GLogLevelFlags _tmp6_ = 0;
	g_return_if_fail (message != NULL);
	_tmp0_ = level;
	_tmp1_ = diorite_logger_display_level;
	if (_tmp0_ > _tmp1_) {
		return;
	}
	_tmp3_ = domain;
	_tmp2_ = _tmp3_;
	if (_tmp2_ == NULL) {
		_tmp2_ = "<unknown>";
	}
	_tmp4_ = level;
	_tmp5_ = message;
	diorite_logger_print (_tmp2_, _tmp4_, _tmp5_);
	_tmp6_ = level;
	switch ((gint) _tmp6_) {
		case G_LOG_LEVEL_ERROR:
		case 6:
		{
			const gchar* _tmp7_ = NULL;
			const gchar* _tmp8_ = NULL;
			GLogLevelFlags _tmp9_ = 0;
			_tmp8_ = domain;
			_tmp7_ = _tmp8_;
			if (_tmp7_ == NULL) {
				_tmp7_ = "<unknown>";
			}
			_tmp9_ = level;
			diorite_logger_print (_tmp7_, _tmp9_, "Application will be terminated.");
			break;
		}
		case G_LOG_LEVEL_CRITICAL:
		{
			const gchar* _tmp10_ = NULL;
			const gchar* _tmp11_ = NULL;
			GLogLevelFlags _tmp12_ = 0;
			_tmp11_ = domain;
			_tmp10_ = _tmp11_;
			if (_tmp10_ == NULL) {
				_tmp10_ = "<unknown>";
			}
			_tmp12_ = level;
			diorite_logger_print (_tmp10_, _tmp12_, "Application will not function properly.");
			break;
		}
		default:
		break;
	}
}


static void diorite_logger_print (const gchar* domain, GLogLevelFlags level, const gchar* message) {
	gchar* name = NULL;
	gchar* _tmp0_ = NULL;
	gint color = 0;
	GLogLevelFlags _tmp1_ = 0;
	const gchar* _tmp11_ = NULL;
	const gchar* _tmp12_ = NULL;
	gchar* hint = NULL;
	gchar* _tmp13_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (domain != NULL);
	g_return_if_fail (message != NULL);
	_tmp0_ = g_strdup ("");
	name = _tmp0_;
	color = -1;
	_tmp1_ = level;
	switch ((gint) _tmp1_) {
		case G_LOG_LEVEL_CRITICAL:
		{
			gchar* _tmp2_ = NULL;
			_tmp2_ = g_strdup ("CRITICAL");
			_g_free0 (name);
			name = _tmp2_;
			color = DIORITE_LOGGER_COLOR_RED;
			break;
		}
		case G_LOG_LEVEL_ERROR:
		case 6:
		{
			gchar* _tmp3_ = NULL;
			_tmp3_ = g_strdup ("ERROR");
			_g_free0 (name);
			name = _tmp3_;
			color = DIORITE_LOGGER_COLOR_RED;
			break;
		}
		case G_LOG_LEVEL_WARNING:
		{
			gchar* _tmp4_ = NULL;
			_tmp4_ = g_strdup ("WARNING");
			_g_free0 (name);
			name = _tmp4_;
			color = DIORITE_LOGGER_COLOR_YELLOW;
			break;
		}
		case G_LOG_LEVEL_MESSAGE:
		case G_LOG_LEVEL_INFO:
		{
			gchar* _tmp5_ = NULL;
			_tmp5_ = g_strdup ("INFO");
			_g_free0 (name);
			name = _tmp5_;
			color = DIORITE_LOGGER_COLOR_GREEN;
			break;
		}
		case G_LOG_LEVEL_DEBUG:
		{
			gchar* _tmp6_ = NULL;
			_tmp6_ = g_strdup ("DEBUG");
			_g_free0 (name);
			name = _tmp6_;
			color = DIORITE_LOGGER_COLOR_BLUE;
			break;
		}
		case G_LOG_LEVEL_MASK:
		{
			gchar* _tmp7_ = NULL;
			_tmp7_ = g_strdup ("MASK");
			_g_free0 (name);
			name = _tmp7_;
			break;
		}
		case G_LOG_FLAG_RECURSION:
		{
			gchar* _tmp8_ = NULL;
			_tmp8_ = g_strdup ("Recursion");
			_g_free0 (name);
			name = _tmp8_;
			break;
		}
		case G_LOG_FLAG_FATAL:
		{
			gchar* _tmp9_ = NULL;
			_tmp9_ = g_strdup ("Fatal");
			_g_free0 (name);
			name = _tmp9_;
			break;
		}
		default:
		{
			gchar* _tmp10_ = NULL;
			_tmp10_ = g_strdup ("Unknown");
			_g_free0 (name);
			name = _tmp10_;
			break;
		}
	}
	_tmp12_ = diorite_logger_hint;
	_tmp11_ = _tmp12_;
	if (_tmp11_ == NULL) {
		_tmp11_ = "";
	}
	_tmp13_ = g_strdup (_tmp11_);
	hint = _tmp13_;
	{
		FILE* _tmp14_ = NULL;
		_tmp14_ = diorite_logger_output;
		g_rec_mutex_lock (&__lock_diorite_logger_output);
		{
			gboolean _tmp15_ = FALSE;
			gboolean _tmp16_ = FALSE;
			FILE* _tmp29_ = NULL;
			_tmp16_ = diorite_logger_colorful;
			if (_tmp16_) {
				gint _tmp17_ = 0;
				_tmp17_ = color;
				_tmp15_ = _tmp17_ >= 0;
			} else {
				_tmp15_ = FALSE;
			}
			if (_tmp15_) {
				FILE* _tmp18_ = NULL;
				gint _tmp19_ = 0;
				const gchar* _tmp20_ = NULL;
				const gchar* _tmp21_ = NULL;
				const gchar* _tmp22_ = NULL;
				const gchar* _tmp23_ = NULL;
				_tmp18_ = diorite_logger_output;
				_tmp19_ = color;
				_tmp20_ = hint;
				_tmp21_ = name;
				_tmp22_ = domain;
				_tmp23_ = message;
				fprintf (_tmp18_, "\x1b[%dm[%s%-8s %5s]\x1b[0m %s\n", DIORITE_LOGGER_COLOR_FOREGROUND + _tmp19_, _tmp20_, _tmp21_, _tmp22_, _tmp23_);
			} else {
				FILE* _tmp24_ = NULL;
				const gchar* _tmp25_ = NULL;
				const gchar* _tmp26_ = NULL;
				const gchar* _tmp27_ = NULL;
				const gchar* _tmp28_ = NULL;
				_tmp24_ = diorite_logger_output;
				_tmp25_ = hint;
				_tmp26_ = name;
				_tmp27_ = domain;
				_tmp28_ = message;
				fprintf (_tmp24_, "[%s%-8s %5s] %s\n", _tmp25_, _tmp26_, _tmp27_, _tmp28_);
			}
			_tmp29_ = diorite_logger_output;
			fflush (_tmp29_);
		}
		__finally24:
		{
			FILE* _tmp30_ = NULL;
			_tmp30_ = diorite_logger_output;
			g_rec_mutex_unlock (&__lock_diorite_logger_output);
		}
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_free0 (hint);
			_g_free0 (name);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_g_free0 (hint);
	_g_free0 (name);
}


DioriteLogger* diorite_logger_construct (GType object_type) {
	DioriteLogger* self = NULL;
	self = (DioriteLogger*) g_type_create_instance (object_type);
	return self;
}


DioriteLogger* diorite_logger_new (void) {
	return diorite_logger_construct (DIORITE_TYPE_LOGGER);
}


static void diorite_value_logger_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void diorite_value_logger_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		diorite_logger_unref (value->data[0].v_pointer);
	}
}


static void diorite_value_logger_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = diorite_logger_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer diorite_value_logger_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* diorite_value_logger_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		DioriteLogger* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = diorite_logger_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* diorite_value_logger_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	DioriteLogger** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = diorite_logger_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* diorite_param_spec_logger (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	DioriteParamSpecLogger* spec;
	g_return_val_if_fail (g_type_is_a (object_type, DIORITE_TYPE_LOGGER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer diorite_value_get_logger (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIORITE_TYPE_LOGGER), NULL);
	return value->data[0].v_pointer;
}


void diorite_value_set_logger (GValue* value, gpointer v_object) {
	DioriteLogger* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIORITE_TYPE_LOGGER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIORITE_TYPE_LOGGER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		diorite_logger_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		diorite_logger_unref (old);
	}
}


void diorite_value_take_logger (GValue* value, gpointer v_object) {
	DioriteLogger* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIORITE_TYPE_LOGGER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIORITE_TYPE_LOGGER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		diorite_logger_unref (old);
	}
}


static void diorite_logger_class_init (DioriteLoggerClass * klass) {
	diorite_logger_parent_class = g_type_class_peek_parent (klass);
	((DioriteLoggerClass *) klass)->finalize = diorite_logger_finalize;
	g_rec_mutex_init (&__lock_diorite_logger_output);
}


static void diorite_logger_instance_init (DioriteLogger * self) {
	self->ref_count = 1;
}


static void diorite_logger_finalize (DioriteLogger* obj) {
	DioriteLogger * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIORITE_TYPE_LOGGER, DioriteLogger);
	g_signal_handlers_destroy (self);
}


/**
 * Logger for GLib
 */
GType diorite_logger_get_type (void) {
	static volatile gsize diorite_logger_type_id__volatile = 0;
	if (g_once_init_enter (&diorite_logger_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { diorite_value_logger_init, diorite_value_logger_free_value, diorite_value_logger_copy_value, diorite_value_logger_peek_pointer, "p", diorite_value_logger_collect_value, "p", diorite_value_logger_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DioriteLoggerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) diorite_logger_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DioriteLogger), 0, (GInstanceInitFunc) diorite_logger_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType diorite_logger_type_id;
		diorite_logger_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DioriteLogger", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&diorite_logger_type_id__volatile, diorite_logger_type_id);
	}
	return diorite_logger_type_id__volatile;
}


gpointer diorite_logger_ref (gpointer instance) {
	DioriteLogger* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void diorite_logger_unref (gpointer instance) {
	DioriteLogger* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		DIORITE_LOGGER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}



