/* storage.c generated by valac 0.29.1, the Vala compiler
 * generated from storage.vala, do not modify */

/*
 * Copyright 2011-2014 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>


#define DIORITE_TYPE_STORAGE (diorite_storage_get_type ())
#define DIORITE_STORAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITE_TYPE_STORAGE, DioriteStorage))
#define DIORITE_STORAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITE_TYPE_STORAGE, DioriteStorageClass))
#define DIORITE_IS_STORAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITE_TYPE_STORAGE))
#define DIORITE_IS_STORAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITE_TYPE_STORAGE))
#define DIORITE_STORAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITE_TYPE_STORAGE, DioriteStorageClass))

typedef struct _DioriteStorage DioriteStorage;
typedef struct _DioriteStorageClass DioriteStorageClass;
typedef struct _DioriteStoragePrivate DioriteStoragePrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define DIORITE_TYPE_XDG_STORAGE (diorite_xdg_storage_get_type ())
#define DIORITE_XDG_STORAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITE_TYPE_XDG_STORAGE, DioriteXdgStorage))
#define DIORITE_XDG_STORAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITE_TYPE_XDG_STORAGE, DioriteXdgStorageClass))
#define DIORITE_IS_XDG_STORAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITE_TYPE_XDG_STORAGE))
#define DIORITE_IS_XDG_STORAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITE_TYPE_XDG_STORAGE))
#define DIORITE_XDG_STORAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITE_TYPE_XDG_STORAGE, DioriteXdgStorageClass))

typedef struct _DioriteXdgStorage DioriteXdgStorage;
typedef struct _DioriteXdgStorageClass DioriteXdgStorageClass;
typedef struct _DioriteXdgStoragePrivate DioriteXdgStoragePrivate;

struct _DioriteStorage {
	GObject parent_instance;
	DioriteStoragePrivate * priv;
	GFile** _data_dirs;
	gint _data_dirs_length1;
};

struct _DioriteStorageClass {
	GObjectClass parent_class;
};

struct _DioriteStoragePrivate {
	GFile* _user_data_dir;
	GFile* _user_cache_dir;
	GFile* _user_config_dir;
};

struct _DioriteXdgStorage {
	DioriteStorage parent_instance;
	DioriteXdgStoragePrivate * priv;
};

struct _DioriteXdgStorageClass {
	DioriteStorageClass parent_class;
};


static gpointer diorite_storage_parent_class = NULL;
static gpointer diorite_xdg_storage_parent_class = NULL;

GType diorite_storage_get_type (void) G_GNUC_CONST;
#define DIORITE_STORAGE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DIORITE_TYPE_STORAGE, DioriteStoragePrivate))
enum  {
	DIORITE_STORAGE_DUMMY_PROPERTY,
	DIORITE_STORAGE_USER_DATA_DIR,
	DIORITE_STORAGE_USER_CACHE_DIR,
	DIORITE_STORAGE_USER_CONFIG_DIR
};
DioriteStorage* diorite_storage_new (const gchar* user_data_dir, gchar** data_dirs, int data_dirs_length1, const gchar* user_config_dir, const gchar* user_cache_dir);
DioriteStorage* diorite_storage_construct (GType object_type, const gchar* user_data_dir, gchar** data_dirs, int data_dirs_length1, const gchar* user_config_dir, const gchar* user_cache_dir);
void diorite_storage_set_user_data_dir (DioriteStorage* self, GFile* value);
void diorite_storage_set_user_config_dir (DioriteStorage* self, GFile* value);
void diorite_storage_set_user_cache_dir (DioriteStorage* self, GFile* value);
static void _vala_array_add1 (GFile*** array, int* length, int* size, GFile* value);
static GFile** _vala_array_dup1 (GFile** self, int length);
DioriteStorage* diorite_storage_get_child (DioriteStorage* self, const gchar* id);
static void _vala_array_add2 (gchar*** array, int* length, int* size, gchar* value);
GFile* diorite_storage_get_user_data_dir (DioriteStorage* self);
GFile* diorite_storage_get_user_config_dir (DioriteStorage* self);
GFile* diorite_storage_get_user_cache_dir (DioriteStorage* self);
GFile* diorite_storage_get_config_path (DioriteStorage* self, const gchar* path);
GFile* diorite_storage_get_cache_path (DioriteStorage* self, const gchar* path);
GFile* diorite_storage_get_data_path (DioriteStorage* self, const gchar* path);
GFile* diorite_storage_get_data_file (DioriteStorage* self, const gchar* name);
GFile** diorite_storage_get_data_dirs (DioriteStorage* self, int* result_length1);
static void _vala_array_add3 (GFile*** array, int* length, int* size, GFile* value);
static void diorite_storage_finalize (GObject* obj);
static void _vala_diorite_storage_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_diorite_storage_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
GType diorite_xdg_storage_get_type (void) G_GNUC_CONST;
enum  {
	DIORITE_XDG_STORAGE_DUMMY_PROPERTY
};
DioriteXdgStorage* diorite_xdg_storage_new (void);
DioriteXdgStorage* diorite_xdg_storage_construct (GType object_type);
DioriteXdgStorage* diorite_xdg_storage_new_for_project (const gchar* id, const gchar* user_suffix);
DioriteXdgStorage* diorite_xdg_storage_construct_for_project (GType object_type, const gchar* id, const gchar* user_suffix);
static void _vala_array_add4 (GFile*** array, int* length, int* size, GFile* value);
static GFile** _vala_array_dup2 (GFile** self, int length);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


/**
 * Creates new storage
 * 
 * @param user_data_dir      Directory for user's data
 * @param data_dirs          System data directories
 * @param user_config_dir    Directory for user's configuration
 * @param user_cache_dir     Directory for user's cached files
 */
static void _vala_array_add1 (GFile*** array, int* length, int* size, GFile* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GFile*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static GFile** _vala_array_dup1 (GFile** self, int length) {
	GFile** result;
	int i;
	result = g_new0 (GFile*, length + 1);
	for (i = 0; i < length; i++) {
		GFile* _tmp0_ = NULL;
		_tmp0_ = _g_object_ref0 (self[i]);
		result[i] = _tmp0_;
	}
	return result;
}


DioriteStorage* diorite_storage_construct (GType object_type, const gchar* user_data_dir, gchar** data_dirs, int data_dirs_length1, const gchar* user_config_dir, const gchar* user_cache_dir) {
	DioriteStorage * self = NULL;
	const gchar* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	GFile* _tmp4_ = NULL;
	GFile* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	GFile* _tmp7_ = NULL;
	GFile* _tmp8_ = NULL;
	GFile** _data_dirs = NULL;
	GFile** _tmp9_ = NULL;
	gint _data_dirs_length1 = 0;
	gint __data_dirs_size_ = 0;
	gchar** _tmp10_ = NULL;
	gint _tmp10__length1 = 0;
	GFile** _tmp15_ = NULL;
	gint _tmp15__length1 = 0;
	GFile** _tmp16_ = NULL;
	gint _tmp16__length1 = 0;
	g_return_val_if_fail (user_data_dir != NULL, NULL);
	g_return_val_if_fail (user_config_dir != NULL, NULL);
	g_return_val_if_fail (user_cache_dir != NULL, NULL);
	self = (DioriteStorage*) g_object_new (object_type, NULL);
	_tmp0_ = user_data_dir;
	_tmp1_ = g_file_new_for_path (_tmp0_);
	_tmp2_ = _tmp1_;
	diorite_storage_set_user_data_dir (self, _tmp2_);
	_g_object_unref0 (_tmp2_);
	_tmp3_ = user_config_dir;
	_tmp4_ = g_file_new_for_path (_tmp3_);
	_tmp5_ = _tmp4_;
	diorite_storage_set_user_config_dir (self, _tmp5_);
	_g_object_unref0 (_tmp5_);
	_tmp6_ = user_cache_dir;
	_tmp7_ = g_file_new_for_path (_tmp6_);
	_tmp8_ = _tmp7_;
	diorite_storage_set_user_cache_dir (self, _tmp8_);
	_g_object_unref0 (_tmp8_);
	_tmp9_ = g_new0 (GFile*, 0 + 1);
	_data_dirs = _tmp9_;
	_data_dirs_length1 = 0;
	__data_dirs_size_ = _data_dirs_length1;
	_tmp10_ = data_dirs;
	_tmp10__length1 = data_dirs_length1;
	{
		gchar** path_collection = NULL;
		gint path_collection_length1 = 0;
		gint _path_collection_size_ = 0;
		gint path_it = 0;
		path_collection = _tmp10_;
		path_collection_length1 = _tmp10__length1;
		for (path_it = 0; path_it < _tmp10__length1; path_it = path_it + 1) {
			gchar* _tmp11_ = NULL;
			gchar* path = NULL;
			_tmp11_ = g_strdup (path_collection[path_it]);
			path = _tmp11_;
			{
				GFile** _tmp12_ = NULL;
				gint _tmp12__length1 = 0;
				const gchar* _tmp13_ = NULL;
				GFile* _tmp14_ = NULL;
				_tmp12_ = _data_dirs;
				_tmp12__length1 = _data_dirs_length1;
				_tmp13_ = path;
				_tmp14_ = g_file_new_for_path (_tmp13_);
				_vala_array_add1 (&_data_dirs, &_data_dirs_length1, &__data_dirs_size_, _tmp14_);
				_g_free0 (path);
			}
		}
	}
	_tmp15_ = _data_dirs;
	_tmp15__length1 = _data_dirs_length1;
	_tmp16_ = (_tmp15_ != NULL) ? _vala_array_dup1 (_tmp15_, _tmp15__length1) : ((gpointer) _tmp15_);
	_tmp16__length1 = _tmp15__length1;
	self->_data_dirs = (_vala_array_free (self->_data_dirs, self->_data_dirs_length1, (GDestroyNotify) g_object_unref), NULL);
	self->_data_dirs = _tmp16_;
	self->_data_dirs_length1 = _tmp16__length1;
	_data_dirs = (_vala_array_free (_data_dirs, _data_dirs_length1, (GDestroyNotify) g_object_unref), NULL);
	return self;
}


DioriteStorage* diorite_storage_new (const gchar* user_data_dir, gchar** data_dirs, int data_dirs_length1, const gchar* user_config_dir, const gchar* user_cache_dir) {
	return diorite_storage_construct (DIORITE_TYPE_STORAGE, user_data_dir, data_dirs, data_dirs_length1, user_config_dir, user_cache_dir);
}


/**
 * Returns new child storage.
 * 
 * @param id    child storage id
 * @return      child storage 
 */
static void _vala_array_add2 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


DioriteStorage* diorite_storage_get_child (DioriteStorage* self, const gchar* id) {
	DioriteStorage* result = NULL;
	gchar** data_dirs = NULL;
	gchar** _tmp0_ = NULL;
	gint data_dirs_length1 = 0;
	gint _data_dirs_size_ = 0;
	GFile** _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	GFile* _tmp9_ = NULL;
	const gchar* _tmp10_ = NULL;
	GFile* _tmp11_ = NULL;
	GFile* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	gchar** _tmp15_ = NULL;
	gint _tmp15__length1 = 0;
	GFile* _tmp16_ = NULL;
	const gchar* _tmp17_ = NULL;
	GFile* _tmp18_ = NULL;
	GFile* _tmp19_ = NULL;
	gchar* _tmp20_ = NULL;
	gchar* _tmp21_ = NULL;
	GFile* _tmp22_ = NULL;
	const gchar* _tmp23_ = NULL;
	GFile* _tmp24_ = NULL;
	GFile* _tmp25_ = NULL;
	gchar* _tmp26_ = NULL;
	gchar* _tmp27_ = NULL;
	DioriteStorage* _tmp28_ = NULL;
	DioriteStorage* _tmp29_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (id != NULL, NULL);
	_tmp0_ = g_new0 (gchar*, 0 + 1);
	data_dirs = _tmp0_;
	data_dirs_length1 = 0;
	_data_dirs_size_ = data_dirs_length1;
	_tmp1_ = self->_data_dirs;
	_tmp1__length1 = self->_data_dirs_length1;
	{
		GFile** dir_collection = NULL;
		gint dir_collection_length1 = 0;
		gint _dir_collection_size_ = 0;
		gint dir_it = 0;
		dir_collection = _tmp1_;
		dir_collection_length1 = _tmp1__length1;
		for (dir_it = 0; dir_it < _tmp1__length1; dir_it = dir_it + 1) {
			GFile* _tmp2_ = NULL;
			GFile* dir = NULL;
			_tmp2_ = _g_object_ref0 (dir_collection[dir_it]);
			dir = _tmp2_;
			{
				gchar** _tmp3_ = NULL;
				gint _tmp3__length1 = 0;
				GFile* _tmp4_ = NULL;
				const gchar* _tmp5_ = NULL;
				GFile* _tmp6_ = NULL;
				GFile* _tmp7_ = NULL;
				gchar* _tmp8_ = NULL;
				_tmp3_ = data_dirs;
				_tmp3__length1 = data_dirs_length1;
				_tmp4_ = dir;
				_tmp5_ = id;
				_tmp6_ = g_file_get_child (_tmp4_, _tmp5_);
				_tmp7_ = _tmp6_;
				_tmp8_ = g_file_get_path (_tmp7_);
				_vala_array_add2 (&data_dirs, &data_dirs_length1, &_data_dirs_size_, _tmp8_);
				_g_object_unref0 (_tmp7_);
				_g_object_unref0 (dir);
			}
		}
	}
	_tmp9_ = self->priv->_user_data_dir;
	_tmp10_ = id;
	_tmp11_ = g_file_get_child (_tmp9_, _tmp10_);
	_tmp12_ = _tmp11_;
	_tmp13_ = g_file_get_path (_tmp12_);
	_tmp14_ = _tmp13_;
	_tmp15_ = data_dirs;
	_tmp15__length1 = data_dirs_length1;
	_tmp16_ = self->priv->_user_config_dir;
	_tmp17_ = id;
	_tmp18_ = g_file_get_child (_tmp16_, _tmp17_);
	_tmp19_ = _tmp18_;
	_tmp20_ = g_file_get_path (_tmp19_);
	_tmp21_ = _tmp20_;
	_tmp22_ = self->priv->_user_cache_dir;
	_tmp23_ = id;
	_tmp24_ = g_file_get_child (_tmp22_, _tmp23_);
	_tmp25_ = _tmp24_;
	_tmp26_ = g_file_get_path (_tmp25_);
	_tmp27_ = _tmp26_;
	_tmp28_ = diorite_storage_new (_tmp14_, _tmp15_, _tmp15__length1, _tmp21_, _tmp27_);
	_tmp29_ = _tmp28_;
	_g_free0 (_tmp27_);
	_g_object_unref0 (_tmp25_);
	_g_free0 (_tmp21_);
	_g_object_unref0 (_tmp19_);
	_g_free0 (_tmp14_);
	_g_object_unref0 (_tmp12_);
	result = _tmp29_;
	data_dirs = (_vala_array_free (data_dirs, data_dirs_length1, (GDestroyNotify) g_free), NULL);
	return result;
}


/**
 * Returns the default path of configuration file/directory with given name
 * 
 * @param path Name of configuration file/directory
 * @return default configuration path
 */
GFile* diorite_storage_get_config_path (DioriteStorage* self, const gchar* path) {
	GFile* result = NULL;
	GFile* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (path != NULL, NULL);
	_tmp0_ = self->priv->_user_config_dir;
	_tmp1_ = path;
	_tmp2_ = g_file_get_child (_tmp0_, _tmp1_);
	result = _tmp2_;
	return result;
}


/**
 * Returns the default path of cache file/directory with given name
 * 
 * @param path
 * @return default cache path
 */
GFile* diorite_storage_get_cache_path (DioriteStorage* self, const gchar* path) {
	GFile* result = NULL;
	GFile* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (path != NULL, NULL);
	_tmp0_ = self->priv->_user_cache_dir;
	_tmp1_ = path;
	_tmp2_ = g_file_get_child (_tmp0_, _tmp1_);
	result = _tmp2_;
	return result;
}


/**
 * Returns the default path of data dir/file with given name
 * 
 * @param path
 * @return default data path
 */
GFile* diorite_storage_get_data_path (DioriteStorage* self, const gchar* path) {
	GFile* result = NULL;
	GFile* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (path != NULL, NULL);
	_tmp0_ = self->priv->_user_data_dir;
	_tmp1_ = path;
	_tmp2_ = g_file_get_child (_tmp0_, _tmp1_);
	result = _tmp2_;
	return result;
}


/**
 * Looks for a file in data directories. User's data directory has a precedence
 * over system data directories.
 * 
 * @param name name of the file
 * @return file instance or null if no file has been found
 */
GFile* diorite_storage_get_data_file (DioriteStorage* self, const gchar* name) {
	GFile* result = NULL;
	GFile* f = NULL;
	GFile* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_ = NULL;
	GFileType _tmp4_ = 0;
	GFile** _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
	GFile** _tmp6_ = NULL;
	gint _tmp6__length1 = 0;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	_tmp0_ = self->priv->_user_data_dir;
	_tmp1_ = name;
	_tmp2_ = g_file_get_child (_tmp0_, _tmp1_);
	f = _tmp2_;
	_tmp3_ = f;
	_tmp4_ = g_file_query_file_type (_tmp3_, 0, NULL);
	if (_tmp4_ == G_FILE_TYPE_REGULAR) {
		result = f;
		return result;
	}
	_tmp5_ = diorite_storage_get_data_dirs (self, &_tmp5__length1);
	_tmp6_ = _tmp5_;
	_tmp6__length1 = _tmp5__length1;
	{
		GFile** dir_collection = NULL;
		gint dir_collection_length1 = 0;
		gint _dir_collection_size_ = 0;
		gint dir_it = 0;
		dir_collection = _tmp6_;
		dir_collection_length1 = _tmp6__length1;
		for (dir_it = 0; dir_it < _tmp6__length1; dir_it = dir_it + 1) {
			GFile* _tmp7_ = NULL;
			GFile* dir = NULL;
			_tmp7_ = _g_object_ref0 (dir_collection[dir_it]);
			dir = _tmp7_;
			{
				GFile* _tmp8_ = NULL;
				const gchar* _tmp9_ = NULL;
				GFile* _tmp10_ = NULL;
				GFile* _tmp11_ = NULL;
				GFileType _tmp12_ = 0;
				_tmp8_ = dir;
				_tmp9_ = name;
				_tmp10_ = g_file_get_child (_tmp8_, _tmp9_);
				_g_object_unref0 (f);
				f = _tmp10_;
				_tmp11_ = f;
				_tmp12_ = g_file_query_file_type (_tmp11_, 0, NULL);
				if (_tmp12_ == G_FILE_TYPE_REGULAR) {
					result = f;
					_g_object_unref0 (dir);
					dir_collection = (_vala_array_free (dir_collection, dir_collection_length1, (GDestroyNotify) g_object_unref), NULL);
					return result;
				}
				_g_object_unref0 (dir);
			}
		}
		dir_collection = (_vala_array_free (dir_collection, dir_collection_length1, (GDestroyNotify) g_object_unref), NULL);
	}
	result = NULL;
	_g_object_unref0 (f);
	return result;
}


GFile* diorite_storage_get_user_data_dir (DioriteStorage* self) {
	GFile* result;
	GFile* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_user_data_dir;
	result = _tmp0_;
	return result;
}


void diorite_storage_set_user_data_dir (DioriteStorage* self, GFile* value) {
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_user_data_dir);
	self->priv->_user_data_dir = _tmp1_;
	g_object_notify ((GObject *) self, "user-data-dir");
}


static void _vala_array_add3 (GFile*** array, int* length, int* size, GFile* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GFile*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


GFile** diorite_storage_get_data_dirs (DioriteStorage* self, int* result_length1) {
	GFile** result;
	GFile** dirs = NULL;
	GFile** _tmp0_ = NULL;
	gint dirs_length1 = 0;
	gint _dirs_size_ = 0;
	GFile** _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	GFile** _tmp8_ = NULL;
	gint _tmp8__length1 = 0;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_new0 (GFile*, 0 + 1);
	dirs = _tmp0_;
	dirs_length1 = 0;
	_dirs_size_ = dirs_length1;
	_tmp1_ = self->_data_dirs;
	_tmp1__length1 = self->_data_dirs_length1;
	{
		GFile** dir_collection = NULL;
		gint dir_collection_length1 = 0;
		gint _dir_collection_size_ = 0;
		gint dir_it = 0;
		dir_collection = _tmp1_;
		dir_collection_length1 = _tmp1__length1;
		for (dir_it = 0; dir_it < _tmp1__length1; dir_it = dir_it + 1) {
			GFile* _tmp2_ = NULL;
			GFile* dir = NULL;
			_tmp2_ = _g_object_ref0 (dir_collection[dir_it]);
			dir = _tmp2_;
			{
				GFile* _tmp3_ = NULL;
				GFileType _tmp4_ = 0;
				_tmp3_ = dir;
				_tmp4_ = g_file_query_file_type (_tmp3_, 0, NULL);
				if (_tmp4_ == G_FILE_TYPE_DIRECTORY) {
					GFile** _tmp5_ = NULL;
					gint _tmp5__length1 = 0;
					GFile* _tmp6_ = NULL;
					GFile* _tmp7_ = NULL;
					_tmp5_ = dirs;
					_tmp5__length1 = dirs_length1;
					_tmp6_ = dir;
					_tmp7_ = _g_object_ref0 (_tmp6_);
					_vala_array_add3 (&dirs, &dirs_length1, &_dirs_size_, _tmp7_);
				}
				_g_object_unref0 (dir);
			}
		}
	}
	_tmp8_ = dirs;
	_tmp8__length1 = dirs_length1;
	if (result_length1) {
		*result_length1 = _tmp8__length1;
	}
	result = _tmp8_;
	return result;
}


GFile* diorite_storage_get_user_cache_dir (DioriteStorage* self) {
	GFile* result;
	GFile* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_user_cache_dir;
	result = _tmp0_;
	return result;
}


void diorite_storage_set_user_cache_dir (DioriteStorage* self, GFile* value) {
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_user_cache_dir);
	self->priv->_user_cache_dir = _tmp1_;
	g_object_notify ((GObject *) self, "user-cache-dir");
}


GFile* diorite_storage_get_user_config_dir (DioriteStorage* self) {
	GFile* result;
	GFile* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_user_config_dir;
	result = _tmp0_;
	return result;
}


void diorite_storage_set_user_config_dir (DioriteStorage* self, GFile* value) {
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_user_config_dir);
	self->priv->_user_config_dir = _tmp1_;
	g_object_notify ((GObject *) self, "user-config-dir");
}


static void diorite_storage_class_init (DioriteStorageClass * klass) {
	diorite_storage_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DioriteStoragePrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_diorite_storage_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_diorite_storage_set_property;
	G_OBJECT_CLASS (klass)->finalize = diorite_storage_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIORITE_STORAGE_USER_DATA_DIR, g_param_spec_object ("user-data-dir", "User data dir", "Directory used to store user-specific data. Read-write access may be available.", G_TYPE_FILE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIORITE_STORAGE_USER_CACHE_DIR, g_param_spec_object ("user-cache-dir", "User cache dir", "Directory used to store user-specific cached data. Read-write access may be available.", G_TYPE_FILE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIORITE_STORAGE_USER_CONFIG_DIR, g_param_spec_object ("user-config-dir", "User configuration dir", "Directory used to store user-specific configuration data. Read-write access may be available.", G_TYPE_FILE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void diorite_storage_instance_init (DioriteStorage * self) {
	self->priv = DIORITE_STORAGE_GET_PRIVATE (self);
}


static void diorite_storage_finalize (GObject* obj) {
	DioriteStorage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIORITE_TYPE_STORAGE, DioriteStorage);
	_g_object_unref0 (self->priv->_user_data_dir);
	self->_data_dirs = (_vala_array_free (self->_data_dirs, self->_data_dirs_length1, (GDestroyNotify) g_object_unref), NULL);
	_g_object_unref0 (self->priv->_user_cache_dir);
	_g_object_unref0 (self->priv->_user_config_dir);
	G_OBJECT_CLASS (diorite_storage_parent_class)->finalize (obj);
}


/**
 * File storage abstraction that provides easy access to a set of common paths: user's data,
 * cache and configuration directories and system data directories.
 */
GType diorite_storage_get_type (void) {
	static volatile gsize diorite_storage_type_id__volatile = 0;
	if (g_once_init_enter (&diorite_storage_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DioriteStorageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) diorite_storage_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DioriteStorage), 0, (GInstanceInitFunc) diorite_storage_instance_init, NULL };
		GType diorite_storage_type_id;
		diorite_storage_type_id = g_type_register_static (G_TYPE_OBJECT, "DioriteStorage", &g_define_type_info, 0);
		g_once_init_leave (&diorite_storage_type_id__volatile, diorite_storage_type_id);
	}
	return diorite_storage_type_id__volatile;
}


static void _vala_diorite_storage_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DioriteStorage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DIORITE_TYPE_STORAGE, DioriteStorage);
	switch (property_id) {
		case DIORITE_STORAGE_USER_DATA_DIR:
		g_value_set_object (value, diorite_storage_get_user_data_dir (self));
		break;
		case DIORITE_STORAGE_USER_CACHE_DIR:
		g_value_set_object (value, diorite_storage_get_user_cache_dir (self));
		break;
		case DIORITE_STORAGE_USER_CONFIG_DIR:
		g_value_set_object (value, diorite_storage_get_user_config_dir (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_diorite_storage_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	DioriteStorage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DIORITE_TYPE_STORAGE, DioriteStorage);
	switch (property_id) {
		case DIORITE_STORAGE_USER_DATA_DIR:
		diorite_storage_set_user_data_dir (self, g_value_get_object (value));
		break;
		case DIORITE_STORAGE_USER_CACHE_DIR:
		diorite_storage_set_user_cache_dir (self, g_value_get_object (value));
		break;
		case DIORITE_STORAGE_USER_CONFIG_DIR:
		diorite_storage_set_user_config_dir (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


/**
 * Creates new storage with XGD paths.
 */
DioriteXdgStorage* diorite_xdg_storage_construct (GType object_type) {
	DioriteXdgStorage * self = NULL;
	const gchar* _tmp0_ = NULL;
	gchar** _tmp1_ = NULL;
	gchar** _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	_tmp0_ = g_get_user_data_dir ();
	_tmp2_ = _tmp1_ = g_get_system_data_dirs ();
	_tmp3_ = g_get_user_config_dir ();
	_tmp4_ = g_get_user_cache_dir ();
	self = (DioriteXdgStorage*) diorite_storage_construct (object_type, _tmp0_, _tmp2_, _vala_array_length (_tmp1_), _tmp3_, _tmp4_);
	return self;
}


DioriteXdgStorage* diorite_xdg_storage_new (void) {
	return diorite_xdg_storage_construct (DIORITE_TYPE_XDG_STORAGE);
}


/**
 * Creates new storage with XGD paths for a project.
 * 
 * @param id identifier of the project
 */
static void _vala_array_add4 (GFile*** array, int* length, int* size, GFile* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GFile*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static GFile** _vala_array_dup2 (GFile** self, int length) {
	GFile** result;
	int i;
	result = g_new0 (GFile*, length + 1);
	for (i = 0; i < length; i++) {
		GFile* _tmp0_ = NULL;
		_tmp0_ = _g_object_ref0 (self[i]);
		result[i] = _tmp0_;
	}
	return result;
}


DioriteXdgStorage* diorite_xdg_storage_construct_for_project (GType object_type, const gchar* id, const gchar* user_suffix) {
	DioriteXdgStorage * self = NULL;
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	GFile* _tmp6_ = NULL;
	GFile* _tmp7_ = NULL;
	GFile* _tmp8_ = NULL;
	GFile* _tmp9_ = NULL;
	const gchar* _tmp10_ = NULL;
	const gchar* _tmp11_ = NULL;
	gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	GFile* _tmp14_ = NULL;
	GFile* _tmp15_ = NULL;
	GFile* _tmp16_ = NULL;
	GFile* _tmp17_ = NULL;
	const gchar* _tmp18_ = NULL;
	const gchar* _tmp19_ = NULL;
	gchar* _tmp20_ = NULL;
	gchar* _tmp21_ = NULL;
	GFile* _tmp22_ = NULL;
	GFile* _tmp23_ = NULL;
	GFile** data_dirs = NULL;
	GFile** _tmp24_ = NULL;
	gint data_dirs_length1 = 0;
	gint _data_dirs_size_ = 0;
	GFile** _tmp25_ = NULL;
	gint _tmp25__length1 = 0;
	GFile** _tmp31_ = NULL;
	gint _tmp31__length1 = 0;
	GFile** _tmp32_ = NULL;
	gint _tmp32__length1 = 0;
	g_return_val_if_fail (id != NULL, NULL);
	g_return_val_if_fail (user_suffix != NULL, NULL);
	self = (DioriteXdgStorage*) diorite_xdg_storage_construct (object_type);
	_tmp0_ = diorite_storage_get_user_data_dir ((DioriteStorage*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = id;
	_tmp3_ = user_suffix;
	_tmp4_ = g_strconcat (_tmp2_, _tmp3_, NULL);
	_tmp5_ = _tmp4_;
	_tmp6_ = g_file_get_child (_tmp1_, _tmp5_);
	_tmp7_ = _tmp6_;
	diorite_storage_set_user_data_dir ((DioriteStorage*) self, _tmp7_);
	_g_object_unref0 (_tmp7_);
	_g_free0 (_tmp5_);
	_tmp8_ = diorite_storage_get_user_config_dir ((DioriteStorage*) self);
	_tmp9_ = _tmp8_;
	_tmp10_ = id;
	_tmp11_ = user_suffix;
	_tmp12_ = g_strconcat (_tmp10_, _tmp11_, NULL);
	_tmp13_ = _tmp12_;
	_tmp14_ = g_file_get_child (_tmp9_, _tmp13_);
	_tmp15_ = _tmp14_;
	diorite_storage_set_user_config_dir ((DioriteStorage*) self, _tmp15_);
	_g_object_unref0 (_tmp15_);
	_g_free0 (_tmp13_);
	_tmp16_ = diorite_storage_get_user_cache_dir ((DioriteStorage*) self);
	_tmp17_ = _tmp16_;
	_tmp18_ = id;
	_tmp19_ = user_suffix;
	_tmp20_ = g_strconcat (_tmp18_, _tmp19_, NULL);
	_tmp21_ = _tmp20_;
	_tmp22_ = g_file_get_child (_tmp17_, _tmp21_);
	_tmp23_ = _tmp22_;
	diorite_storage_set_user_cache_dir ((DioriteStorage*) self, _tmp23_);
	_g_object_unref0 (_tmp23_);
	_g_free0 (_tmp21_);
	_tmp24_ = g_new0 (GFile*, 0 + 1);
	data_dirs = _tmp24_;
	data_dirs_length1 = 0;
	_data_dirs_size_ = data_dirs_length1;
	_tmp25_ = ((DioriteStorage*) self)->_data_dirs;
	_tmp25__length1 = ((DioriteStorage*) self)->_data_dirs_length1;
	{
		GFile** dir_collection = NULL;
		gint dir_collection_length1 = 0;
		gint _dir_collection_size_ = 0;
		gint dir_it = 0;
		dir_collection = _tmp25_;
		dir_collection_length1 = _tmp25__length1;
		for (dir_it = 0; dir_it < _tmp25__length1; dir_it = dir_it + 1) {
			GFile* _tmp26_ = NULL;
			GFile* dir = NULL;
			_tmp26_ = _g_object_ref0 (dir_collection[dir_it]);
			dir = _tmp26_;
			{
				GFile** _tmp27_ = NULL;
				gint _tmp27__length1 = 0;
				GFile* _tmp28_ = NULL;
				const gchar* _tmp29_ = NULL;
				GFile* _tmp30_ = NULL;
				_tmp27_ = data_dirs;
				_tmp27__length1 = data_dirs_length1;
				_tmp28_ = dir;
				_tmp29_ = id;
				_tmp30_ = g_file_get_child (_tmp28_, _tmp29_);
				_vala_array_add4 (&data_dirs, &data_dirs_length1, &_data_dirs_size_, _tmp30_);
				_g_object_unref0 (dir);
			}
		}
	}
	_tmp31_ = data_dirs;
	_tmp31__length1 = data_dirs_length1;
	_tmp32_ = (_tmp31_ != NULL) ? _vala_array_dup2 (_tmp31_, _tmp31__length1) : ((gpointer) _tmp31_);
	_tmp32__length1 = _tmp31__length1;
	((DioriteStorage*) self)->_data_dirs = (_vala_array_free (((DioriteStorage*) self)->_data_dirs, ((DioriteStorage*) self)->_data_dirs_length1, (GDestroyNotify) g_object_unref), NULL);
	((DioriteStorage*) self)->_data_dirs = _tmp32_;
	((DioriteStorage*) self)->_data_dirs_length1 = _tmp32__length1;
	data_dirs = (_vala_array_free (data_dirs, data_dirs_length1, (GDestroyNotify) g_object_unref), NULL);
	return self;
}


DioriteXdgStorage* diorite_xdg_storage_new_for_project (const gchar* id, const gchar* user_suffix) {
	return diorite_xdg_storage_construct_for_project (DIORITE_TYPE_XDG_STORAGE, id, user_suffix);
}


static void diorite_xdg_storage_class_init (DioriteXdgStorageClass * klass) {
	diorite_xdg_storage_parent_class = g_type_class_peek_parent (klass);
}


static void diorite_xdg_storage_instance_init (DioriteXdgStorage * self) {
}


/**
 * File storage abstraction that provides easy access to a set of common paths: user's data,
 * cache and configuration directories and system data directories. This implementation
 * uses paths compliant with XDG specification.
 */
GType diorite_xdg_storage_get_type (void) {
	static volatile gsize diorite_xdg_storage_type_id__volatile = 0;
	if (g_once_init_enter (&diorite_xdg_storage_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DioriteXdgStorageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) diorite_xdg_storage_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DioriteXdgStorage), 0, (GInstanceInitFunc) diorite_xdg_storage_instance_init, NULL };
		GType diorite_xdg_storage_type_id;
		diorite_xdg_storage_type_id = g_type_register_static (DIORITE_TYPE_STORAGE, "DioriteXdgStorage", &g_define_type_info, 0);
		g_once_init_leave (&diorite_xdg_storage_type_id__volatile, diorite_xdg_storage_type_id);
	}
	return diorite_xdg_storage_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



