/* subprocess.c generated by valac 0.29.1, the Vala compiler
 * generated from subprocess.vala, do not modify */

/*
 * Copyright 2013-2014 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <sys/types.h>


#define DIORITE_TYPE_SUBPROCESS_FLAGS (diorite_subprocess_flags_get_type ())

#define DIORITE_TYPE_SUBPROCESS (diorite_subprocess_get_type ())
#define DIORITE_SUBPROCESS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITE_TYPE_SUBPROCESS, DioriteSubprocess))
#define DIORITE_SUBPROCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITE_TYPE_SUBPROCESS, DioriteSubprocessClass))
#define DIORITE_IS_SUBPROCESS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITE_TYPE_SUBPROCESS))
#define DIORITE_IS_SUBPROCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITE_TYPE_SUBPROCESS))
#define DIORITE_SUBPROCESS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITE_TYPE_SUBPROCESS, DioriteSubprocessClass))

typedef struct _DioriteSubprocess DioriteSubprocess;
typedef struct _DioriteSubprocessClass DioriteSubprocessClass;
typedef struct _DioriteSubprocessPrivate DioriteSubprocessPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_main_loop_unref0(var) ((var == NULL) ? NULL : (var = (g_main_loop_unref (var), NULL)))

typedef enum  {
	DIORITE_SUBPROCESS_FLAGS_NONE = 1 << 0,
	DIORITE_SUBPROCESS_FLAGS_INPUT_PIPE = 1 << 1,
	DIORITE_SUBPROCESS_FLAGS_INPUT_INHERIT = 1 << 2,
	DIORITE_SUBPROCESS_FLAGS_OUTPUT_PIPES = 1 << 3,
	DIORITE_SUBPROCESS_FLAGS_OUTPUT_SILENCE = 1 << 4,
	DIORITE_SUBPROCESS_FLAGS_INHERIT_FDS = 1 << 5
} DioriteSubprocessFlags;

struct _DioriteSubprocess {
	GObject parent_instance;
	DioriteSubprocessPrivate * priv;
};

struct _DioriteSubprocessClass {
	GObjectClass parent_class;
};

struct _DioriteSubprocessPrivate {
	GPid _pid;
	gint _status;
	GInputStream* _stdin_pipe;
	GOutputStream* _stdout_pipe;
	GOutputStream* _stderr_pipe;
	gboolean _running;
	gchar** argv;
	gint argv_length1;
	gint _argv_size_;
	DioriteSubprocessFlags flags;
	GMainLoop* loop;
	GRecMutex __lock_loop;
	gboolean loop_result;
	guint loop_timeout;
};

typedef enum  {
	DIORITE_ERROR_INVALID_ARGUMENT,
	DIORITE_ERROR_UNEXPECTED_RESULT,
	DIORITE_ERROR_NOT_SUPPORTED,
	DIORITE_ERROR_NOT_IMPLEMENTED,
	DIORITE_ERROR_IOERROR,
	DIORITE_ERROR_NOT_FOUND
} DioriteError;
#define DIORITE_ERROR diorite_error_quark ()

static gpointer diorite_subprocess_parent_class = NULL;

GType diorite_subprocess_flags_get_type (void) G_GNUC_CONST;
GType diorite_subprocess_get_type (void) G_GNUC_CONST;
#define DIORITE_SUBPROCESS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DIORITE_TYPE_SUBPROCESS, DioriteSubprocessPrivate))
enum  {
	DIORITE_SUBPROCESS_DUMMY_PROPERTY,
	DIORITE_SUBPROCESS_PID,
	DIORITE_SUBPROCESS_STATUS,
	DIORITE_SUBPROCESS_STDIN_PIPE,
	DIORITE_SUBPROCESS_STDOUT_PIPE,
	DIORITE_SUBPROCESS_STDERR_PIPE,
	DIORITE_SUBPROCESS_RUNNING
};
DioriteSubprocess* diorite_subprocess_new (gchar** argv, DioriteSubprocessFlags flags, GError** error);
DioriteSubprocess* diorite_subprocess_construct (GType object_type, gchar** argv, DioriteSubprocessFlags flags, GError** error);
GQuark diorite_error_quark (void);
static gchar** _vala_array_dup3 (gchar** self, int length);
static void diorite_subprocess_set_running (DioriteSubprocess* self, gboolean value);
static void diorite_subprocess_child_watch (DioriteSubprocess* self, GPid pid, gint status);
static void _diorite_subprocess_child_watch_gchild_watch_func (GPid pid, gint status, gpointer self);
gboolean diorite_subprocess_get_running (DioriteSubprocess* self);
static void diorite_subprocess_set_pid (DioriteSubprocess* self, GPid value);
GInputStream* diorite_input_stream_from_pipe (gint fd);
static void diorite_subprocess_set_stdin_pipe (DioriteSubprocess* self, GInputStream* value);
GOutputStream* diorite_output_stream_from_pipe (gint fd);
static void diorite_subprocess_set_stdout_pipe (DioriteSubprocess* self, GOutputStream* value);
static void diorite_subprocess_set_stderr_pipe (DioriteSubprocess* self, GOutputStream* value);
gboolean diorite_subprocess_wait (DioriteSubprocess* self, guint timeout);
static gboolean diorite_subprocess_on_loop_timeout (DioriteSubprocess* self);
static gboolean _diorite_subprocess_on_loop_timeout_gsource_func (gpointer self);
void diorite_subprocess_exit (DioriteSubprocess* self);
static void diorite_subprocess_send_signal (DioriteSubprocess* self, gint signum);
void diorite_subprocess_force_exit (DioriteSubprocess* self);
GPid diorite_subprocess_get_pid (DioriteSubprocess* self);
void diorite_subprocess_set_status (DioriteSubprocess* self, gint value);
gint diorite_subprocess_get_status (DioriteSubprocess* self);
GInputStream* diorite_subprocess_get_stdin_pipe (DioriteSubprocess* self);
GOutputStream* diorite_subprocess_get_stdout_pipe (DioriteSubprocess* self);
GOutputStream* diorite_subprocess_get_stderr_pipe (DioriteSubprocess* self);
static void diorite_subprocess_finalize (GObject* obj);
static void _vala_diorite_subprocess_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_diorite_subprocess_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


GType diorite_subprocess_flags_get_type (void) {
	static volatile gsize diorite_subprocess_flags_type_id__volatile = 0;
	if (g_once_init_enter (&diorite_subprocess_flags_type_id__volatile)) {
		static const GFlagsValue values[] = {{DIORITE_SUBPROCESS_FLAGS_NONE, "DIORITE_SUBPROCESS_FLAGS_NONE", "none"}, {DIORITE_SUBPROCESS_FLAGS_INPUT_PIPE, "DIORITE_SUBPROCESS_FLAGS_INPUT_PIPE", "input-pipe"}, {DIORITE_SUBPROCESS_FLAGS_INPUT_INHERIT, "DIORITE_SUBPROCESS_FLAGS_INPUT_INHERIT", "input-inherit"}, {DIORITE_SUBPROCESS_FLAGS_OUTPUT_PIPES, "DIORITE_SUBPROCESS_FLAGS_OUTPUT_PIPES", "output-pipes"}, {DIORITE_SUBPROCESS_FLAGS_OUTPUT_SILENCE, "DIORITE_SUBPROCESS_FLAGS_OUTPUT_SILENCE", "output-silence"}, {DIORITE_SUBPROCESS_FLAGS_INHERIT_FDS, "DIORITE_SUBPROCESS_FLAGS_INHERIT_FDS", "inherit-fds"}, {0, NULL, NULL}};
		GType diorite_subprocess_flags_type_id;
		diorite_subprocess_flags_type_id = g_flags_register_static ("DioriteSubprocessFlags", values);
		g_once_init_leave (&diorite_subprocess_flags_type_id__volatile, diorite_subprocess_flags_type_id);
	}
	return diorite_subprocess_flags_type_id__volatile;
}


/**
 * Creates new subprocess.
 * 
 * @param argv     vector of commandline arguments
 * @param flags    flags that define the behavior of the subprocess
 * @throw GLib.Error on failure
 */
static gchar** _vala_array_dup3 (gchar** self, int length) {
	gchar** result;
	int i;
	result = g_new0 (gchar*, length + 1);
	for (i = 0; i < length; i++) {
		gchar* _tmp0_ = NULL;
		_tmp0_ = g_strdup (self[i]);
		result[i] = _tmp0_;
	}
	return result;
}


static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = needle;
	_tmp1_ = strstr ((gchar*) self, (gchar*) _tmp0_);
	result = _tmp1_ != NULL;
	return result;
}


static void _diorite_subprocess_child_watch_gchild_watch_func (GPid pid, gint status, gpointer self) {
	diorite_subprocess_child_watch ((DioriteSubprocess*) self, pid, status);
}


DioriteSubprocess* diorite_subprocess_construct (GType object_type, gchar** argv, DioriteSubprocessFlags flags, GError** error) {
	DioriteSubprocess * self = NULL;
	gchar** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gchar** _tmp2_ = NULL;
	gint _tmp2__length1 = 0;
	gchar** _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	DioriteSubprocessFlags _tmp4_ = 0;
	GSpawnFlags spawn_flags = 0;
	gchar** _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
	const gchar* _tmp6_ = NULL;
	gboolean _tmp7_ = FALSE;
	DioriteSubprocessFlags _tmp9_ = 0;
	DioriteSubprocessFlags _tmp11_ = 0;
	DioriteSubprocessFlags _tmp13_ = 0;
	gint child_pid = 0;
	gint child_stdin = 0;
	gint child_stdout = 0;
	gint child_stderr = 0;
	DioriteSubprocessFlags _tmp16_ = 0;
	gint _tmp45_ = 0;
	gboolean _tmp46_ = FALSE;
	GError * _inner_error_ = NULL;
	self = (DioriteSubprocess*) g_object_new (object_type, NULL);
	_tmp0_ = argv;
	_tmp0__length1 = _vala_array_length (argv);
	if (_tmp0__length1 < 1) {
		GError* _tmp1_ = NULL;
		_tmp1_ = g_error_new_literal (DIORITE_ERROR, DIORITE_ERROR_INVALID_ARGUMENT, "Commandline arguments vector is empty.");
		_inner_error_ = _tmp1_;
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (self);
		return NULL;
	}
	_tmp2_ = argv;
	_tmp2__length1 = _vala_array_length (argv);
	_tmp3_ = (_tmp2_ != NULL) ? _vala_array_dup3 (_tmp2_, _tmp2__length1) : ((gpointer) _tmp2_);
	_tmp3__length1 = _tmp2__length1;
	self->priv->argv = (_vala_array_free (self->priv->argv, self->priv->argv_length1, (GDestroyNotify) g_free), NULL);
	self->priv->argv = _tmp3_;
	self->priv->argv_length1 = _tmp3__length1;
	self->priv->_argv_size_ = self->priv->argv_length1;
	_tmp4_ = flags;
	self->priv->flags = _tmp4_;
	spawn_flags = G_SPAWN_DO_NOT_REAP_CHILD;
	_tmp5_ = argv;
	_tmp5__length1 = _vala_array_length (argv);
	_tmp6_ = _tmp5_[0];
	_tmp7_ = string_contains (_tmp6_, G_DIR_SEPARATOR_S);
	if (!_tmp7_) {
		GSpawnFlags _tmp8_ = 0;
		_tmp8_ = spawn_flags;
		spawn_flags = _tmp8_ | G_SPAWN_SEARCH_PATH;
	}
	_tmp9_ = flags;
	if ((_tmp9_ & DIORITE_SUBPROCESS_FLAGS_INPUT_INHERIT) != 0) {
		GSpawnFlags _tmp10_ = 0;
		_tmp10_ = spawn_flags;
		spawn_flags = _tmp10_ | G_SPAWN_CHILD_INHERITS_STDIN;
	}
	_tmp11_ = flags;
	if ((_tmp11_ & DIORITE_SUBPROCESS_FLAGS_INHERIT_FDS) != 0) {
		GSpawnFlags _tmp12_ = 0;
		_tmp12_ = spawn_flags;
		spawn_flags = _tmp12_ | G_SPAWN_LEAVE_DESCRIPTORS_OPEN;
	}
	_tmp13_ = flags;
	if ((_tmp13_ & DIORITE_SUBPROCESS_FLAGS_OUTPUT_SILENCE) != 0) {
		GSpawnFlags _tmp14_ = 0;
		GSpawnFlags _tmp15_ = 0;
		_tmp14_ = spawn_flags;
		spawn_flags = _tmp14_ | G_SPAWN_STDOUT_TO_DEV_NULL;
		_tmp15_ = spawn_flags;
		spawn_flags = _tmp15_ | G_SPAWN_STDERR_TO_DEV_NULL;
	}
	child_pid = -1;
	child_stdin = -1;
	child_stdout = -1;
	child_stderr = -1;
	_tmp16_ = flags;
	if ((_tmp16_ & DIORITE_SUBPROCESS_FLAGS_INPUT_PIPE) == 0) {
		DioriteSubprocessFlags _tmp17_ = 0;
		_tmp17_ = flags;
		if ((_tmp17_ & DIORITE_SUBPROCESS_FLAGS_OUTPUT_PIPES) == 0) {
			gboolean _tmp18_ = FALSE;
			gchar** _tmp19_ = NULL;
			gint _tmp19__length1 = 0;
			GSpawnFlags _tmp20_ = 0;
			GPid _tmp21_ = 0;
			gboolean _tmp22_ = FALSE;
			_tmp19_ = argv;
			_tmp19__length1 = _vala_array_length (argv);
			_tmp20_ = spawn_flags;
			_tmp22_ = g_spawn_async_with_pipes (NULL, _tmp19_, NULL, _tmp20_, NULL, NULL, &_tmp21_, NULL, NULL, NULL, &_inner_error_);
			child_pid = (gint) _tmp21_;
			_tmp18_ = _tmp22_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				g_propagate_error (error, _inner_error_);
				_g_object_unref0 (self);
				return NULL;
			}
			diorite_subprocess_set_running (self, _tmp18_);
		} else {
			gboolean _tmp23_ = FALSE;
			gchar** _tmp24_ = NULL;
			gint _tmp24__length1 = 0;
			GSpawnFlags _tmp25_ = 0;
			GPid _tmp26_ = 0;
			gint _tmp27_ = 0;
			gint _tmp28_ = 0;
			gboolean _tmp29_ = FALSE;
			_tmp24_ = argv;
			_tmp24__length1 = _vala_array_length (argv);
			_tmp25_ = spawn_flags;
			_tmp29_ = g_spawn_async_with_pipes (NULL, _tmp24_, NULL, _tmp25_, NULL, NULL, &_tmp26_, NULL, &_tmp27_, &_tmp28_, &_inner_error_);
			child_pid = (gint) _tmp26_;
			child_stdout = _tmp27_;
			child_stderr = _tmp28_;
			_tmp23_ = _tmp29_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				g_propagate_error (error, _inner_error_);
				_g_object_unref0 (self);
				return NULL;
			}
			diorite_subprocess_set_running (self, _tmp23_);
		}
	} else {
		DioriteSubprocessFlags _tmp30_ = 0;
		_tmp30_ = flags;
		if ((_tmp30_ & DIORITE_SUBPROCESS_FLAGS_OUTPUT_PIPES) == 0) {
			gboolean _tmp31_ = FALSE;
			gchar** _tmp32_ = NULL;
			gint _tmp32__length1 = 0;
			GSpawnFlags _tmp33_ = 0;
			GPid _tmp34_ = 0;
			gint _tmp35_ = 0;
			gboolean _tmp36_ = FALSE;
			_tmp32_ = argv;
			_tmp32__length1 = _vala_array_length (argv);
			_tmp33_ = spawn_flags;
			_tmp36_ = g_spawn_async_with_pipes (NULL, _tmp32_, NULL, _tmp33_, NULL, NULL, &_tmp34_, &_tmp35_, NULL, NULL, &_inner_error_);
			child_pid = (gint) _tmp34_;
			child_stdin = _tmp35_;
			_tmp31_ = _tmp36_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				g_propagate_error (error, _inner_error_);
				_g_object_unref0 (self);
				return NULL;
			}
			diorite_subprocess_set_running (self, _tmp31_);
		} else {
			gboolean _tmp37_ = FALSE;
			gchar** _tmp38_ = NULL;
			gint _tmp38__length1 = 0;
			GSpawnFlags _tmp39_ = 0;
			GPid _tmp40_ = 0;
			gint _tmp41_ = 0;
			gint _tmp42_ = 0;
			gint _tmp43_ = 0;
			gboolean _tmp44_ = FALSE;
			_tmp38_ = argv;
			_tmp38__length1 = _vala_array_length (argv);
			_tmp39_ = spawn_flags;
			_tmp44_ = g_spawn_async_with_pipes (NULL, _tmp38_, NULL, _tmp39_, NULL, NULL, &_tmp40_, &_tmp41_, &_tmp42_, &_tmp43_, &_inner_error_);
			child_pid = (gint) _tmp40_;
			child_stdin = _tmp41_;
			child_stdout = _tmp42_;
			child_stderr = _tmp43_;
			_tmp37_ = _tmp44_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				g_propagate_error (error, _inner_error_);
				_g_object_unref0 (self);
				return NULL;
			}
			diorite_subprocess_set_running (self, _tmp37_);
		}
	}
	_tmp45_ = child_pid;
	g_child_watch_add_full (G_PRIORITY_DEFAULT_IDLE, (GPid) _tmp45_, _diorite_subprocess_child_watch_gchild_watch_func, g_object_ref (self), g_object_unref);
	_tmp46_ = self->priv->_running;
	if (_tmp46_) {
		gint _tmp47_ = 0;
		gint _tmp48_ = 0;
		GInputStream* _tmp49_ = NULL;
		GInputStream* _tmp50_ = NULL;
		gint _tmp51_ = 0;
		GOutputStream* _tmp52_ = NULL;
		GOutputStream* _tmp53_ = NULL;
		gint _tmp54_ = 0;
		GOutputStream* _tmp55_ = NULL;
		GOutputStream* _tmp56_ = NULL;
		_tmp47_ = child_pid;
		diorite_subprocess_set_pid (self, (GPid) _tmp47_);
		_tmp48_ = child_stdin;
		_tmp49_ = diorite_input_stream_from_pipe (_tmp48_);
		_tmp50_ = _tmp49_;
		diorite_subprocess_set_stdin_pipe (self, _tmp50_);
		_g_object_unref0 (_tmp50_);
		_tmp51_ = child_stdout;
		_tmp52_ = diorite_output_stream_from_pipe (_tmp51_);
		_tmp53_ = _tmp52_;
		diorite_subprocess_set_stdout_pipe (self, _tmp53_);
		_g_object_unref0 (_tmp53_);
		_tmp54_ = child_stderr;
		_tmp55_ = diorite_output_stream_from_pipe (_tmp54_);
		_tmp56_ = _tmp55_;
		diorite_subprocess_set_stderr_pipe (self, _tmp56_);
		_g_object_unref0 (_tmp56_);
	}
	return self;
}


DioriteSubprocess* diorite_subprocess_new (gchar** argv, DioriteSubprocessFlags flags, GError** error) {
	return diorite_subprocess_construct (DIORITE_TYPE_SUBPROCESS, argv, flags, error);
}


/**
 * Waits for the subprocess to exit
 * 
 * @param timeout    Miliseconds to wait or zero to wait forever.
 * @return true in the subprocess exited before timeout
 */
static gboolean _diorite_subprocess_on_loop_timeout_gsource_func (gpointer self) {
	gboolean result;
	result = diorite_subprocess_on_loop_timeout ((DioriteSubprocess*) self);
	return result;
}


gboolean diorite_subprocess_wait (DioriteSubprocess* self, guint timeout) {
	gboolean result = FALSE;
	GMainLoop* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	GMainLoop* _tmp8_ = NULL;
	gboolean _tmp13_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->loop;
	g_return_val_if_fail (_tmp0_ == NULL, FALSE);
	_tmp1_ = self->priv->_running;
	if (!_tmp1_) {
		result = TRUE;
		return result;
	}
	{
		GMainLoop* _tmp2_ = NULL;
		_tmp2_ = self->priv->loop;
		g_rec_mutex_lock (&self->priv->__lock_loop);
		{
			GMainLoop* _tmp3_ = NULL;
			guint _tmp4_ = 0U;
			_tmp3_ = g_main_loop_new (NULL, FALSE);
			_g_main_loop_unref0 (self->priv->loop);
			self->priv->loop = _tmp3_;
			self->priv->loop_result = TRUE;
			_tmp4_ = timeout;
			if (_tmp4_ > ((guint) 0)) {
				guint _tmp5_ = 0U;
				guint _tmp6_ = 0U;
				_tmp5_ = timeout;
				_tmp6_ = g_timeout_add_full (G_PRIORITY_DEFAULT, _tmp5_, _diorite_subprocess_on_loop_timeout_gsource_func, g_object_ref (self), g_object_unref);
				self->priv->loop_timeout = _tmp6_;
			}
		}
		__finally25:
		{
			GMainLoop* _tmp7_ = NULL;
			_tmp7_ = self->priv->loop;
			g_rec_mutex_unlock (&self->priv->__lock_loop);
		}
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
	}
	_tmp8_ = self->priv->loop;
	g_main_loop_run (_tmp8_);
	{
		GMainLoop* _tmp9_ = NULL;
		_tmp9_ = self->priv->loop;
		g_rec_mutex_lock (&self->priv->__lock_loop);
		{
			guint _tmp10_ = 0U;
			_g_main_loop_unref0 (self->priv->loop);
			self->priv->loop = NULL;
			_tmp10_ = self->priv->loop_timeout;
			if (_tmp10_ > ((guint) 0)) {
				guint _tmp11_ = 0U;
				_tmp11_ = self->priv->loop_timeout;
				g_source_remove (_tmp11_);
				self->priv->loop_timeout = (guint) 0;
			}
		}
		__finally26:
		{
			GMainLoop* _tmp12_ = NULL;
			_tmp12_ = self->priv->loop;
			g_rec_mutex_unlock (&self->priv->__lock_loop);
		}
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
	}
	_tmp13_ = self->priv->loop_result;
	result = _tmp13_;
	return result;
}


/**
 * Ask the subprocess to exit cleanly.
 * 
 * On Unix, it sends signal SIGTERM. On Windows, it tries to send message WM_CLOSE to the
 * associated window and then Ctrl-C control message.
 */
void diorite_subprocess_exit (DioriteSubprocess* self) {
	g_return_if_fail (self != NULL);
	diorite_subprocess_send_signal (self, SIGTERM);
}


/**
 * Forcefully terminate the subprocess.
 * 
 * On Unix, it sends signal SIGKILL. On Windows, it uses TerminateProcess call.
 */
void diorite_subprocess_force_exit (DioriteSubprocess* self) {
	g_return_if_fail (self != NULL);
	diorite_subprocess_send_signal (self, SIGKILL);
}


static void diorite_subprocess_send_signal (DioriteSubprocess* self, gint signum) {
	GPid _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_pid;
	if (_tmp0_ != ((GPid) 0)) {
		GPid _tmp1_ = 0;
		gint _tmp2_ = 0;
		_tmp1_ = self->priv->_pid;
		_tmp2_ = signum;
		kill ((pid_t) _tmp1_, _tmp2_);
	}
}


static void diorite_subprocess_child_watch (DioriteSubprocess* self, GPid pid, gint status) {
	GPid _tmp0_ = 0;
	gint _tmp1_ = 0;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = pid;
	g_spawn_close_pid (_tmp0_);
	_tmp1_ = status;
	diorite_subprocess_set_status (self, _tmp1_);
	diorite_subprocess_set_running (self, FALSE);
	diorite_subprocess_set_pid (self, (GPid) (-1));
	{
		GMainLoop* _tmp2_ = NULL;
		_tmp2_ = self->priv->loop;
		g_rec_mutex_lock (&self->priv->__lock_loop);
		{
			gboolean _tmp3_ = FALSE;
			GMainLoop* _tmp4_ = NULL;
			_tmp4_ = self->priv->loop;
			if (_tmp4_ != NULL) {
				GMainLoop* _tmp5_ = NULL;
				gboolean _tmp6_ = FALSE;
				_tmp5_ = self->priv->loop;
				_tmp6_ = g_main_loop_is_running (_tmp5_);
				_tmp3_ = _tmp6_;
			} else {
				_tmp3_ = FALSE;
			}
			if (_tmp3_) {
				GMainLoop* _tmp7_ = NULL;
				_tmp7_ = self->priv->loop;
				g_main_loop_quit (_tmp7_);
			}
		}
		__finally27:
		{
			GMainLoop* _tmp8_ = NULL;
			_tmp8_ = self->priv->loop;
			g_rec_mutex_unlock (&self->priv->__lock_loop);
		}
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	g_signal_emit_by_name (self, "exited");
}


static gboolean diorite_subprocess_on_loop_timeout (DioriteSubprocess* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		GMainLoop* _tmp0_ = NULL;
		_tmp0_ = self->priv->loop;
		g_rec_mutex_lock (&self->priv->__lock_loop);
		{
			gboolean _tmp1_ = FALSE;
			GMainLoop* _tmp2_ = NULL;
			_tmp2_ = self->priv->loop;
			if (_tmp2_ != NULL) {
				GMainLoop* _tmp3_ = NULL;
				gboolean _tmp4_ = FALSE;
				_tmp3_ = self->priv->loop;
				_tmp4_ = g_main_loop_is_running (_tmp3_);
				_tmp1_ = _tmp4_;
			} else {
				_tmp1_ = FALSE;
			}
			if (_tmp1_) {
				GMainLoop* _tmp5_ = NULL;
				self->priv->loop_result = FALSE;
				self->priv->loop_timeout = (guint) 0;
				_tmp5_ = self->priv->loop;
				g_main_loop_quit (_tmp5_);
			}
		}
		__finally28:
		{
			GMainLoop* _tmp6_ = NULL;
			_tmp6_ = self->priv->loop;
			g_rec_mutex_unlock (&self->priv->__lock_loop);
		}
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
	}
	result = FALSE;
	return result;
}


GPid diorite_subprocess_get_pid (DioriteSubprocess* self) {
	GPid result;
	GPid _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_pid;
	result = _tmp0_;
	return result;
}


static void diorite_subprocess_set_pid (DioriteSubprocess* self, GPid value) {
	GPid _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_pid = _tmp0_;
	g_object_notify ((GObject *) self, "pid");
}


gint diorite_subprocess_get_status (DioriteSubprocess* self) {
	gint result;
	gint _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_status;
	result = _tmp0_;
	return result;
}


void diorite_subprocess_set_status (DioriteSubprocess* self, gint value) {
	gint _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_status = _tmp0_;
	g_object_notify ((GObject *) self, "status");
}


GInputStream* diorite_subprocess_get_stdin_pipe (DioriteSubprocess* self) {
	GInputStream* result;
	GInputStream* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_stdin_pipe;
	result = _tmp0_;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void diorite_subprocess_set_stdin_pipe (DioriteSubprocess* self, GInputStream* value) {
	GInputStream* _tmp0_ = NULL;
	GInputStream* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_stdin_pipe);
	self->priv->_stdin_pipe = _tmp1_;
	g_object_notify ((GObject *) self, "stdin-pipe");
}


GOutputStream* diorite_subprocess_get_stdout_pipe (DioriteSubprocess* self) {
	GOutputStream* result;
	GOutputStream* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_stdout_pipe;
	result = _tmp0_;
	return result;
}


static void diorite_subprocess_set_stdout_pipe (DioriteSubprocess* self, GOutputStream* value) {
	GOutputStream* _tmp0_ = NULL;
	GOutputStream* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_stdout_pipe);
	self->priv->_stdout_pipe = _tmp1_;
	g_object_notify ((GObject *) self, "stdout-pipe");
}


GOutputStream* diorite_subprocess_get_stderr_pipe (DioriteSubprocess* self) {
	GOutputStream* result;
	GOutputStream* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_stderr_pipe;
	result = _tmp0_;
	return result;
}


static void diorite_subprocess_set_stderr_pipe (DioriteSubprocess* self, GOutputStream* value) {
	GOutputStream* _tmp0_ = NULL;
	GOutputStream* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_stderr_pipe);
	self->priv->_stderr_pipe = _tmp1_;
	g_object_notify ((GObject *) self, "stderr-pipe");
}


gboolean diorite_subprocess_get_running (DioriteSubprocess* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_running;
	result = _tmp0_;
	return result;
}


static void diorite_subprocess_set_running (DioriteSubprocess* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_running = _tmp0_;
	g_object_notify ((GObject *) self, "running");
}


static void diorite_subprocess_class_init (DioriteSubprocessClass * klass) {
	diorite_subprocess_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DioriteSubprocessPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_diorite_subprocess_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_diorite_subprocess_set_property;
	G_OBJECT_CLASS (klass)->finalize = diorite_subprocess_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIORITE_SUBPROCESS_PID, g_param_spec_int ("pid", "pid", "pid", G_MININT, G_MAXINT, (GPid) (-1), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIORITE_SUBPROCESS_STATUS, g_param_spec_int ("status", "status", "status", G_MININT, G_MAXINT, -1, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIORITE_SUBPROCESS_STDIN_PIPE, g_param_spec_object ("stdin-pipe", "stdin-pipe", "stdin-pipe", G_TYPE_INPUT_STREAM, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIORITE_SUBPROCESS_STDOUT_PIPE, g_param_spec_object ("stdout-pipe", "stdout-pipe", "stdout-pipe", G_TYPE_OUTPUT_STREAM, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIORITE_SUBPROCESS_STDERR_PIPE, g_param_spec_object ("stderr-pipe", "stderr-pipe", "stderr-pipe", G_TYPE_OUTPUT_STREAM, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIORITE_SUBPROCESS_RUNNING, g_param_spec_boolean ("running", "running", "running", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	/**
	 * Emitted when the subprocess exited.
	 */
	g_signal_new ("exited", DIORITE_TYPE_SUBPROCESS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void diorite_subprocess_instance_init (DioriteSubprocess * self) {
	self->priv = DIORITE_SUBPROCESS_GET_PRIVATE (self);
	self->priv->_pid = (GPid) (-1);
	self->priv->_status = -1;
	self->priv->_running = FALSE;
	g_rec_mutex_init (&self->priv->__lock_loop);
	self->priv->loop = NULL;
	self->priv->loop_result = FALSE;
	self->priv->loop_timeout = (guint) 0;
}


static void diorite_subprocess_finalize (GObject* obj) {
	DioriteSubprocess * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIORITE_TYPE_SUBPROCESS, DioriteSubprocess);
	_g_object_unref0 (self->priv->_stdin_pipe);
	_g_object_unref0 (self->priv->_stdout_pipe);
	_g_object_unref0 (self->priv->_stderr_pipe);
	self->priv->argv = (_vala_array_free (self->priv->argv, self->priv->argv_length1, (GDestroyNotify) g_free), NULL);
	g_rec_mutex_clear (&self->priv->__lock_loop);
	_g_main_loop_unref0 (self->priv->loop);
	G_OBJECT_CLASS (diorite_subprocess_parent_class)->finalize (obj);
}


/**
 * Subprocess is a class for creation of child process and interaction with it.
 * (See also GIO Subprocess for more robust alternative.)
 */
GType diorite_subprocess_get_type (void) {
	static volatile gsize diorite_subprocess_type_id__volatile = 0;
	if (g_once_init_enter (&diorite_subprocess_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DioriteSubprocessClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) diorite_subprocess_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DioriteSubprocess), 0, (GInstanceInitFunc) diorite_subprocess_instance_init, NULL };
		GType diorite_subprocess_type_id;
		diorite_subprocess_type_id = g_type_register_static (G_TYPE_OBJECT, "DioriteSubprocess", &g_define_type_info, 0);
		g_once_init_leave (&diorite_subprocess_type_id__volatile, diorite_subprocess_type_id);
	}
	return diorite_subprocess_type_id__volatile;
}


static void _vala_diorite_subprocess_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DioriteSubprocess * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DIORITE_TYPE_SUBPROCESS, DioriteSubprocess);
	switch (property_id) {
		case DIORITE_SUBPROCESS_PID:
		g_value_set_int (value, diorite_subprocess_get_pid (self));
		break;
		case DIORITE_SUBPROCESS_STATUS:
		g_value_set_int (value, diorite_subprocess_get_status (self));
		break;
		case DIORITE_SUBPROCESS_STDIN_PIPE:
		g_value_set_object (value, diorite_subprocess_get_stdin_pipe (self));
		break;
		case DIORITE_SUBPROCESS_STDOUT_PIPE:
		g_value_set_object (value, diorite_subprocess_get_stdout_pipe (self));
		break;
		case DIORITE_SUBPROCESS_STDERR_PIPE:
		g_value_set_object (value, diorite_subprocess_get_stderr_pipe (self));
		break;
		case DIORITE_SUBPROCESS_RUNNING:
		g_value_set_boolean (value, diorite_subprocess_get_running (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_diorite_subprocess_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	DioriteSubprocess * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DIORITE_TYPE_SUBPROCESS, DioriteSubprocess);
	switch (property_id) {
		case DIORITE_SUBPROCESS_PID:
		diorite_subprocess_set_pid (self, g_value_get_int (value));
		break;
		case DIORITE_SUBPROCESS_STATUS:
		diorite_subprocess_set_status (self, g_value_get_int (value));
		break;
		case DIORITE_SUBPROCESS_STDIN_PIPE:
		diorite_subprocess_set_stdin_pipe (self, g_value_get_object (value));
		break;
		case DIORITE_SUBPROCESS_STDOUT_PIPE:
		diorite_subprocess_set_stdout_pipe (self, g_value_get_object (value));
		break;
		case DIORITE_SUBPROCESS_STDERR_PIPE:
		diorite_subprocess_set_stderr_pipe (self, g_value_get_object (value));
		break;
		case DIORITE_SUBPROCESS_RUNNING:
		diorite_subprocess_set_running (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



