/* system.c generated by valac 0.29.1, the Vala compiler
 * generated from system.vala, do not modify */

/*
 * Copyright 2011-2014 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))



gchar* diorite_system_read_file (GFile* file, GError** error);
void diorite_system_overwrite_file (GFile* file, const gchar* contents, GError** error);
void diorite_system_purge_directory_content (GFile* dir, gboolean recursive, GError** error);
gboolean diorite_system_try_purge_dir (GFile* dir, gboolean recursive);
void diorite_system_copy_tree (GFile* source_dir, GFile* dest_dir, GCancellable* cancellable, GError** error);


/**
 * Loads contents of a file in UTF-8 encoding
 * 
 * @param file    file to read
 * @return contents of the file
 * @throws GLib.Error on failure
 */
gchar* diorite_system_read_file (GFile* file, GError** error) {
	gchar* result = NULL;
	gchar* data = NULL;
	guint8* binary_data = NULL;
	gint binary_data_length1 = 0;
	gint _binary_data_size_ = 0;
	GFile* _tmp0_ = NULL;
	guint8* _tmp1_ = NULL;
	gsize _tmp2_;
	guint8* _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (file != NULL, NULL);
	_tmp0_ = file;
	g_file_load_contents (_tmp0_, NULL, &_tmp1_, &_tmp2_, NULL, &_inner_error_);
	binary_data = (g_free (binary_data), NULL);
	binary_data = _tmp1_;
	binary_data_length1 = _tmp2_;
	_binary_data_size_ = binary_data_length1;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		binary_data = (g_free (binary_data), NULL);
		_g_free0 (data);
		return NULL;
	}
	_tmp3_ = binary_data;
	_tmp3__length1 = binary_data_length1;
	_tmp4_ = g_strdup ((const gchar*) _tmp3_);
	_g_free0 (data);
	data = _tmp4_;
	binary_data = (g_free (binary_data), NULL);
	binary_data = NULL;
	binary_data_length1 = 0;
	_binary_data_size_ = binary_data_length1;
	_tmp5_ = data;
	data = NULL;
	result = _tmp5_;
	binary_data = (g_free (binary_data), NULL);
	_g_free0 (data);
	return result;
}


/**
 * 
 * Replaces contents of a file with text in UTF-8 encoding
 * 
 * @param file        file to overwrite
 * @param contents    contents of the file
 * @throws GLib.Error on failure
 */
static guint8* string_get_data (const gchar* self, int* result_length1) {
	guint8* result;
	guint8* res = NULL;
	gint res_length1 = 0;
	gint _res_size_ = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	guint8* _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	guint8* _tmp4_ = NULL;
	gint _tmp4__length1 = 0;
	g_return_val_if_fail (self != NULL, NULL);
	res = (guint8*) self;
	res_length1 = -1;
	_res_size_ = res_length1;
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	res_length1 = (gint) _tmp1_;
	_tmp2_ = res_length1;
	_tmp3_ = res;
	_tmp3__length1 = res_length1;
	_tmp4_ = _tmp3_;
	_tmp4__length1 = _tmp3__length1;
	if (result_length1) {
		*result_length1 = _tmp4__length1;
	}
	result = _tmp4_;
	return result;
}


void diorite_system_overwrite_file (GFile* file, const gchar* contents, GError** error) {
	GFile* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	guint8* _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
	guint8* _tmp6_ = NULL;
	gint _tmp6__length1 = 0;
	GError * _inner_error_ = NULL;
	g_return_if_fail (file != NULL);
	g_return_if_fail (contents != NULL);
	{
		GFile* _tmp0_ = NULL;
		GFile* _tmp1_ = NULL;
		GFile* _tmp2_ = NULL;
		_tmp0_ = file;
		_tmp1_ = g_file_get_parent (_tmp0_);
		_tmp2_ = _tmp1_;
		g_file_make_directory_with_parents (_tmp2_, NULL, &_inner_error_);
		_g_object_unref0 (_tmp2_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch29_g_error;
		}
	}
	goto __finally29;
	__catch29_g_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_g_error_free0 (e);
	}
	__finally29:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return;
	}
	_tmp3_ = file;
	_tmp4_ = contents;
	_tmp5_ = string_get_data (_tmp4_, &_tmp5__length1);
	_tmp6_ = _tmp5_;
	_tmp6__length1 = _tmp5__length1;
	g_file_replace_contents (_tmp3_, _tmp6_, (gsize) _tmp6__length1, NULL, FALSE, G_FILE_CREATE_NONE, NULL, NULL, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return;
	}
}


/**
 * Removes files in a directory.
 * 
 * @param dir          directory
 * @param recursive    recursive removal
 * @throw              Error on failure
 */
void diorite_system_purge_directory_content (GFile* dir, gboolean recursive, GError** error) {
	GFileEnumerator* enumerator = NULL;
	GFile* _tmp0_ = NULL;
	GFileEnumerator* _tmp1_ = NULL;
	GFileInfo* file_info = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (dir != NULL);
	_tmp0_ = dir;
	_tmp1_ = g_file_enumerate_children (_tmp0_, G_FILE_ATTRIBUTE_STANDARD_NAME, 0, NULL, &_inner_error_);
	enumerator = _tmp1_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return;
	}
	while (TRUE) {
		GFileInfo* _tmp2_ = NULL;
		GFileEnumerator* _tmp3_ = NULL;
		GFileInfo* _tmp4_ = NULL;
		GFileInfo* _tmp5_ = NULL;
		GFileInfo* _tmp6_ = NULL;
		GFile* f = NULL;
		GFile* _tmp7_ = NULL;
		GFileInfo* _tmp8_ = NULL;
		const gchar* _tmp9_ = NULL;
		GFile* _tmp10_ = NULL;
		GFile* _tmp11_ = NULL;
		GFileType _tmp12_ = 0;
		GFile* _tmp15_ = NULL;
		_tmp3_ = enumerator;
		_tmp4_ = g_file_enumerator_next_file (_tmp3_, NULL, &_inner_error_);
		_tmp2_ = _tmp4_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (file_info);
			_g_object_unref0 (enumerator);
			return;
		}
		_tmp5_ = _tmp2_;
		_tmp2_ = NULL;
		_g_object_unref0 (file_info);
		file_info = _tmp5_;
		_tmp6_ = file_info;
		if (!(_tmp6_ != NULL)) {
			_g_object_unref0 (_tmp2_);
			break;
		}
		_tmp7_ = dir;
		_tmp8_ = file_info;
		_tmp9_ = g_file_info_get_name (_tmp8_);
		_tmp10_ = g_file_get_child (_tmp7_, _tmp9_);
		f = _tmp10_;
		_tmp11_ = f;
		_tmp12_ = g_file_query_file_type (_tmp11_, 0, NULL);
		if (_tmp12_ == G_FILE_TYPE_DIRECTORY) {
			gboolean _tmp13_ = FALSE;
			_tmp13_ = recursive;
			if (_tmp13_) {
				GFile* _tmp14_ = NULL;
				_tmp14_ = f;
				diorite_system_purge_directory_content (_tmp14_, TRUE, &_inner_error_);
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					g_propagate_error (error, _inner_error_);
					_g_object_unref0 (f);
					_g_object_unref0 (_tmp2_);
					_g_object_unref0 (file_info);
					_g_object_unref0 (enumerator);
					return;
				}
			}
		}
		_tmp15_ = f;
		g_file_delete (_tmp15_, NULL, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (f);
			_g_object_unref0 (_tmp2_);
			_g_object_unref0 (file_info);
			_g_object_unref0 (enumerator);
			return;
		}
		_g_object_unref0 (f);
		_g_object_unref0 (_tmp2_);
	}
	_g_object_unref0 (file_info);
	_g_object_unref0 (enumerator);
}


/**
 * Deletes directory and its content and ignores IO errors.
 * 
 * @param dir          directory to remove
 * @param recursive    recursive removal
 * @return             true on success, false on failure
 */
gboolean diorite_system_try_purge_dir (GFile* dir, gboolean recursive) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (dir != NULL, FALSE);
	{
		GFile* _tmp0_ = NULL;
		gboolean _tmp1_ = FALSE;
		GFile* _tmp2_ = NULL;
		_tmp0_ = dir;
		_tmp1_ = recursive;
		diorite_system_purge_directory_content (_tmp0_, _tmp1_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch30_g_error;
		}
		_tmp2_ = dir;
		g_file_delete (_tmp2_, NULL, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch30_g_error;
		}
	}
	goto __finally30;
	__catch30_g_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		result = FALSE;
		_g_error_free0 (e);
		return result;
	}
	__finally30:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	result = TRUE;
	return result;
}


void diorite_system_copy_tree (GFile* source_dir, GFile* dest_dir, GCancellable* cancellable, GError** error) {
	GFile* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	GFileEnumerator* enumerator = NULL;
	GFile* _tmp3_ = NULL;
	GFileEnumerator* _tmp4_ = NULL;
	GFileInfo* file_info = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (source_dir != NULL);
	g_return_if_fail (dest_dir != NULL);
	_tmp0_ = dest_dir;
	_tmp1_ = g_file_query_exists (_tmp0_, NULL);
	if (!_tmp1_) {
		GFile* _tmp2_ = NULL;
		_tmp2_ = dest_dir;
		g_file_make_directory_with_parents (_tmp2_, NULL, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_propagate_error (error, _inner_error_);
			return;
		}
	}
	_tmp3_ = source_dir;
	_tmp4_ = g_file_enumerate_children (_tmp3_, G_FILE_ATTRIBUTE_STANDARD_NAME, 0, NULL, &_inner_error_);
	enumerator = _tmp4_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return;
	}
	while (TRUE) {
		GFileInfo* _tmp5_ = NULL;
		GFileEnumerator* _tmp6_ = NULL;
		GFileInfo* _tmp7_ = NULL;
		GFileInfo* _tmp8_ = NULL;
		GFileInfo* _tmp9_ = NULL;
		gchar* name = NULL;
		GFileInfo* _tmp10_ = NULL;
		const gchar* _tmp11_ = NULL;
		gchar* _tmp12_ = NULL;
		GFile* source_item = NULL;
		GFile* _tmp13_ = NULL;
		const gchar* _tmp14_ = NULL;
		GFile* _tmp15_ = NULL;
		GFile* dest_item = NULL;
		GFile* _tmp16_ = NULL;
		const gchar* _tmp17_ = NULL;
		GFile* _tmp18_ = NULL;
		GFile* _tmp19_ = NULL;
		GFileType _tmp20_ = 0;
		_tmp6_ = enumerator;
		_tmp7_ = g_file_enumerator_next_file (_tmp6_, NULL, &_inner_error_);
		_tmp5_ = _tmp7_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (file_info);
			_g_object_unref0 (enumerator);
			return;
		}
		_tmp8_ = _tmp5_;
		_tmp5_ = NULL;
		_g_object_unref0 (file_info);
		file_info = _tmp8_;
		_tmp9_ = file_info;
		if (!(_tmp9_ != NULL)) {
			_g_object_unref0 (_tmp5_);
			break;
		}
		_tmp10_ = file_info;
		_tmp11_ = g_file_info_get_name (_tmp10_);
		_tmp12_ = g_strdup (_tmp11_);
		name = _tmp12_;
		_tmp13_ = source_dir;
		_tmp14_ = name;
		_tmp15_ = g_file_get_child (_tmp13_, _tmp14_);
		source_item = _tmp15_;
		_tmp16_ = dest_dir;
		_tmp17_ = name;
		_tmp18_ = g_file_get_child (_tmp16_, _tmp17_);
		dest_item = _tmp18_;
		_tmp19_ = source_item;
		_tmp20_ = g_file_query_file_type (_tmp19_, 0, NULL);
		if (_tmp20_ == G_FILE_TYPE_DIRECTORY) {
			GFile* _tmp21_ = NULL;
			GFile* _tmp22_ = NULL;
			GCancellable* _tmp23_ = NULL;
			_tmp21_ = source_item;
			_tmp22_ = dest_item;
			_tmp23_ = cancellable;
			diorite_system_copy_tree (_tmp21_, _tmp22_, _tmp23_, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				g_propagate_error (error, _inner_error_);
				_g_object_unref0 (dest_item);
				_g_object_unref0 (source_item);
				_g_free0 (name);
				_g_object_unref0 (_tmp5_);
				_g_object_unref0 (file_info);
				_g_object_unref0 (enumerator);
				return;
			}
		} else {
			GFile* _tmp24_ = NULL;
			GFileType _tmp25_ = 0;
			_tmp24_ = source_item;
			_tmp25_ = g_file_query_file_type (_tmp24_, 0, NULL);
			if (_tmp25_ == G_FILE_TYPE_REGULAR) {
				GFile* _tmp26_ = NULL;
				GFile* _tmp27_ = NULL;
				GCancellable* _tmp28_ = NULL;
				_tmp26_ = source_item;
				_tmp27_ = dest_item;
				_tmp28_ = cancellable;
				g_file_copy (_tmp26_, _tmp27_, 0, _tmp28_, NULL, NULL, &_inner_error_);
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					g_propagate_error (error, _inner_error_);
					_g_object_unref0 (dest_item);
					_g_object_unref0 (source_item);
					_g_free0 (name);
					_g_object_unref0 (_tmp5_);
					_g_object_unref0 (file_info);
					_g_object_unref0 (enumerator);
					return;
				}
			} else {
				GFile* _tmp29_ = NULL;
				gchar* _tmp30_ = NULL;
				gchar* _tmp31_ = NULL;
				_tmp29_ = source_item;
				_tmp30_ = g_file_get_path (_tmp29_);
				_tmp31_ = _tmp30_;
				g_warning ("system.vala:125: Skipped: %s", _tmp31_);
				_g_free0 (_tmp31_);
			}
		}
		_g_object_unref0 (dest_item);
		_g_object_unref0 (source_item);
		_g_free0 (name);
		_g_object_unref0 (_tmp5_);
	}
	_g_object_unref0 (file_info);
	_g_object_unref0 (enumerator);
}



